REBOL [
    title: "R3 GUI - load and start"
    name: #[none]
    type: #[none]
    version: "$Id: $"
    date: 9-Dec-2010/10:32:04+1:00
    file: #[none]
    author: #[none]
    needs: #[none]
    options: #[none]
    checksum: #[none]
    Purpose: "Load all files needed by GUI (for testing)."
]
;-- JC -- this version : 28-01-2011

context [
    ext-shape: import 'shape
    ext-draw: import 'draw
    ext-text: import 'text
    lit-word: false
    any-arg?: false
    text-args: make object! [
        b: bold: [logic!]
        i: italic: [logic!]
        u: underline: [logic!]
        font: [object!]
        para: [object!]
        size: [integer!]
        shadow: [pair! | tuple! | number!]
        scroll: [pair!]
        drop: [integer!]
        anti-alias: [logic!]
        nl: newline: none
        caret: [object!]
        center: none
        left: none
        right: none
    ]
    shape-args: make object! [
        arc: [
            pair!
            | pair!
            | number!
            | 'sweep
            | 'large
        ]
        close: none
        curv: [pair! (any-arg?: true)]
        curve: [pair! (any-arg?: true)]
        hline: [number!]
        line: [pair! (any-arg?: true)]
        move: [pair!]
        qcurv: [pair!]
        qcurve: [pair! (any-arg?: true)]
        vline: [number!]
    ]
    draw-args: make object! [
        anti-alias: [logic!]
        arc: [
            pair!
            | pair!
            | number!
            | number!
            | 'closed
        ]
        arrow: [tuple! | pair!]
        box: [pair! | pair! | number!]
        curve: [pair! (any-arg?: true)]
        circle: [pair! | number! | number!]
        clip: [pair! | pair! | logic!]
        ellipse: [pair! | pair!]
        fill-pen: [tuple! | image! | logic!]
        fill-rule: ['even-odd | 'non-zero]
        gamma: [number!]
        grad-pen: [
            'conic
            | 'cubic
            | 'diagonal
            | 'diamond
            | 'linear
            | 'radial
            | 'normal
            | 'repeat
            | 'reflect
            | pair!
            | pair!
            | number!
            | number!
            | number!
            | logic!
            | block!
        ]
        invert-matrix: none
        image: [
            image! |
            pair! (any-arg?: true)
        ]
        image-filter: [
            'nearest
            | 'bilinear
            | 'bicubic
            | 'gaussian
            | 'resize
            | 'resample
            | number!
        ]
        image-options: [
            tuple! | 'border | 'no-border
        ]
        image-pattern: [
            'normal | 'repeat | 'reflect | pair! | pair!
        ]
        line: [pair! (any-arg?: true)]
        line-cap: ['butt | 'square | 'rounded]
        line-join: ['miter | 'miter-bevel | 'round | 'bevel]
        line-pattern: [logic! | tuple! | number! (any-arg?: true)]
        line-width: [number! | 'fixed]
        matrix: [block!]
        pen: [tuple! | image! | logic!]
        polygon: [pair! (any-arg?: true)]
        push: [block!]
        reset-matrix: none
        rotate: [number!]
        scale: [pair!]
        shape: [block!]
        skew: [pair!]
        spline: [integer! | 'closed | pair! (any-arg?: true)]
        text: ['aliased | 'antialiased | 'vectorial | pair! | pair! | block!]
        transform: [number! | number! | number! | pair! | pair!]
        translate: [pair!]
        triangle: [pair! | pair! | pair! | tuple! | tuple! | tuple! | number!]
    ]
    text-words: words-of text-args
    shape-words: append words-of shape-args [
        sweep
        large
    ]
    draw-words: append words-of draw-args [
        even-odd
        non-zero
        conic
        cubic
        diagonal
        diamond
        linear
        radial
        normal
        repeat
        reflect
        butt
        square
        rounded
        miter
        miter-bevel
        round
        bevel
        fixed
        closed
        no-border
        border
        nearest
        bilinear
        bicubic
        gaussian
        resize
        resample
        aliased
        antialiased
        vectorial
    ]
    text-command: [
        string!
        | tuple!
        | char!
        | 'anti-alias
        | 'b
        | 'bold
        | 'caret
        | 'center
        | 'drop
        | 'font
        | 'i
        | 'italic
        | 'left
        | 'nl
        | 'newline
        | 'para
        | 'right
        | 'scroll
        | 'shadow
        | 'size
        | 'u
        | 'underline
    ]
    shape-command: [(lit-word: false)
        'arc
        | 'close
        | 'curv
        | 'curve
        | 'hline
        | 'line
        | 'move
        | 'qcurv
        | 'qcurve
        | 'vline
        | lit-word! (lit-word: true)
    ]
    draw-command: [
        'anti-alias
        | 'arc
        | 'arrow
        | 'box
        | 'circle
        | 'clip
        | 'curve
        | 'ellipse
        | 'fill-pen
        | 'fill-rule
        | 'gamma
        | 'grad-pen
        | 'invert-matrix
        | 'image
        | 'image-filter
        | 'image-options
        | 'image-pattern
        | 'line
        | 'line-cap
        | 'line-join
        | 'line-pattern
        | 'line-width
        | 'matrix
        | 'pen
        | 'polygon
        | 'push
        | 'reset-matrix
        | 'rotate
        | 'scale
        | 'shape
        | 'skew
        | 'spline
        | 'text
        | 'transform
        | 'translate
        | 'triangle
    ]
    text-types: make object! [
        logic!: []
        tuple!: []
        integer!: []
        object!: []
        pair!: []
    ]
    shape-types: make object! [
        pair!: []
        integer!: []
        decimal!: []
        word!: []
    ]
    draw-types: make object! [
        logic!: []
        pair!: []
        integer!: []
        decimal!: []
        tuple!: []
        word!: []
        block!: []
        image!: []
    ]
    set 'to-text func [
        src [block!]
        dst [block!]
        /local
        cmd args a text-arg t
    ] [
        parse reduce/only src text-words [
            some [
                set cmd text-command (
                    args: make text-types []
                    text-arg: either word? cmd [
                        all [
                            text-args/(cmd)
                            copy text-args/(cmd)
                        ]
                    ] [
                        none
                    ]
                )
                any [
                    set a text-arg (
                        all [
                            not none? a
                            append select args t: type?/word a a
                            remove/part find text-arg t 2
                        ]
                    )
                ] (
                    append dst reduce switch/default type?/word cmd [
                        string! [['text cmd]]
                        tuple! [['color cmd]]
                        string! [['text to string! cmd]]
                    ] [
                        append dst reduce switch/default cmd [
                            anti-alias [['anti-alias either args/logic!/1 = none [true] [args/logic!/1]]]
                            b bold [['bold either args/logic!/1 = none [true] [args/logic!/1]]]
                            caret [['caret args/object!/1]]
                            center [['center]]
                            drop [['drop args/integer!/1]]
                            font [['font args/object!/1]]
                            i italic [['italic either args/logic!/1 = none [true] [args/logic!/1]]]
                            left [['left]]
                            nl newline [['text to string! newline]]
                            para [['para args/object!/1]]
                            right [['right]]
                            scroll [['scroll args/pair!/1]]
                            shadow [['shadow args/pair!/1 args/tuple!/1 args/integer!/1]]
                            size [['size args/integer!/1]]
                            u underline [['underline either args/logic!/1 = none [true] [args/logic!/1]]]
                        ] [[]] []
                    ]
                )
                | end
                | a: (
                    do make error! reform ["TO-TEXT - syntax error at:" copy/part mold/only at src index? a 50 "..."]
                )
            ]
        ]
        bind/only dst ext-text
    ]
    to-shape: func [
        src [block!]
        dst [block!]
        /local
        cmd args a shape-arg t
    ] [
        parse reduce/only src shape-words [
            some [
                set cmd shape-command (
                    args: make shape-types []
                    shape-arg: either word? cmd [
                        all [
                            shape-args/(cmd)
                            copy shape-args/(cmd)
                        ]
                    ] [
                        none
                    ]
                )
                any [(any-arg?: false) set a shape-arg (
                        all [
                            not none? a
                            append select args t: type?/word a a
                            unless any-arg? [
                                remove/part find shape-arg t 2
                            ]
                        ]
                    )] (
                    append dst reduce switch/default cmd [
                        arc [[
                                either lit-word ['arc'] ['arc]
                                args/pair!/1
                                args/pair!/2
                                any [args/integer!/1 args/decimal!/1]
                                any [all [args/word!/1 = 'sweep 'positive] 'negative]
                                any [args/word!/2 all [args/word!/1 = 'large 'large] 'small]
                            ]]
                        close [['close]]
                        curv [[either lit-word ['curv'] ['curv] args/pair!]]
                        curve [[either lit-word ['curve'] ['curve] args/pair!]]
                        hline [[either lit-word ['hline'] ['hline] any [args/integer!/1 args/decimal!/1]]]
                        line [[either lit-word ['line'] ['line] any [all [args/pair!/2 args/pair!] args/pair!/1]]]
                        move [[either lit-word ['move'] ['move] args/pair!/1]]
                        qcurve [[either lit-word ['qcurve'] ['qcurve] args/pair!]]
                        qcurv [[either lit-word ['qcurv'] ['qcurv] args/pair!/1]]
                        vline [[either lit-word ['vline'] ['vline] any [args/integer!/1 args/decimal!/1]]]
                    ] [[]]
                )
                | end
                | a: (
                    do make error! reform ["TO-SHAPE - syntax error at:" copy/part mold/only at src index? a 50 "..."]
                )
            ]
        ]
        bind/only dst ext-shape
    ]
    set 'to-draw func [
        src [block!]
        dst [block!]
        /local
        cmd args a t draw-arg
    ] [
        parse reduce/only src draw-words [
            some [
                set cmd draw-command (
                    args: make draw-types []
                    draw-arg: either word? cmd [
                        all [
                            draw-args/(cmd)
                            copy draw-args/(cmd)
                        ]
                    ] [
                        none
                    ]
                    all [draw-arg append draw-arg [| none! (any-arg?: true)]]
                )
                any [(any-arg?: false) set a draw-arg (
                        all [
                            not none? a
                            append select args t: type?/word a a
                            unless any-arg? [
                                remove/part find draw-arg t 2
                            ]
                        ]
                    )] (
                    append dst reduce switch/default cmd [
                        anti-alias [['anti-alias args/logic!/1]]
                        arc [[
                                'arc
                                args/pair!/1
                                args/pair!/2
                                any [args/integer!/1 args/decimal!/1]
                                any [args/integer!/2 args/decimal!/2]
                                any [args/word!/1 'opened]
                            ]]
                        arrow [['arrow args/pair!/1 args/tuple!/1]]
                        box [['box args/pair!/1 any [args/pair!/2 100x100] any [args/integer!/1 args/decimal!/1 0]]]
                        circle [[
                                'circle
                                any [args/pair!/1 50x50]
                                as-pair a: any [args/integer!/1 args/decimal!/1 50] any [args/integer!/2 args/decimal!/2 a]
                            ]]
                        clip [
                            either args/logic!/1 = false [['clip 0x0 10000x10000]] [['clip args/pair!/1 args/pair!/2]]
                        ]
                        curve [['curve args/pair!/1 args/pair!/2 args/pair!/3 args/pair!/4]]
                        ellipse [['ellipse args/pair!/1 args/pair!/2]]
                        fill-pen [['fill-pen either a: any [args/tuple!/1 args/image!/1 args/logic!/1] [a] [false]]]
                        fill-rule [['fill-rule args/word!/1]]
                        gamma [['gamma any [args/integer!/1 args/decimal!/1]]]
                        grad-pen [[
                                'grad-pen
                                any [args/word!/1 'linear]
                                any [args/word!/2 'normal]
                                any [args/pair!/1 0x0]
                                as-pair any [args/integer!/1 args/decimal!/1 0] any [args/integer!/2 args/decimal!/2 100]
                                any [args/integer!/3 args/decimal!/3 0]
                                any [args/pair!/3 1x1]
                                args/block!
                            ]]
                        image [['image args/image!/1 any [all [args/pair!/2 args/pair!] any [args/pair!/1 0x0]]]]
                        image-filter [[
                                'image-filter
                                any [args/word!/1 'nearest]
                                any [args/word!/2 'resize]
                                any [args/integer!/1 args/decimal!/1]
                            ]]
                        image-options [['image-options args/tuple!/1 any [args/word!/1 'no-border]]]
                        image-pattern [[
                                'image-pattern any [args/word!/1 'normal] any [args/pair!/1 0x0] any [args/pair!/2 0x0]
                            ]]
                        line [['line args/pair!]]
                        line-cap [['line-cap args/word!/1]]
                        line-join [['line-join args/word!/1]]
                        line-pattern [['line-pattern args/tuple!/1 args/block!/1]]
                        line-width [['line-width any [args/integer!/1 args/decimal!/1 1] any [args/word!/1 'variable]]]
                        invert-matrix [['invert-matrix]]
                        matrix [['matrix args/block!/1]]
                        pen [['pen either a: any [args/tuple!/1 args/image!/1 args/logic!/1] [a] [false]]]
                        polygon [['polygon args/pair!]]
                        push [['push to-draw args/block! copy []]]
                        reset-matrix [['reset-matrix]]
                        rotate [['rotate any [args/integer!/1 args/decimal!/1]]]
                        scale [['scale args/pair!/1]]
                        shape [['shape to-shape args/block! copy []]]
                        skew [['skew args/pair!/1]]
                        spline [['spline args/pair! any [args/integer!/1 0] any [args/word!/1 'opened]]]
                        text [[
                                'text
                                any [args/pair!/1 0x0]
                                any [args/pair!/2 0x0]
                                any [args/word!/1 'raster]
                                to-text args/block! copy []
                            ]]
                        transform [[
                                'transform
                                any [args/integer!/1 args/decimal!/1 0]
                                any [args/pair!/1 0x0]
                                any [as-pair a: any [args/integer!/2 args/decimal!/2 1] any [args/integer!/3 args/decimal!/3 a]]
                                any [args/pair!/2 0x0]
                            ]]
                        translate [['translate args/pair!/1]]
                        triangle [[
                                'triangle
                                args/pair!/1
                                any [args/pair!/2 100x100]
                                any [args/pair!/3 as-pair args/pair!/1/x any [args/pair!/2/y 100]]
                                args/tuple!/1
                                args/tuple!/2
                                args/tuple!/3
                                any [args/integer!/1 args/decimal!/1 0]
                            ]]
                    ] [[]]
                )
                | end
                | a: (
                    do make error! reform ["TO-DRAW - syntax error at:" copy/part mold/only at src index? a 50 "..."]
                )
            ]
        ]
        bind/only dst ext-draw
    ]
]
sum-pair: func [pair] [pair/x + pair/y]
merge-values: funct [
    {Merge a source object's defined values into a target object.}
    obj [object!] "Target"
    src [object!] "Source"
    /force {Even if destination has a value, set it from source.}
] [
    foreach word words-of obj [
        if all [
            val: select src word
            any [force none? select obj word]
        ] [
            obj/:word: src/:word
        ]
    ]
]
debug-gui: func [
    "GUI debugging function. Allows selective enabling."
    tag [word!] "Debug category"
    args [block! string!] "Values to print."
] [
    if any [find guie/debug tag find guie/debug 'all] [
        args: reduce args
        if object? args/1 [args/1: args/1/style]
        print ['-- tag args]
    ]
    true
]
fail-gui: func [msg] [
    print ["^/** GUI ERROR:" reform msg]
    halt
]
warn-gui: func [msg] [
    print ["^/** GUI WARNING:" reform msg]
    none
]
assert-gui: func [cond msg] [
    unless cond [fail-gui msg]
]
remind-gui: func [body /when cond] [
    if all [
        guie/remind
        any [not when cond]
    ] [
        print ["-- remind:" reform body]
    ]
]
debug-face: func [
    face
    word
    block
    /local flags style
] [
    if all [
        any [
            flags: select face 'debug
            all [
                style: select guie/styles face/style
                flags: select style 'debug
            ]
        ]
        any [
            not block? flags
            find flags word
        ]
    ] [
        print ajoin ["-- debug-face[" face/style ":" word "]: " remold block]
    ]
]
dump-face: func [face /indent d] [
    print [
        any [d ""]
        to-set-word face/style
        face/gob/offset
        "size:" face/gob/size
        any [select face 'name "*"]
        mold any [select face/facets 'text-body "*"]
    ]
]
dump-panel: func [panel /indent d] [
    unless d [d: copy ""]
    dump-face/indent panel d
    insert d "  "
    foreach f select panel 'faces [
        either find [panel group] f/style [
            dump-panel/indent f d
        ] [
            dump-face/indent f d
        ]
    ]
    remove/part d 2
]
guie: context [
    debug: []
    remind: off
    styles: make map! 30
    fonts: make map! 20
    dialect: make object! 50
    actions: make object! 20
    shows: make block! 20
    drawing: make block! 40
    focal-face:
    popup-face:
    popup-parent:
    drag:
    style:
    font:
    face:
    face-state:
    char-space:
    char-valid:
    none
    handler: none
]
guie/style: object [
    name:
    facets:
    draw:
    actors:
    tags:
    options:
    parent:
    state:
    intern:
    content:
    none
    about: "Not documented."
]
guie/face: object [
    style:
    facets:
    state:
    gob:
    options:
    tags:
    draw-result:
]
guie/face-state: object [
    mode: 'up
    over: no
    value: none
]
guie/style/facets: object [
    init-size: 100x100
    min-size: 0x0
    max-size: 2.1474836e9x2.1474836e9
    align: 'left
    valign: 'top
    resizes?: true
    border-color: black
    border-size: [0x0 0x0]
    bg-color: none
    margin: [0x0 0x0]
    padding: [0x0 0x0]
    spacing: none
    gob: none
    gob-size: 0x0
    space: [0x0 0x0]
    margin-box: reduce/no-set [
        top-left: 0x0
        top-right: 0x0
        bottom-left: 0x0
        bottom-right: 0x0
        center: 0x0
    ]
    border-box: copy margin-box
    padding-box: copy margin-box
    viewport-box: copy margin-box
]
guie/drag: context [
    face:
    active:
    event:
    start:
    delta:
    base:
    base-offset:
    gob:
    origin:
    none
    show-parent?: true
    none
]
append guie/dialect [
    default: [set-word!]
    options: [block!]
    debug: [block!]
    return: []
]
system-cursors: context [
    app-start: 32650
    hand: 32649
    help: 32651
    hourglass: 32650
    arrow: 32512
    cross: 32515
    i-shape: 32513
    no: 32648
    size-all: 32646
    size-nesw: 32643
    size-ns: 32645
    size-nwse: 32642
    size-we: 32644
    up-arrow: 32516
    wait: 32514
]
stylize: func [
    {Create one or more styles (with simple style dialect).}
    list [block!] "Format: name: [def], name: parent [def]"
    /local name parent spec style spot
] [
    assert-gui parse list [
        some [
            spot:
            set name set-word!
            set parent opt word!
            set spec block! (make-style to-word name parent spec)
        ]
    ] ["Invalid style syntax:" spot]
    debug-gui 'dialect [name]
]
make-style: funct [
    "GUI API function for creating a style."
    name [word!]
    parent [word! none!]
    spec [block! none!]
] [
    debug-gui 'make-style [name]
    parname: parent
    parent: either parent [guie/styles/:parent] [guie/style]
    assert-gui parent ["Unknown parent style for:" name]
    style: copy parent
    style/name: name
    if name <> parname [style/parent: parname]
    foreach [field code] [
        tags [if val [make-tags val]]
        facets [if val [make parent/facets val]]
        options [append-dialect name parent/name val]
        actors [if val [make-actors parent val]]
        intern [if val [make object! val]]
        draw [val]
        state [val]
        content [val]
        about [val]
        debug [extend style 'debug val val]
    ] [
        val: select spec to-set-word field
        unless any [none? :val block? :val string? :val] [
            print ["Invalid style field:" field "with" mold :val]
        ]
        if result: do code [style/:field: result]
    ]
    if find select style 'debug 'style [
        print ajoin ["-- debug-style [" name "]: " mold style]
    ]
    repend guie/styles [name style]
]
append-dialect: func [
    style-name [word!]
    parent [word! none!]
    block
    /local name types init options type-list
] [
    options: clear []
    type-list: clear []
    either block? :block [
        parse block [
            some [
                set name set-word!
                set types block!
                opt string!
                set init opt block! (
                    repend options [name init]
                    append type-list to-typeset types
                )
            ]
        ]
        type-list: copy type-list
    ] [
        type-list: select guie/dialect parent
        all [
            parent
            name: select guie/styles parent
            options: name/options
        ]
    ]
    extend guie/dialect style-name any [type-list copy []]
    either block? options [context options] [copy options]
]
style-tags: [
    internal
    panel
    compound
    field
    state
    action
    info
    tab
    auto-tab
    select
    keep
]
face-tags: [
    default
    focus
    disabled
    frozen
    dirty
]
window-tags: [
    form
    inform
    popup
]
tags: make map! []
foreach tag style-tags [repend tags [tag true]]
foreach tag face-tags [repend tags [tag true]]
foreach tag window-tags [repend tags [tag true]]
tag-error: funct [
    "Generate error on tag problem"
    words [word! block!]
    error [word!]
] [
    or-tag: func [w] [replace/all reform w " " " or "]
    fail-gui select [
        unknown ["Unknown tag:" words]
        coexist [words/1 "cannot coexist with " or-tag next words]
        requires [words/1 "requires" or-tag next words]
    ] error
]
tag-face?: funct [
    "Queries whether a tag exists for a face"
    face
    tag
    /deep
] [
    any [not word? tag tags/:tag tag-error tag 'unknown]
    either deep [
        if deep [traverse-face [tag-face? face tag]]
    ] [
        either all [block? tag not empty? tag] [
            foreach t tag [if tag-face? face t [return true]]
        ] [
            all [face face/tags/:tag]
        ]
    ]
]
tag-face: funct [
    "Applies a tag to a face"
    face
    tag
    /deep
] [
    any [tags/:tag tag-error tag 'unknown]
    unless apply :tag-face? [face tag deep] [face/tags/:tag: true]
    face
]
untag-face: funct [
    "Removes a tag from a face"
    face
    tag
    /deep
] [
    any [tags/:tag tag-error tag 'unknown]
    face/tags/:tag: none
    if deep [traverse-face [face/tags/:tag: none]]
    face
]
make-tags: funct [
    tags
] [
    map: make map! 4
    foreach tag tags [repend map [tag true]]
    map
]
tagged-faces: funct [
    "Return all faces with a tag"
    face [object!] "Face to search for faces"
    tag [word!] "Tag to search for"
] [
    faces: copy []
    traverse-face face [if tag-face? face tag [append faces face]]
    unique faces
]
guie/style/tags: make-tags []
do-style: funct [
    "Call a style actor function."
    faces [block! object!] "Face or block of faces"
    act [word!] "Actor identifier"
    data {Argument to the actor (use block for multiple args).}
    /style "Do actor from other style"
    style-name [word!] "Style for actor"
    /bubble {Allow event to bubble up if specified actor not found}
] [
    out: copy []
    blockified?: unless block? faces [faces: append copy [] faces]
    foreach face faces [
        result: none
        actor: none
        all [
            style: select guie/styles any [style-name face/style]
            actors: style/actors
            debug-gui 'do-style [act face/style select face/facets 'name]
            any [
                actor: select actors act
                result: false
            ]
            set/any 'result actor face :data
        ]
        if unset? :result [result: none]
        all [
            bubble
            none? :actor
            face/gob/parent
            face/gob/parent/data
            result: apply :do-style [face/gob/parent/data act data any [style-name] style-name bubble]
        ]
        all [
            face/gob/parent
            face/gob/parent/data
            do-triggers/face/arg/only face/gob/parent/data act face data 'do-reactors
        ]
        append/only out :result
    ]
    either blockified? [:out/1] [out]
]
has-actor?: funct [
    "Return true if face's style has this actor."
    face [object!]
    act [word!] "Actor identifier"
] [
    true? select select select guie/styles face/style 'actors act
]
do-related: funct [
    {Find related faces and call their specified actor id.}
    face
    related [word! block!]
] [
    if word? related [
        if parent: parent-face? face [
            foreach fac faces? parent [do-style fac related face]
        ]
    ]
]
find-face-actor: funct [
    {Find the next (or prior) face that responds to the given actor.}
    face [object!]
    act [word!]
    /reverse
] [
    dir: pick [-1 1] true? reverse
    if all [
        parent: parent-face? face
        faces: find faces? parent face
    ] [
        faces: skip faces dir
        forskip faces dir [
            if has-actor? first faces act [return first faces]
        ]
    ]
]
do-bind-actor: funct [face actor-block] [
    all [
        pf: parent-face? face
        in pf 'names
        actor-block: bind/copy actor-block pf/names
    ]
    all [
        in face 'names
        actor-block: bind/copy actor-block face/names
    ]
    do actor-block
]
make-actors: funct [
    parent
    actors
] [
    map: either parent [copy parent/actors] [make map! 4]
    unless parse actors [
        any [
            here:
            set-word! block! (
                repend map [here/1 funct [face arg] reduce ['do-bind-actor 'face here/2]]
                repend guie/dialect [here/1 reduce [make typeset! [block!]]]
            )
        ]
    ] [
        fail-gui ["Bad style actor:" here]
    ]
    map
]
guie/style/actors: make-actors none [
    locate: [
        arg/offset
    ]
    on-resize: [
        if any [face/facets/resizes? face/gob/size <> 0x-1] [
            if all [
                in face/facets 'intern
                in face/facets/intern 'update?
                face/facets/intern/update?
            ] [do-style face 'on-update none]
            set-draw-keywords-in face/facets arg
        ]
        unless face/gob/size = 0x-1 [face/gob/size: face/facets/gob-size]
    ]
    on-get: [
        select face/state arg
    ]
    on-key: [arg]
    on-scroll-event: [arg]
    on-focus: [
        either arg [] []
    ]
]
materials: make object! [
    base: make object! [
        up: down: over: make object! [
            specular: 'high
            intensity: 1
            diffusion: [1 1]
            opacity: 1
            texture: none
        ]
    ]
    shadow: make base [
        up: over: make up [
            diffusion: 0.0.0.200
        ]
        down: make up [
            diffusion: 255.255.255.100
        ]
    ]
    chrome: make base [
        up: make up [
            diffusion: [1.0 0% 0.78000000000000003 48.999999999999999% 0.76000000000000001 50% 0.69999999999999996 51.000000000000001% 0.76000000000000001 96.999999999999997% 1.0 100%]
        ]
        down: make up [
            intensity: 0.90000000000000002
        ]
        over: make up [
            intensity: 1.05
        ]
    ]
    chrome-groove: make base [
        up: over: down: make up [
            diffusion: [0.69999999999999996 0% 0.40000000000000002 5.0000000000000003% 0.5 20.000000000000001% 0.69999999999999996 48.999999999999999% 0.71999999999999997 50% 0.69999999999999996 75%]
        ]
    ]
    scroller: make base [
        up: make up [
            diffusion: [0.69999999999999996 0% 0.40000000000000002 5.0000000000000003% 0.65000000000000002 20.000000000000001% 0.75 48.999999999999999% 0.71999999999999997 50% 0.69999999999999996 55.000000000000004% 0.5 80.000000000000004%]
        ]
        over: make up []
        down: make up [
            diffusion: [0.59999999999999998 0% 0.80000000000000004 65.000000000000002% 0.69999999999999996 100%]
        ]
    ]
    piano: make chrome [
        up: make up [
            diffusion: [0.81999999999999995 0% 0.71999999999999997 48.999999999999999% 0.69999999999999996 50% 0.59999999999999998 51.000000000000001% 0.76000000000000001 96.999999999999997% 1.0 100%]
        ]
        down: make up [
            intensity: 0.90000000000000002
        ]
        over: make up [
            intensity: 1.05
        ]
    ]
    aluminum: make base [
        up: make up [
            diffusion: [1.0 0% 0.73999999999999999 7.0000000000000007% 0.69999999999999996 70.000000000000007% 0.70999999999999996 96.999999999999997% 1.0 100%]
        ]
        down: make up [
            diffusion: [0.67000000000000004 0% 0.78000000000000003 7.0000000000000007% 0.70999999999999996 70.000000000000007% 0.71999999999999997 96.999999999999997% 1.0 100%]
        ]
        over: make up [
            intensity: 1.03
        ]
    ]
    container-groove: make base [
        up: down: over: make up [
            diffusion: [0.0.0.200 0% 0.0.0.255 50% 255.255.255.255 50% 255.255.255.220 100%]
        ]
    ]
    field-groove: make base [
        up: down: over: make up [
            specular: 'linear
            diffusion: [0 0% 0.5 10.000000000000001% 0.98999999999999999 40.000000000000002% 1 100%]
        ]
    ]
    dark-groove: make base [
        up: down: over: make up [
            diffusion: [0.0.0.96 0% 0.0.0.128 50% 0.0.0.140 59.999999999999998% 0.0.0.160 90.000000000000002%]
        ]
    ]
    radial-aluminum: make aluminum [
        up: make up [
            intensity: 1.1000000000000001
            diffusion: [0.80000000000000004 0% 0.78000000000000003 10.000000000000001% 0.71999999999999997 70.000000000000007% 0.69999999999999996 95.000000000000007% 0.80000000000000004 100%]
        ]
        down: make up [
            intensity: 1
            diffusion: [0.65000000000000002 0% 0.69999999999999996 70.000000000000007% 0.75 95.000000000000007% 0.84999999999999998 100%]
        ]
        over: make up [
            intensity: 1.03
        ]
    ]
    led: make base [
        on: make up [
            diffusion: [1.0 0% 0.68000000000000005 5.0000000000000003% 0.68000000000000005 48.999999999999999% 0.75 50% 0.90000000000000002 95.000000000000007% 1.0 100%]
        ]
        off: make on [
            diffusion: [1.0 0% 0.0 5.0000000000000003% 0.0 48.999999999999999% 0.080000000000000002 50% 0.25 95.000000000000007% 1.0 100%]
        ]
    ]
    plastic: make base [
        up: down: make up [
            specular: 'linear
            diffusion: [0.84999999999999998 0.59999999999999998]
        ]
        over: make up [
            intensity: 1.2
        ]
    ]
    paper: make base [
        up: make up [
            specular: 'mul
            diffusion: [0.75 0.75]
        ]
        down: make up [
            intensity: 0.90000000000000002
        ]
        over: make up [
            intensity: 1.1000000000000001
        ]
    ]
    groove: make base [
        up: down: over: make up [
            specular: 'mul
            diffusion: [0.10000000000000001 0% 0.5 5.0000000000000003% 0.65000000000000002 50% 0.90000000000000002 100%]
        ]
    ]
    fluorescent: make base [
        up: down: over: make up [
            specular: 'linear
            diffusion: [0.80000000000000004 0% 1 100%]
            opacity: 0.69999999999999996
        ]
    ]
    candy-stripe: make base [
        up: down: over: make up [
            diffusion: [255.255.255.255 255.255.255.255 255.255.255.240 255.255.255.240]
        ]
    ]
]
'materialize [
    base: [
        color: white
        specular: 'high
        diffusion: []
        opacity: 1
        texture: none
    ]
    chrome: base [
        diffusion: [1.0 0% 0.78000000000000003 48.999999999999999% 0.76000000000000001 50% 0.69999999999999996 51.000000000000001% 0.76000000000000001 96.999999999999997% 1.0 100%]
    ]
    aluminum: base [
        diffusion: [
            up: [1.0 0% 0.73999999999999999 7.0000000000000007% 0.69999999999999996 70.000000000000007% 0.70999999999999996 96.999999999999997% 1.0 100%]
            down: []
            over: []
        ]
    ]
    plastic: base [
        specular: 'linear
        diffusion: [0.76000000000000001 0.72999999999999998]
    ]
    fluorescent: base [
        specular: 'linear
        diffusion: [0.59999999999999998 0.90000000000000002 0.59999999999999998]
        opacity: 0.69999999999999996
    ]
    paper: base [
        specular: 'avg
        diffusion: [0.75 0.75]
    ]
    carpet: [
        specular: 'linear
        diffusion: [1.0 1.0]
        texture: random-noise-image
    ]
]
make-face: funct [
    {Returns a new face based on the style with various attributes.}
    style [word!] "Name of style"
    opts [block! map! none!] "Optional variations of style"
    /not-on-make "don't call on-make actor"
] [
    styl: guie/styles/:style
    face: make guie/face [
        facets: make styl/facets opts
        options: make object! any [opts []]
        tags: copy styl/tags
        state: make guie/face-state select styl 'state
        intern: styl/intern
    ]
    if select styl 'debug [
        append face reduce/no-set [debug: styl/debug]
    ]
    face/style: style
    face/gob: make gob! reduce/no-set [data: face]
    face/facets/gob: face/gob
    unless not-on-make [
        do-style face 'on-make none
    ]
    face
]
make-options: funct [
    style [word!]
    values [block!]
] [
    assert-gui styl: guie/styles/:style ["Unknown style:" style]
    options: clear []
    foreach word words-of styl/options [
        if first values [repend options [to-set-word word first values]]
        values: next values
    ]
    options
]
update-face: funct [
    face [object!]
    /no-show
    /contents
] [
    container: either contents [face] [
        all [container: face/gob/parent container/data]
    ]
    until [
        not all [
            container
            face: container
            not face/facets/intern/update?
            face/facets/intern/update?: true
            face/facets/auto-size?
            face/facets/resizes?
            container: face/gob/parent
            container: container/data
        ]
    ]
    unless no-show [
        until [
            not all [
                container: face/gob/parent
                container: container/data
                container/facets/intern/update?
                face: container
            ]
        ]
        do-style face 'on-resize face/facets/gob-size
        draw-face face
    ]
]
extend-face: func [
    face [object!]
    field [word!]
    value
    /only
] [
    apply :append [
        any [
            select face field
            extend face field make block! 1
        ]
        value
        none
        none
        only
    ]
]
show-face: funct [
    {Set the visibility attributes of a face/block of faces.}
    face [object! block!] "a face or a block of faces"
    show? [word!] "the SHOW? attribute value"
    /no-show
] [
    visible?: any [show? = 'visible show? = 'fixed]
    resizes?: any [show? = 'visible show? = 'hidden]
    either object? face do-show: [
        if all [
            face/gob/size <> 0x-1
            not visible?
        ] [
            if guie/focal-face = face [unfocus]
            face/facets/gob-size: face/gob/size
            face/gob/size: 0x-1
        ]
        if all [
            face/gob/size = 0x-1
            visible?
        ] [
            face/gob/size: face/facets/gob-size
        ]
        apply either resizes? <> face/facets/resizes? [
            face/facets/resizes?: resizes?
            :update-face
        ] [
            :draw-face
        ] [face no-show]
    ] [
        foreach face face do-show
    ]
]
focus: func [
    face [object!]
] [
    if guie/focal-face <> face [unfocus]
    do-style face 'on-focus true
    guie/focal-face: face
]
unfocus: does [
    if guie/focal-face [
        do-style guie/focal-face 'on-focus false
        guie/focal-face: none
    ]
]
next-focus: funct [face] [
    focus find-face-actor face 'on-focus
]
tall-face?: funct [
    {Returns TRUE if the face is taller than it is wide.}
    face
] [
    equal? face-axis? face 'y
]
face-axis?: funct [
    "Returns face major axis as 'x or 'y."
    face
] [
    axis: get-facet face 'axis
    if none? axis [
        size: face/facets/viewport-box/bottom-right
        axis: either size [pick [x y] size/x < size/y] [none]
    ]
    axis
]
find-title-text: func [
    "Finds the title text of a panel."
    panel [object!]
] [
    foreach face faces? panel [
        if face/style = 'title [
            return get-facet face 'text-body
        ]
    ]
    none
]
face-text-size: funct [
    {Return position in text and height of visible area in precent!. Useful for scroller.}
    face [object!]
] [
    if zero? height: second size-text gob: sub-gob? face [height: 1]
    size: min 100% to percent! gob/size/y / height
    t: max 0% negate gob/size/y - height - 5
    start: either zero? t [0%] [limit to percent! negate gob/text/scroll/y / t 0% 100%]
    reduce [start size]
]
init-drag: func [
    {Initialize drag operation, reusing a common drag object.}
    face
    spot "Initial condition (initial value, offset, etc)."
    /only {Drag only inside face, do not use face for drag'n'drop}
] [
    guie/drag/face: face
    guie/drag/base: any [spot face/gob/offset]
    guie/drag/base-offset: face/gob/offset
    guie/drag/gob: either only [none] [face/gob]
    guie/drag/delta: 0x0
    guie/drag/origin: find face/gob/parent face/gob
    guie/drag/show-parent?: true
    draw-face face
    guie/drag
]
get-gob-offset: funct [
    gob
] [
    offset: gob/offset
    either all [gob/parent gob/parent/parent gob/parent/parent/parent] [
        offset + get-gob-offset gob/parent
    ] [
        offset
    ]
]
sub-gob?: func [
    "Return face's internal area gob."
    face [object!]
] [
    face/gob/1
]
parent-face?: func [
    "Return face's parent or none for top face."
    face [object!]
] [
    all [
        face/gob/parent
        face/gob/parent/data
    ]
]
window-face?: funct [
    "Return window face where face belongs."
    face [object!]
] [
    all [
        gob: map-gob-offset/reverse face/gob 1x1
        gob: first gob
        gob/data
    ]
]
root-face?: funct [
    "Returns whether the face is a root face"
    face [object!]
] [
    face/style = 'window
]
tip-face?: funct [
    {Travels inward through all last faces in starting at the given face and returns the innermost one.}
    face
] [
    if empty? faces: faces? face [return face]
    last-face: last faces
    tip-face: none
    until [
        faces: faces? last-face
        either empty? faces [
            tip-face: :last-face
        ] [
            last-face: last :faces
        ]
        tip-face
    ]
]
return-face?: funct [
    {Returns the next possible face outward and then forward in the hierarchy}
    face
] [
    unless face/gob/parent [return face]
    return-face: none
    fp: parent-face? face
    until [
        either root-face? fp [
            return-face: fp
        ] [
            faces: locate-face fp
            either all [faces single? faces] [
                fp: parent-face? fp
            ] [
                return-face: faces/2
            ]
        ]
        return-face
    ]
]
locate-face: funct [
    {Locate the index for the given face in the parent face block}
    face
    /reverse "Find backwards"
] [
    fp: parent-face? face
    fpp: if fp [faces? fp]
    if block? fpp [find fpp face]
]
back-face?: funct [
    "Returns the face before this one."
    face [gob! object!]
] [
    if gob? face [face: face/data]
    if root-face? face [return tip-face? face]
    faces: locate-face face
    if head? faces [return parent-face? face]
    tip-face? first back faces
]
next-face?: funct [
    "Returns the face after this one."
    face
] [
    if gob? face [face: face/data]
    if any [root-face? face not empty? f: faces? face] [return first any [f faces? face]]
    faces: locate-face face
    any [
        faces/2
        return-face? face
    ]
]
find-face?: funct [
    {Deeply find the next face from specs relative to the given face.}
    face [gob! object!]
    spec
    /reverse "Find backwards"
] [
    fc: either gob? face [face/data] [face]
    until [
        face: either reverse [back-face? face] [next-face? face]
        any [
            face = fc
            do bind spec 'face
        ]
    ]
    if face <> fc [face]
]
traverse-face: funct [
    {Traverses a face deeply and performs a function on each subface.}
    face [gob! object!]
    action
    /only these-faces
] [
    if gob? face [face: face/data]
    if empty? faces? face [return face]
    last-face: tip-face? face
    func-act: func [face] action
    these-act: all [only func [face] these-faces]
    until [
        face: next-face? face
        all [
            any [not only these-act face]
            func-act face
        ]
        same? last-face face
    ]
]
within-face?: funct [
    "Returns whether a face exists within another face."
    child [gob! object!]
    parent [gob! object!]
] [
    if gob? child [child: child/data]
    result: false
    traverse-face parent [result: any [result face = child]]
    to-logic result
]
find-tab-face?: funct [
    {Return the next tab face in the window face for the given tab face}
    tab-face
    /reverse
] [
    apply :find-face? [tab-face [tag-face? face 'tab] reverse]
]
compound-face?: funct [
    {Return the compound face for an existing face, or the face itself, if no face is found}
    face
] [
    if gob? face [face: face/data]
    fc: face
    until [
        face: parent-face? face
        any [root-face? face found: tag-face? face 'compound]
    ]
    either found [face] [fc]
]
set-tab-face: funct [
    {Sets the tab face in the given window face and focuses the face if possible}
    window
    tab-face
] [
    set-facet window 'tab-face tab-face
    if tag-face? tab-face 'field [focus tab-face]
]
process-tab: funct [
    "Process tab key (move focus)"
    event "Keyboard event (tab key)"
    face "Current face"
] [
    win: window-face? face
    unless tab-face: get-facet win 'tab-face [
        set-facet win 'tab-face tab-face: face
    ]
    shift-key: found? find event/flags 'shift
    new-tab-face: apply :find-tab-face? reduce [tab-face shift-key]
    if new-tab-face [
        set-tab-face event/window/data new-tab-face
        if tab-face <> new-tab-face [focus new-tab-face]
    ]
    tab-face
]
faces?: funct [
    "Get a block of faces in a panel"
    face [object!]
] [
    face: face/gob
    result: make block! length? face
    repeat i length? face [
        sg: face/:i
        if same? sg sg/data/gob [append result sg/data]
    ]
    result
]
foreach-face: closure [
    {Evaluates the BODY block for each subface in the PANEL.}
    'word [word!] "Word to set each time (local)"
    panel [object!] "The panel to traverse"
    body [block!] "Block to evaluate each time"
    /local sg result
] [
    word: repeat (word) 1 reduce [:quote word]
    body: bind/copy body word
    panel: panel/gob
    repeat i length? panel [
        sg: panel/:i
        if same? sg sg/data/gob [
            set word sg/data
            set/any 'result do body
        ]
    ]
    get/any 'result
]
has-faces?: funct [
    "Finds out whether the face has content"
    face [object!]
] [
    face: face/gob
    repeat i length? face [
        sg: face/:i
        if same? sg sg/data/gob [return true]
    ]
]
dialect-draw: make object! [
    type-spec: [block!]
    anti-alias: [logic!]
    arc: [
        pair! pair! decimal! decimal! word!
        decimal! word!
    ]
    arrow: [tuple! pair!]
    box: [pair! pair! decimal!]
    circle: [pair! decimal! decimal!]
    clip: [pair! pair! logic!]
    curve: [* pair!]
    effect: [pair! pair! block!]
    ellipse: [pair! pair!]
    fill-pen: [tuple! image! logic!]
    fill-rule: [word!]
    gamma: [decimal!]
    grad-pen: [word! word! pair! logic! decimal! decimal! decimal! decimal! decimal! block!]
    invert-matrix: []
    image: [image! tuple! word! word! integer! integer! integer! integer! * pair!]
    image-filter: [word! word! decimal!]
    line: [* pair!]
    line-cap: [word!]
    line-join: [word!]
    line-pattern: [logic! tuple! * decimal!]
    line-width: [decimal! word!]
    matrix: [block!]
    pen: [tuple! image! logic!]
    polygon: [* pair!]
    push: [block!]
    reset-matrix: []
    rotate: [decimal!]
    scale: [decimal! decimal!]
    shape: [block!]
    skew: [decimal!]
    spline: [integer! word! * pair!]
    text: [word! pair! pair! block!]
    transform: [decimal! pair! decimal! decimal! pair!]
    translate: [pair!]
    triangle: [pair! pair! pair! tuple! tuple! tuple! decimal!]
    close: []
    curv: [* pair!]
    hline: [decimal!]
    move: [* pair!]
    qcurv: [pair!]
    qcurve: [* pair!]
    vline: [decimal!]
    radial: none
    conic: none
    diamond: none
    linear: none
    diagonal: none
    cubic: none
    non-zero: none
    even-odd: none
    border: none
    nearest: none
    bilinear: none
    bicubic: none
    gaussian: none
    resample: none
    butt: none
    square: none
    rounded: none
    miter: none
    miter-bevel: none
    round: none
    bevel: none
    fixed: none
    closed: none
    normal: none
    repeat: none
    reflect: none
    large: none
    sweep: none
    vectorial: none
]
set-draw-keywords-in: funct [
    context [object!]
    size [pair!]
] [
    do bind [
        gob-size: min max size min-size max-size
        space: reduce [
            margin/1 + border-size/1 + padding/1
            margin/2 + border-size/2 + padding/2
        ]
        size: gob-size - space/1 - space/2
        margin-box/top-left: negate space/1
        margin-box/bottom-right: size + space/2
        margin-box/top-right: as-pair margin-box/bottom-right/x margin-box/top-left/y
        margin-box/bottom-left: as-pair margin-box/top-left/x margin-box/bottom-right/y
        margin-box/center: margin-box/bottom-right + margin-box/top-left * 0.5
        border-box/top-left: margin-box/top-left + margin/1
        border-box/bottom-right: margin-box/bottom-right - margin/2
        border-box/top-right: as-pair border-box/bottom-right/x border-box/top-left/y
        border-box/bottom-left: as-pair border-box/top-left/x border-box/bottom-right/y
        border-box/center: border-box/bottom-right + border-box/top-left * 0.5
        padding-box/top-left: border-box/top-left + border-size/1
        padding-box/bottom-right: border-box/bottom-right - border-size/2
        padding-box/top-right: as-pair padding-box/bottom-right/x padding-box/top-left/y
        padding-box/bottom-left: as-pair padding-box/top-left/x padding-box/bottom-right/y
        padding-box/center: padding-box/bottom-right + padding-box/top-left * 0.5
        viewport-box/top-left: 0x0
        viewport-box/bottom-right: size
        viewport-box/top-right: as-pair viewport-box/bottom-right/x viewport-box/top-left/y
        viewport-box/bottom-left: as-pair viewport-box/top-left/x viewport-box/bottom-right/y
        viewport-box/center: size * 0.5
    ] context
]
box-model: [
    translate (space/1)
    clip margin-box/top-left margin-box/bottom-right
    anti-alias off
    pen off (
        all [
            bg-color [
                fill-pen bg-color
                box border-box/top-left border-box/bottom-right
                fill-pen off
            ]
        ]
    )
    pen border-color (
        all [
            border-size/1/x > 0 [
                line-cap (pick [square butt] border-size/1/y = 1)
                line-width (border-size/1/y)
                line (border-box/top-left + (0x1 * (to integer! border-size/1/y / 2))) (border-box/top-right - 1x0 + (0x1 * (to integer! border-size/1/y / 2)))
            ]
        ]
    ) (
        all [
            border-size/1/y > 0 [
                line-cap (pick [square butt] border-size/1/x = 1)
                line-width (border-size/1/x)
                line (border-box/top-left + (1x0 * (to integer! border-size/1/x / 2))) (border-box/bottom-left - 0x1 + (1x0 * (to integer! border-size/1/x / 2)))
            ]
        ]
    ) (
        all [
            border-size/2/x > 0 [
                line-cap (pick [square butt] border-size/2/y = 1)
                line-width (border-size/2/y)
                line (border-box/bottom-left - 0x1 - (0x1 * (to integer! border-size/2/y / 2))) (border-box/bottom-right - 1 - (0x1 * (to integer! border-size/2/y / 2)))
            ]
        ]
    ) (
        all [
            border-size/2/y > 0 [
                line-cap (pick [square butt] border-size/2/x = 1)
                line-width (border-size/2/x)
                line (border-box/top-right - 1x0 - (1x0 * (to integer! border-size/2/x / 2))) (border-box/bottom-right - 1 - (1x0 * (to integer! border-size/2/x / 2)))
            ]
        ]
    )
    clip viewport-box/top-left viewport-box/bottom-right
    line-width 1
    pen white
    fill-pen off
    anti-alias on
]
draw-face: funct [
    "Given a face, generate its DRAW block."
    face [object!]
    /no-show "Do not queue it for refresh"
] [
    draw-buf: guie/drawing
    unless empty? face/gob [
        foreach f faces? face [draw-face/no-show f]
    ]
    if any [
        face/gob/color
        face/gob/text
        face/gob/effect
    ] [
        face/draw-result: none
        unless no-show [show-later face]
        exit
    ]
    style: select guie/styles face/style
    append clear draw-buf box-model
    usr-drw: any [select face 'draw select style 'draw]
    if word? d: get-facet face 'draw-mode [
        if block? d: select usr-drw to set-word! d [usr-drw: d]
    ]
    all [
        usr-drw
        append draw-buf usr-drw
    ]
    all [
        drw: do-style face 'on-draw draw-buf
        draw-buf: drw
    ]
    if select face 'debug [
        draw-buf: append copy [pen red line-width 1 box 0x0 (margin-box/bottom-right - 1)] draw-buf
    ]
    if tb: get-facet face 'text-body [
        append/only append draw-buf 'text make-text face tb
    ]
    if empty? draw-buf [exit]
    all [
        style/facets
        bind draw-buf style/facets
    ]
    bind draw-buf face/facets
    delect/all dialect-draw compose/deep draw-buf face/draw-result: copy []
    unless no-show [show-later face]
]
get-face: func [
    "Get a variable from the face state"
    face [object!]
    /field
    word [word! none!]
] [
    do-style face 'on-get any [word 'value]
]
set-face: func [
    "Set a variable in the face state, redraw the face."
    face [object!]
    value
    /no-draw "Do not redraw the face at this time"
    /field "Set only specific field"
    word [word! none!]
    /list "Value is a tagged list already"
] [
    unless list [value: reduce [any [word 'value] :value]]
    do-style face 'on-set value
    unless no-draw [draw-face face]
    if get-facet face 'relay [do-face face]
]
set-facet: func [
    {Set a named facet in face/facets. Creates it if needed.}
    face [object!]
    word [word!]
    value
] [
    extend face/facets word :value
]
get-facet: funct [
    "Get a named facet(s) from the face or style."
    face [object!]
    field [word! block!] "A word or block of words (set-words allowed)."
] [
    either word? field [
        any [
            select face/facets field
            all [
                style: select guie/styles face/style
                select style/facets field
            ]
        ]
    ] [
        foreach word field [
            if any-word? :word [
                set :word any [
                    select face/facets to-word word
                    all [
                        style: select guie/styles face/style
                        select style/facets to-word word
                    ]
                ]
            ]
        ]
    ]
]
do-face: funct [
    {Evaluates the reactors (result actions) for a specific face.}
    face [object!]
    /only "Only do a specific kind of reactor"
    kind [word! none!]
    /custom
    custom-reactors [block!]
    /from-trigger
    id [word!] arg [any-type!]
] [
    if rel: get-facet face 'related [do-related face rel]
    names: all [
        pf: parent-face? face
        in pf 'names
        pf/names
    ]
    if any [custom-reactors select face 'reactors] [
        foreach cmd any [custom-reactors face/reactors] [
            if any [not kind kind = cmd/1] [
                if names [bind cmd names]
                apply/only select guie/actions cmd/1 append reduce [face get-face face id arg] next cmd
            ]
        ]
    ]
]
make-face-actions: func [
    reactors
] [
    foreach [name spec code] reactors [
        typesets: clear []
        foreach t spec [
            if block? t [append typesets to typeset! t]
        ]
        repend guie/dialect [name copy typesets]
        repend guie/actions [name funct append copy [face value trigger-id actor-arg] spec code]
    ]
]
append-face-act: funct [
    face
    blk
] [
    extend-face/only face 'reactors copy/deep blk
]
find-act: func [
    face action name
] [
    if select face 'reactors [
        foreach act face/reactors [
            if all [act/1 = action act/2 = name] [return act]
        ]
    ]
    none
]
exclude-faces: funct [
    sel-face name
] [
    panel: parent-face? sel-face
    foreach face panel/faces [
        if all [
            sel-face/style = face/style
            act: find-act face 'of name
        ] [
            if all [
                face <> sel-face
                get-face face
            ] [
                set-face face off
            ]
        ]
    ]
]
close-win-face: func [
    "Close the parent window of a face."
    face
    /result value "Set result value (for requestors)"
] [
    if face: window-face? face [
        if result [set-face face value]
        unview/only face
    ]
]
make-face-actions [
    do: ["Evaluate in REBOL a block or file." arg [block! file! url! word!]] [
        switch type?/word arg [
            block! [do funct [face value actor-arg] arg :face :value :actor-arg]
            word! [do-face get arg]
            file! url! [do arg]
        ]
    ]
    do-reactors: [{Evaluate block of reactor actions after specific ACTOR event} action [word!] arg [block!]] [
        if trigger-id <> action [exit]
        actions: make block! 10
        dial: make block! 10
        forever [
            if error? err: try [
                arg: delect guie/dialect arg dial
            ] [
                fail-gui ["Cannot parse the DO-REACTOR dialect at:" copy/part dial 5]
            ]
            unless arg [break]
            append/only actions copy/deep dial
        ]
        do-face/custom/from-trigger face actions action actor-arg
    ]
    browse: ["Open web browser." arg [url! file!]] [browse arg]
    run: [{Run external program (or default app for file type).} file [file!]] [
        call to-local-file file
    ]
    launch: ["Launch a script" arg [url! file!]] [
        launch arg
    ]
    view: ["Change the contents of a panel." what [word!] where [word!]] [
        switch-panel get where get what none
    ]
    alert: ["Popup an alert message." msg [string!] title [string! none!]] [
        request any [title "Alert"] msg
    ]
    close: ["Close the current window." status [word! logic! block! none!]] [
        if block? status [status: do bind status 'status]
        close-win-face/result face :status
    ]
    halt: ["Exit to console."] [halt]
    quit: ["Exit REBOL."] [quit/now]
    set: [
        "Set state of a face. Default field is VALUE."
        name [word!] field [word! none!] val [any-type!]
    ] [
        set-face/field get name val field
    ]
    of: ["Reset state of related faces (mutex)." name [word!]] [exclude-faces face name]
    attach: [
        {Set a field of a face to a field of this face and perform the main function of the named face.}
        name [word!] field [word! none!] self-field [word! none!]
    ] [
        set-face/field get name get-face/field face field self-field
        do-face get name
    ]
    submit: [
        "Submit contents to a URL or other receiver."
        name [word! none!]
        dest [url! file! function! none!]
        args [block! none!]
    ] [
        blk: either name [get-panel get name] [get-parent-panel face]
        if args [insert blk reduce/no-set args]
        switch type?/word :dest [
            function! [dest face blk]
            url! file! [
                probe to-string write dest to-binary probe mold/all blk
            ]
            none! [print mold/all blk]
        ]
    ]
    acquire: [
        "Acquire contents from a URL or other sender."
        name [word! none!]
        src [url! file! function! none!]
        args [block! none!]
    ] [
        switch type?/word :src [
            function! [vals: src face reduce/no-set args]
            url! file! [
                probe vals: load src
            ]
            none [print vals: none]
        ]
        set-face either name [get name] [parent-face? face] vals
    ]
    reset: ["Reset contents to original value(s)." name [word! none!]] [
        do-style either name [get name] [face] 'on-reset none
    ]
    clear: ["Clear the contents of a face." name [word! none!]] [
        do-style either name [get name] [parent-face? face] 'on-clear none
    ]
    focus: ["Focus key input to a given face." name [word! none!]] [
        either name [focus get name] []
    ]
    scroll: ["Tell a face to scroll based on our value." name [word! object!]] [
        if word? name [name: get name]
        do-style name 'on-scroll face
    ]
    print: ["Print a value to console." data [any-type!]] [print data]
    dump: ["Print the face object on the console."] [probe face]
    moved: ["Called when face has moved (for windows)." arg [block!]] [do bind arg 'arg]
    signal: ["Send a signal to another face." id [word! integer!] who [word! none!]] [
        unless who [face: parent-face? face]
        do-style face 'on-signal id
    ]
    record: ["Manage as database record." info [block!]] [
        info: copy info
        set-facet face 'record make map! compose [
            data: (found? find info 'data)
            skip: (found? find info 'skip)
            record: (take find info word!)
        ]
    ]
]
make-panel: func [
    face [object!]
    layout-type [word!]
] [
    init-panel face layout-type
    if get-facet face 'names [bind-faces face]
    foreach face faces? face [do-style face 'on-init none]
    foreach face select face 'trigger-faces [do-style face 'on-init none]
    do-triggers/no-recursive face 'load
]
init-panel: funct [
    {Initialize a panel face object. Init subfaces and set size.}
    panel [object!]
    layout-type [word!]
    /local d1 d2
] [
    unless block: select panel/options 'content [
        if all [
            style: select guie/styles panel/style
            block: select style 'content
            block: copy block
        ] [
            foreach [d: c] block [
                if get-word? :c [
                    change/only d get-facet panel to-word c
                ]
            ]
        ]
    ]
    faces: apply :parse-panel [block get-facet panel 'names]
    panel?: layout-type = 'panel
    trigs: none
    remove-each face faces [
        hidden?: true
        either object? face [
            hidden?: if t: get-facet face 'triggers [
                unless trigs [trigs: make block! 2]
                append trigs face
                not find t 'visible-trigger
            ]
            all [
                panel?
                not hidden?
                append panel/gob face/gob
            ]
            hidden?
        ] [
            false
        ]
    ]
    extend panel 'trigger-faces trigs
    append panel/facets reduce/no-set switch layout-type [
        panel [[
                break-after: any [
                    all [
                        in panel/facets 'break-after panel/facets/break-after
                    ]
                    0
                ]
                pane-align: any [
                    all [in panel/facets 'pane-align panel/facets/pane-align]
                    'left
                ]
                pane-valign: any [
                    all [in panel/facets 'pane-valign panel/facets/pane-valign]
                    'top
                ]
                column-max: any [
                    all [in panel/facets 'column-max panel/facets/column-max]
                    'max
                ]
                row-max: any [
                    all [in panel/facets 'row-max panel/facets/row-max]
                    'max
                ]
                resize?: either in panel/facets 'resize? [
                    panel/facets/resize?
                ] [
                    on
                ]
                layout-mode: any [
                    all [in panel/facets 'layout-mode panel/facets/layout-mode]
                    'horizontal
                ]
                auto-size?: panel/facets/init-size = 0x0
                intern: make object! [
                    update?: true
                    init-pane: none
                    init-heights: copy []
                    min-heights: copy []
                    max-heights: copy []
                    init-widths: copy []
                    min-widths: copy []
                    max-widths: copy []
                    row-minification-index: copy []
                    row-magnification-index: copy []
                    column-minification-index: copy []
                    column-magnification-index: copy []
                ]
            ]]
        group [[
                pane-align: any [
                    all [in panel/facets 'pane-align panel/facets/pane-align]
                    'left
                ]
                pane-valign: any [
                    all [in panel/facets 'pane-valign panel/facets/pane-valign]
                    'top
                ]
                layout-mode: any [
                    all [in panel/facets 'layout-mode panel/facets/layout-mode]
                    'horizontal
                ]
                resize?: either in panel/facets 'resize? [
                    panel/facets/resize?
                ] [
                    on
                ]
                auto-size?: panel/facets/init-size = 0x0
                intern: make object! [
                    update?: true
                    init-pane: none
                    lines: copy []
                    minification-index: copy []
                    magnification-index: copy []
                ]
            ]]
    ]
    unless panel? [
        insert-into-group panel/gob 1 + length? panel/gob faces
    ]
    panel
]
set-panel: funct [
    {Set panel input face values from an object of values.}
    panel [object!]
    values [object!]
] [
    faces: faces? panel
    foreach face faces [
        either tag-face? face 'panel [
            set-panel face values
        ] [
            all [
                in face 'name
                tag-face? face [info field state]
                val: get in values face/name
                set-face face val
            ]
        ]
    ]
]
get-panel: funct [
    "Get panel input face values as an object."
    panel [object!]
] [
    out: make object! []
    foreach face any [f: faces? panel to-block panel] [
        if tag-face? face [info field state] [
            if select face 'name [
                repend out [to-set-word face/name get-face face]
            ]
        ]
        if f [
            out: make out get-panel face
        ]
    ]
    foreach face select panel 'trigger-faces [
        if tag-face? face [info field state] [
            if in face 'name [
                extend out face/name get-face face
            ]
        ]
    ]
    out
]
clear-panel: func [
    "Clear panel input face values."
    panel [object!]
] [
    foreach face faces? panel [
        either tag-face? face 'panel [
            clear-panel face
        ] [
            all [
                tag-face? face [info field state]
                do-style face 'on-clear none
            ]
        ]
    ]
]
get-parent-panel: funct [
    {Get panel input faces for the contextual parent panel.}
    face
] [
    while [not select face 'names] [
        unless f: parent-face? face [break]
        face: f
    ]
    get-panel face
]
get-panel-var: funct [
    {Get the value of a top level panel/names local variable.}
    panel [gob!] "The window gob"
    name [word!]
] [
    all [
        p: panel/data
        p: first faces? p
        p: p/names
        p/:name
    ]
]
set-panel-content: funct [
    panel [object!]
    content [block! object!]
    /pos
    index [integer! object! gob!]
    /no-show
] [
    apply :clear-panel-content [panel index index]
    apply :insert-panel-content [
        panel content true 1 + length? panel/gob no-show
    ]
]
clear-panel-content: funct [
    panel [object!]
    /pos
    index [integer! object! gob!]
    /no-show
] [
    index: any [index 1]
    if object? index [index: index/gob]
    index: either gob? index [
        either index: find panel/gob index [index? index] [
            1 + length? panel/gob
        ]
    ] [
        max index 1
    ]
    either index > len: length? panel/gob [panel] [
        do-style panel 'on-content reduce ['clear no-show index len]
    ]
]
insert-panel-content: funct [
    panel [object!]
    content [block! object!]
    /pos
    index [integer! object! gob!] "pane index, face, or gob"
    /no-show
] [
    index: any [index 1]
    if object? index [index: index/gob]
    index: case [
        gob? index [
            either index: find panel/gob index [index? index] [
                1 + length? panel/gob
            ]
        ]
        integer? index [min max index 1 1 + length? panel/gob]
    ]
    content: either block? content [
        apply :parse-panel [
            content all [in panel/facets 'names panel/facets/names]
        ]
    ] [
        reduce [content]
    ]
    either empty? content [panel] [
        do-style panel 'on-content reduce ['insert no-show content index]
    ]
]
append-panel-content: funct [
    panel [object!]
    content [block! object!]
    /no-show
] [
    apply :insert-panel-content [
        panel content true 1 + length? panel/gob no-show
    ]
]
change-panel-content: funct [
    panel [object!]
    content [block! object!]
    /pos
    index [integer! object! gob!]
    /part
    range [integer!]
    /no-show
] []
remove-panel-content: func [
    panel [object!]
    /pos
    index [integer! object! gob!]
    /part
    range [integer!]
    /no-show
] [
    index: any [index 1]
    if object? index [index: index/gob]
    index: case [
        gob? index [
            either index: find panel/gob index [index? index] [
                1 + length? panel/gob
            ]
        ]
        integer? index [min max index 1 1 + length? panel/gob]
    ]
    range: any [range 1]
    range: max range 1 - index
    if range < 0 [
        index: index + range
        range: negate range
    ]
    if index > length? panel/gob [return panel]
    range: min range 1 - index + length? panel/gob
    if range = 0 [return panel]
    do-style panel 'on-content reduce ['remove no-show index range]
]
make object! [
    line-proto: make object! [
        start:
        length:
        net-length:
        init-size:
        min-size:
        max-size:
        offset:
        size:
        minification-index:
        magnification-index:
        none
        align: 'left
        valign: 'top
    ]
    max-coord: 2147483647
    add-max: func [a b] [
        either any [max-coord = a max-coord = b] [max-coord] [a + b]
    ]
    group-modes: make object! [
        horizontal: [
            x
            y
            valign
            align
            pane-valign
            top
            middle
            bottom
            left
            center
            right
        ]
        vertical: [
            y
            x
            align
            valign
            pane-align
            left
            center
            right
            top
            middle
            bottom
        ]
    ]
    set 'update-group funct [
        {
^-^-^-given a group update:
^-^-^-^-line dimensions
^-^-^-^-pane dimensions
^-^-^-^-minification and magnification indices
^-^-}
        group [gob!]
    ] [
        do bind bind/copy [
            unless update? [exit]
            update?: false
            unless spacing [spacing: 0x0]
            set [d1: d2:] group-modes/:layout-mode
            sort-block: copy []
            init-pane:
            min-pane:
            max-pane: 0x0
            net-lines: 0
            repeat i length? lines [
                line: lines/:i
                line/init-size:
                line/min-size:
                line/max-size: 0x0
                line/align: case [
                    word? pane-align [pane-align]
                    all [block? pane-align pick pane-align i] [
                        pick pane-align i
                    ]
                    true [line/align]
                ]
                line/valign: case [
                    word? pane-valign [pane-valign]
                    all [block? pane-valign pick pane-valign i] [
                        pick pane-valign i
                    ]
                    true [line/valign]
                ]
                line-start: at group line/start
                line/net-length: 0
                repeat i line/length [
                    sg: pick line-start i
                    face: sg/data
                    case [
                        face/facets/resizes? [
                            do-style face 'on-update none
                            line/net-length: line/net-length + 1
                            line/init-size/:d1: line/init-size/:d1
                            + face/facets/init-size/:d1
                            line/init-size/:d2: max line/init-size/:d2
                            face/facets/init-size/:d2
                            line/min-size/:d1: line/min-size/:d1
                            + face/facets/min-size/:d1
                            line/min-size/:d2: max line/min-size/:d2
                            face/facets/min-size/:d2
                            line/max-size/:d1: add-max line/max-size/:d1
                            face/facets/max-size/:d1
                            line/max-size/:d2: max line/max-size/:d2
                            face/facets/max-size/:d2
                        ]
                        face/gob/size <> 0x-1 [
                            either in face/facets 'intern [
                                if face/facets/intern/update? [
                                    do-style face 'on-resize face/facets/gob-size
                                ]
                            ] [
                                do-style face 'on-update none
                            ]
                        ]
                    ]
                ]
                line-spacing: spacing/:d1 * max 0 line/net-length - 1
                if line/net-length > 0 [net-lines: net-lines + 1]
                init-pane/:d1: max init-pane/:d1 line-spacing
                + line/init-size/:d1
                init-pane/:d2: init-pane/:d2 + line/init-size/:d2
                min-pane/:d1: max min-pane/:d1 line-spacing + line/min-size/:d1
                min-pane/:d2: min-pane/:d2 + line/min-size/:d2
                max-pane/:d1: max max-pane/:d1 add-max line-spacing
                line/max-size/:d1
                max-pane/:d2: add-max max-pane/:d2 line/max-size/:d2
                line/minification-index: make block! line/net-length
                clear sort-block
                repeat i line/length [
                    sg: pick line-start i
                    face: sg/data
                    if face/facets/resizes? [
                        append append sort-block
                        either face/facets/init-size/:d1 = 0 [1.0] [
                            face/facets/min-size/:d1
                            / face/facets/init-size/:d1
                        ] i
                    ]
                ]
                sort/skip/reverse sort-block 2
                foreach [value i] sort-block [append line/minification-index i]
                line/magnification-index: make block! line/length
                clear sort-block
                repeat i line/length [
                    sg: pick line-start i
                    face: sg/data
                    if face/facets/resizes? [
                        append append sort-block
                        either face/facets/init-size/:d1 = 0 [1.0] [
                            face/facets/max-size/:d1
                            / face/facets/init-size/:d1
                        ] i
                    ]
                ]
                sort/skip sort-block 2
                foreach [value i] sort-block [append line/magnification-index i]
            ]
            box-space: margin/1 + border-size/1 + padding/1 + margin/2
            + border-size/2 + padding/2
            box-space/:d2: box-space/:d2 + (spacing/:d2 * max 0 net-lines - 1)
            if auto-size? [
                init-size: init-pane + box-space
                either resize? [
                    min-size: min-pane + box-space
                    max-size: max-pane
                    unless max-size/x = max-coord [
                        max-size/x: max-size/x + box-space/x
                    ]
                    unless max-size/y = max-coord [
                        max-size/y: max-size/y + box-space/y
                    ]
                ] [
                    min-size: max-size: init-size
                ]
            ]
            minification-index: make block! net-lines
            clear sort-block
            repeat i length? lines [
                linei: pick lines i
                unless linei/net-length = 0 [
                    append append sort-block either linei/init-size/:d1 = 0 [
                        1.0
                    ] [
                        linei/min-size/:d1 / linei/init-size/:d1
                    ] i
                ]
            ]
            sort/skip/reverse sort-block 2
            foreach [value i] sort-block [append minification-index i]
            magnification-index: make block! net-lines
            clear sort-block
            repeat i length? lines [
                linei: pick lines i
                unless linei/net-length = 0 [
                    append append sort-block either linei/init-size/:d1 = 0 [
                        1.0
                    ] [
                        linei/max-size/:d1 / linei/init-size/:d1
                    ] i
                ]
            ]
            sort/skip sort-block 2
            foreach [value i] sort-block [append magnification-index i]
        ] group/data/facets group/data/facets/intern
    ]
    set 'update-panel funct [
        {
^-^-^-given a panel update:
^-^-^-^-row heights
^-^-^-^-column widths
^-^-^-^-pane dimensions
^-^-^-^-minification and magnification indices
^-^-}
        panel [gob!]
    ] [
        do bind bind/copy [
            unless update? [exit]
            update?: false
            unless spacing [spacing: 0x0]
            sort-block: copy []
            net-panel: 0
            repeat i length? panel [
                sg: pick panel i
                face: sg/data
                case [
                    face/facets/resizes? [
                        do-style face 'on-update none
                        net-panel: net-panel + 1
                    ]
                    face/gob/size <> 0x-1 [
                        either in face/facets 'intern [
                            if face/facets/intern/update? [
                                do-style face 'on-resize face/facets/gob-size
                            ]
                        ] [
                            do-style face 'on-update none
                        ]
                    ]
                ]
            ]
            line-length: either break-after = 0 [net-panel] [break-after]
            either line-length = 0 [lines: 0] [
                last-line: net-panel // line-length
                lines: net-panel - last-line / line-length
                if last-line <> 0 [lines: lines + 1]
            ]
            either layout-mode = 'horizontal [
                rows: lines
                columns: line-length
            ] [
                rows: line-length
                columns: lines
            ]
            row-max-block: either block? row-max [row-max] [
                append/dup make block! rows row-max rows
            ]
            init-heights: head insert/dup copy [] 0 rows
            min-heights: head insert/dup copy [] 0 rows
            max-heights: make block! rows
            foreach rm row-max-block [
                append max-heights case [
                    rm = 'max [0]
                    rm = 'min [max-coord]
                    true [rm]
                ]
            ]
            column-max-block: either block? column-max [column-max] [
                append/dup make block! columns column-max columns
            ]
            init-widths: head insert/dup copy [] 0 columns
            min-widths: head insert/dup copy [] 0 columns
            max-widths: make block! columns
            foreach cm column-max-block [
                append max-widths case [
                    cm = 'max [0]
                    cm = 'min [max-coord]
                    true [cm]
                ]
            ]
            row-number: 1
            column-number: 1
            repeat i length? panel [
                sg: pick panel i
                face: sg/data
                if face/facets/resizes? [
                    init-heights/:row-number: max init-heights/:row-number
                    face/facets/init-size/y
                    min-heights/:row-number: max min-heights/:row-number
                    face/facets/min-size/y
                    case [
                        row-max-block/:row-number = 'max [
                            max-heights/:row-number: max max-heights/:row-number
                            face/facets/max-size/y
                        ]
                        row-max-block/:row-number = 'min [
                            max-heights/:row-number: min max-heights/:row-number
                            face/facets/max-size/y
                        ]
                    ]
                    init-widths/:column-number: max init-widths/:column-number
                    face/facets/init-size/x
                    min-widths/:column-number: max min-widths/:column-number
                    face/facets/min-size/x
                    case [
                        column-max-block/:column-number = 'max [
                            max-widths/:column-number: max max-widths/:column-number
                            face/facets/max-size/x
                        ]
                        column-max-block/:column-number = 'min [
                            max-widths/:column-number: min max-widths/:column-number
                            face/facets/max-size/x
                        ]
                    ]
                    either layout-mode = 'horizontal [
                        column-number: column-number + 1
                        if column-number > columns [
                            column-number: 1
                            row-number: row-number + 1
                        ]
                    ] [
                        row-number: row-number + 1
                        if row-number > rows [
                            row-number: 1
                            column-number: column-number + 1
                        ]
                    ]
                ]
            ]
            repeat row-number rows [
                max-heights/:row-number: max max-heights/:row-number
                init-heights/:row-number
            ]
            repeat column-number columns [
                max-widths/:column-number: max max-widths/:column-number
                init-widths/:column-number
            ]
            init-pane:
            min-pane:
            max-pane: 0x0
            repeat row-number rows [
                init-pane/y: init-pane/y + init-heights/:row-number
                min-pane/y: min-pane/y + min-heights/:row-number
                max-pane/y: either any [
                    max-pane/y = max-coord
                    max-heights/:row-number = max-coord
                ] [max-coord] [max-pane/y + max-heights/:row-number]
            ]
            repeat column-number columns [
                init-pane/x: init-pane/x + init-widths/:column-number
                min-pane/x: min-pane/x + min-widths/:column-number
                max-pane/x: either any [
                    max-pane/x = max-coord
                    max-widths/:column-number = max-coord
                ] [max-coord] [max-pane/x + max-widths/:column-number]
            ]
            box-space: margin/1 + border-size/1 + padding/1 + margin/2
            + border-size/2 + padding/2 + (
                spacing * max 0x0 (as-pair columns rows) - 1x1
            )
            if auto-size? [
                init-size: init-pane + box-space
                either resize? [
                    min-size: min-pane + box-space
                    max-size/x: either max-pane/x = max-coord [max-coord] [
                        max-pane/x + box-space/x
                    ]
                    max-size/y: either max-pane/y = max-coord [max-coord] [
                        max-pane/y + box-space/y
                    ]
                ] [
                    min-size: max-size: init-size
                ]
            ]
            row-minification-index: make block! rows
            clear sort-block
            repeat row-number rows [
                append append sort-block either init-heights/:row-number = 0 [
                    1.0
                ] [
                    min-heights/:row-number / init-heights/:row-number
                ] row-number
            ]
            sort/skip/reverse sort-block 2
            foreach [value row-number] sort-block [
                append row-minification-index row-number
            ]
            row-magnification-index: make block! rows
            clear sort-block
            repeat row-number rows [
                append append sort-block either init-heights/:row-number = 0 [
                    1.0
                ] [
                    max-heights/:row-number / init-heights/:row-number
                ] row-number
            ]
            sort/skip sort-block 2
            foreach [value row-number] sort-block [
                append row-magnification-index row-number
            ]
            column-minification-index: make block! columns
            clear sort-block
            repeat column-number columns [
                append append sort-block either init-widths/:column-number = 0 [
                    1.0
                ] [
                    min-widths/:column-number / init-widths/:column-number
                ] column-number
            ]
            sort/skip/reverse sort-block 2
            foreach [value column-number] sort-block [
                append column-minification-index column-number
            ]
            column-magnification-index: make block! columns
            clear sort-block
            repeat column-number columns [
                append append sort-block either init-widths/:column-number = 0 [
                    1.0
                ] [
                    max-widths/:column-number / init-widths/:column-number
                ] column-number
            ]
            sort/skip sort-block 2
            foreach [value column-number] sort-block [
                append column-magnification-index column-number
            ]
        ] panel/data/facets panel/data/facets/intern
    ]
    line?: funct [
        "compute the line number of a group position"
        group [gob!]
        index [integer!]
    ] [
        lines: group/data/facets/intern/lines
        b: length? lines
        case [
            lines/1/length >= index [1]
            lines/:b/start <= index [b]
            true [
                a: 1
                while [a + 1 < b] [
                    m: shift a + b -1
                    line: lines/:m
                    case [
                        line/start > index [b: m]
                        line/start + line/length <= index [a: m]
                        true [a: b: m]
                    ]
                ]
                a
            ]
        ]
    ]
    set 'remove-from-group funct [
        "remove subgob(s) from a group"
        group [gob!]
        index [integer!]
        length [integer!]
    ] [
        lines: group/data/facets/intern/lines
        remove/part at group index length
        line-no: line? group index
        line: lines/:line-no
        last-index: index + length - 1
        either line/start + line/length > last-index [
            line/length: line/length - length
            either line/length = 0 [remove at lines line-no] [
                line-no: line-no + 1
            ]
        ] [
            if index > line/start [
                line/length: index - line/start
                line-no: line-no + 1
            ]
            last-line-no: line? group last-index
            line: lines/:last-line-no
            line/length: line/start + line/length - 1 - last-index
            either line/length = 0 [
                last-line-no: last-line-no + 1
            ] [
                line/start: last-index - length
            ]
            remove/part at lines line-no last-line-no - line-no
            line-no: last-line-no
        ]
        foreach line at lines line-no [line/start: line/start - length]
    ]
    set 'insert-into-group funct [
        "insert faces(s) into a group"
        group [gob!]
        index [integer!]
        face [word! object! block!] "RETURN signals line break"
    ] [
        lines: group/data/facets/intern/lines
        if empty? lines [
            append lines make line-proto [
                start: 1
                length: 0
            ]
        ]
        line-no: line? group index
        lines: at lines line-no
        line: first lines
        lines: next lines
        length: 0
        trigs: none
        either block? face [
            faces: face
            remove-each f faces [
                face: f
                do process-face
            ]
        ] process-face: [
            either object? face [
                if t: select face/facets 'triggers [
                    unless trigs [
                        trigs: make block! 2
                    ]
                    append trigs face
                ]
                not if any [none? t find t 'visible-trigger] [
                    insert at group index face/gob
                    line/length: line/length + 1
                    length: length + 1
                    index: index + 1
                ]
            ] [
                new-line: make line-proto [
                    start: index
                    length: 0
                ]
                lines: insert lines new-line
                line/length: index - line/start
                line: new-line
            ]
        ]
        foreach line lines [line/start: line/start + length]
        trigs
    ]
    set 'change-line-alignment funct [
        "changes alignments of lines in a group"
        group [gob!]
        align [word! block!]
        valign [word! block!]
    ] [
        lines: group/data/facets/intern
        either word? align [
            foreach line lines [line/align: align]
        ] [
            n: min length? align length? lines
            repeat i n [
                line: lines/:i
                line/align: align/:i
            ]
        ]
        either word? valign [
            foreach line lines [line/valign: valign]
        ] [
            n: min length? valign length? lines
            repeat i n [
                line: lines/:i
                line/valign: valign/:i
            ]
        ]
    ]
    set 'resize-group funct [
        "resize a group"
        group [gob!]
    ] [
        do bind bind/copy [
            size: viewport-box/bottom-right
            set [d1: d2: ea: la: pa: a1: a2: a3: a4: a5: a6:]
            group-modes/:layout-mode
            source: init-pane/:d2
            total: target: size/:d2
            - (spacing/:d2 * max 0 (length? minification-index) - 1)
            either target <= source [
                index: minification-index
                boundary: 'min-size
                compare: :lesser-or-equal?
            ] [
                index: magnification-index
                boundary: 'max-size
                compare: :greater-or-equal?
            ]
            foreach i index [
                line: pick lines i
                ratio: either zero? source [1.0] [target / source]
                line/size: to integer! ratio * line/init-size/:d2 + 0.5
                unless compare line/:boundary/:d2 line/size [
                    line/size: line/:boundary/:d2
                ]
                source: source - line/init-size/:d2
                target: target - line/size
            ]
            offset: switch get bind pa 'pane-align reduce [
                a1 [space/1/:d2]
                a2 [
                    to integer! space/1/:d2 + group/size/:d2 - space/2/:d2
                    - (spacing/:d2 * max 0 (length? minification-index) - 1)
                    - total + target / 2 + 0.5
                ]
                a3 [
                    group/size/:d2 - space/2/:d2 - (
                        spacing/:d2 * max 0 (length? minification-index) - 1
                    ) - total + target
                ]
            ]
            foreach line lines [
                unless line/net-length = 0 [
                    line/offset: offset
                    offset: offset + line/size + spacing/:d2
                ]
            ]
            foreach line lines [
                unless line/net-length = 0 [
                    source: line/init-size/:d1
                    total: target: size/:d1 - (
                        spacing/:d1 * max 0 line/net-length - 1
                    )
                    either target <= source [
                        index-name: 'minification-index
                        boundary: 'min-size
                        compare: :lesser-or-equal?
                    ] [
                        index-name: 'magnification-index
                        boundary: 'max-size
                        compare: :greater-or-equal?
                    ]
                    line-start: at group line/start
                    foreach i line/:index-name [
                        sg: pick line-start i
                        face: sg/data
                        if face/facets/resizes? [
                            ratio: either zero? source [1.0] [target / source]
                            face/facets/gob-size/:d1: to integer! ratio
                            * face/facets/init-size/:d1 + 0.5
                            unless compare face/facets/:boundary/:d1 face/facets/gob-size/:d1 [
                                face/facets/gob-size/:d1: face/facets/:boundary/:d1
                            ]
                            face/facets/gob-size/:d2: line/size
                            do-style face 'on-resize face/facets/gob-size
                            source: source - face/facets/init-size/:d1
                            target: target - face/facets/gob-size/:d1
                        ]
                    ]
                    offset: switch line/:la reduce [
                        a4 [space/1/:d1]
                        a5 [
                            to integer! space/1/:d1 + gob-size/:d1 - space/2/:d1
                            - (spacing/:d1 * max 0 line/length - 1) - total
                            + target / 2 + 0.5
                        ]
                        a6 [
                            gob-size/:d1 - space/2/:d1 - (
                                spacing/:d1 * max 0 line/length - 1
                            ) - total + target
                        ]
                    ]
                    repeat i line/length [
                        sg: pick line-start i
                        face: sg/data
                        sg/offset/:d1: offset
                        sg/offset/:d2: line/offset + switch face/facets/:ea reduce [
                            a1 [0]
                            a2 [
                                to integer! line/size
                                - face/facets/gob-size/:d2 / 2 + 0.5
                            ]
                            a3 [line/size - face/facets/gob-size/:d2]
                        ]
                        offset: offset + face/facets/gob-size/:d1 + spacing/:d1
                    ]
                ]
            ]
        ] group/data/facets group/data/facets/intern
    ]
    set 'resize-panel funct [
        "resize a panel"
        panel [gob!]
    ] [
        do bind bind/copy [
            size: viewport-box/bottom-right
            rows: length? row-minification-index
            columns: length? column-minification-index
            heights: head insert/dup copy [] none rows
            row-offsets: head insert/dup copy [] none rows
            source: init-pane/y
            total: target: size/y - (spacing/y * max 0 rows - 1)
            either target <= source [
                index: row-minification-index
                boundary: min-heights
                compare: :lesser-or-equal?
            ] [
                index: row-magnification-index
                boundary: max-heights
                compare: :greater-or-equal?
            ]
            foreach row-number index [
                ratio: either zero? source [1.0] [target / source]
                heights/:row-number: to integer! ratio
                * init-heights/:row-number + 0.5
                unless compare boundary/:row-number heights/:row-number [
                    heights/:row-number: boundary/:row-number
                ]
                source: source - init-heights/:row-number
                target: target - heights/:row-number
            ]
            offset: switch pane-valign [
                top [space/1/y]
                middle [
                    to integer! space/1/y + gob-size/y - space/2/y
                    - (spacing/y * max 0 rows - 1) - total + target / 2
                    + 0.5
                ]
                bottom [
                    gob-size/y - space/2/y - (spacing/y * max 0 rows - 1)
                    - total + target
                ]
            ]
            repeat row-number rows [
                row-offsets/:row-number: offset
                offset: offset + heights/:row-number + spacing/y
            ]
            widths: head insert/dup copy [] none columns
            column-offsets: head insert/dup copy [] none columns
            source: init-pane/x
            total: target: size/x - (spacing/x * max 0 columns - 1)
            either target <= source [
                index: column-minification-index
                boundary: min-widths
                compare: :lesser-or-equal?
            ] [
                index: column-magnification-index
                boundary: max-widths
                compare: :greater-or-equal?
            ]
            foreach column-number index [
                ratio: either zero? source [1.0] [target / source]
                widths/:column-number: to integer! ratio
                * init-widths/:column-number + 0.5
                unless compare boundary/:column-number widths/:column-number [
                    widths/:column-number: boundary/:column-number
                ]
                source: source - init-widths/:column-number
                target: target - widths/:column-number
            ]
            offset: switch pane-align [
                left [space/1/x]
                center [
                    to integer! space/1/x + gob-size/x - space/2/x
                    - (spacing/x * max 0 columns - 1) - total + target / 2
                    + 0.5
                ]
                right [
                    gob-size/x - space/2/x - (spacing/x * max 0 columns - 1)
                    - total + target
                ]
            ]
            repeat column-number columns [
                column-offsets/:column-number: offset
                offset: offset + widths/:column-number + spacing/x
            ]
            row-number: 1
            column-number: 1
            repeat i length? panel [
                sg: pick panel i
                face: sg/data
                if face/facets/resizes? [
                    face/facets/gob-size/x: widths/:column-number
                    face/facets/gob-size/y: heights/:row-number
                    do-style face 'on-resize face/facets/gob-size
                    sg/offset/x: column-offsets/:column-number + switch face/facets/align [
                        left [0]
                        center [
                            to integer! widths/:column-number
                            - face/facets/gob-size/x / 2 + 0.5
                        ]
                        right [widths/:column-number - face/facets/gob-size/x]
                    ]
                    sg/offset/y: row-offsets/:row-number + switch face/facets/valign [
                        top [0]
                        middle [
                            to integer! heights/:row-number
                            - face/facets/gob-size/y / 2 + 0.5
                        ]
                        bottom [heights/:row-number - face/facets/gob-size/y]
                    ]
                    either layout-mode = 'horizontal [
                        column-number: column-number + 1
                        if column-number > columns [
                            column-number: 1
                            row-number: row-number + 1
                        ]
                    ] [
                        row-number: row-number + 1
                        if row-number > rows [
                            row-number: 1
                            column-number: column-number + 1
                        ]
                    ]
                ]
            ]
        ] panel/data/facets panel/data/facets/intern
    ]
]
parse-panel: funct [
    {Parses the panel dialect and returns a block of faces/commands.}
    block [block! none!]
    /no-names "don't set face name references"
] [
    unless block [return copy []]
    pane: make block! length? block
    dial: block
    opts: make block! 10
    trigs: make block! 2
    last-face: none
    build-face: func [
        /not-on-make
    ] [
        if all [not not-on-make object? last-face] [
            if show? [
                show-face/no-show last-face show?
            ]
            do-style last-face 'on-make none
            if show? = 'fixed [
                do-style last-face 'on-update none
                do-style last-face 'on-resize last-face/facets/init-size
            ]
            show?: none
        ]
        all [
            block? last-face
            data: last-face/1
            last-face: last-face/1: apply :make-face [data/1 make-options data/1 data/2 not-on-make]
            if data/3 [
                extend last-face 'name data/3
                unless no-names [
                    set data/3 last-face
                ]
            ]
        ]
    ]
    forever [
        if error? err: try [
            dial: delect guie/dialect dial opts
        ] [
            fail-gui ["Cannot parse the GUI dialect at:" copy/part dial 5]
        ]
        unless dial [break]
        if word: first opts [
            arg: second opts
            case [
                word = 'face [
                    build-face
                    last-face: arg
                    if name [extend last-face 'name name name: none]
                    append pane last-face
                ]
                select guie/styles word [
                    build-face
                    insert/only last-face: tail pane reduce [word copy next opts name]
                    if name [name: none]
                ]
                word = 'default [
                    name: to-word arg
                ]
                word = 'return [
                    build-face
                    last-face: none
                    append pane 'return
                ]
                last-face [
                    build-face/not-on-make
                    switch/default word [
                        options [
                            if arg [
                                arg: reduce/no-set arg
                                if arg/gob-offset [
                                    last-face/gob/offset: arg/gob-offset
                                    remove/part find/skip arg 'gob-offset 2 2
                                ]
                                if arg/show? [
                                    show?: arg/show?
                                    remove/part find/skip arg 'show? 2 2
                                ]
                                append last-face/facets arg
                                either last-face/facets/gob-size = 0x0 [
                                    last-face/facets/gob-size: last-face/facets/init-size
                                ] [
                                    last-face/facets/init-size: last-face/facets/gob-size
                                ]
                            ]
                        ]
                        debug [
                            extend last-face 'debug any [arg [make]]
                            debug-face last-face 'make last-face
                        ]
                    ] [
                        either all [
                            style: select guie/styles last-face/style
                            select style/actors word
                        ] [
                            unless get-facet last-face 'triggers [
                                set-facet last-face 'triggers copy [visible-trigger]
                            ]
                            append get-facet last-face 'triggers word
                            append-face-act last-face reduce ['do-reactors opts/1 first next opts]
                        ] [
                            append-face-act last-face opts
                        ]
                    ]
                ]
            ]
        ]
    ]
    build-face
    pane
]
bind-faces: funct [
    panel
] [
    names: make object! 4
    find-panel-names panel names
    extend panel 'names names
    bind-panel-acts panel names
]
find-panel-names: funct [
    panel [object!]
    names [object!]
] [
    faces: faces? panel
    trigger-faces: select panel 'trigger-faces
    foreach field [faces trigger-faces] [
        foreach face get field [
            if item: select face 'name [
                repend names [item face]
            ]
        ]
    ]
    foreach face faces? panel [
        if all [
            not empty? faces? face
            not get-facet face 'names
        ] [
            find-panel-names face names
        ]
    ]
]
bind-panel-acts: funct [
    panel
    names [object!]
] [
    faces: faces? panel
    trigger-faces: select panel 'trigger-faces
    foreach field [faces trigger-faces] [
        foreach face get field [
            if item: select face 'reactors [
                bind item names
            ]
        ]
    ]
    foreach face faces? panel [
        if all [
            not empty? faces? face
            not get-facet face 'names
        ] [
            bind-panel-acts face names
        ]
    ]
]
do-triggers: funct [
    "Process all WHEN panel triggers of a given type."
    panel [object!]
    id [word!] "Type of trigger"
    /face "process only specific face"
    trigger-face [object! none!]
    /arg "optional arg value passed to trigger call"
    arg-value [any-type!]
    /only "trigger only specific reactor"
    reactor [word!]
    /no-recursive
] [
    if trigger-face [
        if all [
            triggers: select trigger-face/facets 'triggers
            find triggers id
        ] [
            do-face/from-trigger/only trigger-face id arg-value reactor
        ]
        exit
    ]
    foreach face select panel 'trigger-faces [
        if all [
            triggers: select face/facets 'triggers
            find triggers id
        ] [
            do-face/from-trigger/only face id arg-value reactor
        ]
    ]
    unless no-recursive [
        foreach sub-face faces? panel [
            unless empty? faces? sub-face [
                apply :do-triggers [sub-face id face trigger-face arg arg-value only reactor false]
            ]
        ]
    ]
]
init-effect-fly: funct [
    panel
    effect
] [
    faces: panel/faces
    dests: make block! length? faces
    foreach face faces [
        append dests face/gob/offset
        switch effect [
            fly-right
            fly-down [face/gob/offset: negate face/gob/size]
            fly-left
            fly-up [face/gob/offset: panel/gob/size + 2]
        ]
    ]
    dests
]
anim-effect-fly: funct [
    panel
    effect
    dests
] [
    foreach face panel/faces [
        dest: first+ dests
        size: face/gob/size
        inc: max 1x1 dest + size / 6
        xy: face/gob/offset
        switch effect [
            fly-right [xy/y: dest/y]
            fly-left [xy/y: dest/y inc: negate inc]
            fly-down [xy/x: dest/x]
            fly-up [xy/x: dest/x inc: negate inc]
        ]
        op: get pick [max min] negative? inc
        while [xy <> dest] [
            face/gob/offset: xy
            show face/gob
            wait 0.01
            xy: op dest xy + inc
        ]
        face/gob/offset: dest
        show face/gob
    ]
]
effect-panel: funct [
    "Display a panel transition effect."
    panel [object!] "Panel face"
    effect [word! none!] "Effect word"
] [
    switch effect [
        fly-right
        fly-left
        fly-up
        fly-down [dests: init-effect-fly panel effect]
    ]
    draw-face/no-show panel
    switch effect [
        fly-right
        fly-left
        fly-up
        fly-down [anim-effect-fly panel effect dests]
    ]
]
view-panel: func [
    panel
    child
] [
    extend panel 'faces reduce [child]
    append clear panel/gob child/gob
    show-later panel
]
switch-panel: funct [
    "Switch contents (faces) of a panel."
    top-panel [object!] "target"
    new-panel [object!] "source"
    effect [word! none!]
] [
    size: top-panel/gob/size
    margin: get-facet top-panel 'margin
    show clear top-panel/gob
    extend top-panel 'faces reduce [new-panel]
    append top-panel/gob new-panel/gob
    new-panel/gob/offset: margin
    s: size - margin - margin
    new-panel/gob/size: new-panel/facets/size: s
    new-panel/facets/area-size: s - 2x2
    collect-sizes top-panel
    do-style top-panel 'on-resize size
    do-triggers new-panel 'enter
    effect-panel new-panel effect
]
guie/font: context [
    name:
    parent:
    font:
    para:
    anti-alias:
    char-size:
    none
]
fontize: funct [
    "Define text styles (from dialect)."
    spec [block!]
] [
    name: parent: none
    assert-gui parse spec [
        some [
            spot:
            set name set-word!
            set parent opt word!
            set spec block! (make-text-style to-word name parent spec)
        ]
    ] ["Invalid font syntax:" spot]
]
make-text-style: funct [
    {Define a new font style (used for text face styles).}
    font-name [word!]
    font-parent [word! none!]
    spec [block! none!]
] [
    proto: either font-parent [guie/fonts/:font-parent] [guie/font]
    unless proto [warn-gui ["Unknown parent:" font-parent "- for font:" font-name]]
    style: make proto [
        name: font-name
        parent: font-parent
        font: make any [proto/font system/standard/font] select spec to-set-word 'font
        para: make any [proto/para system/standard/para] select spec to-set-word 'para
        anti-alias: any [select spec to-set-word 'anti-alias proto/anti-alias]
        char-size: font-char-size? self
    ]
    repend guie/fonts [font-name style]
]
what-font?: funct [
    {Given a name, return gui font object defined earlier. (helper)}
    name
] [
    any [
        guie/fonts/:name
        warn-gui ["missing font:" name]
        guie/fonts/base
    ]
]
face-font?: funct [
    {Given a face, return gui font object defined earlier. (helper)}
    face
] [
    what-font? any [get-facet face 'text-style 'base]
]
font-font?: func [name] [select what-font? name 'font]
face-char-size?: funct [
    "Returns font char-size field. (helper)"
    face
] [
    style: face-font? face
    style/char-size
]
text-key-map: context [
    face: none
    key: none
    shift?: none
    chars: [
        #"^H" [
            remove-text-face face -1
            clear-text-caret face
        ]
        #"^X" [
            remove-text-face face 1
            clear-text-caret face
        ]
        #"^C" [copy-text-face face]
        #"^V" [insert-text-face face load-clip-text]
        #"^-" [
            print "Warning: TAB in key area, please check!"
            process-tab event face
        ]
        #"^M" [
            either get-facet face 'lines [
                insert-text-face face pick [#"^-" #"^/"] key = tab
            ] [
                do-face face
                apply :find-tab-face? reduce [window-face? face shift?]
            ]
        ]
        #"^A" [select-all face]
        #"^[" [unfocus]
        #"^Q" [quit]
    ]
    control: [
        home head
        end tail
        up back-para
        down next-para
        left back-word
        right next-word
        delete delete-end
    ]
    words: [
        left right
        up down
        home end
        page-down page-up
        back-word next-word
        back-para next-para
        head tail [move-cursor face key 1 shift?]
        delete [remove-text-face face 1]
        delete-end [remove-text-face face 'end-line]
        deselect [select-none face/state]
        ignore [none]
    ]
    no-edit: [
        #"^H" left
        #"^X" #"^C"
        #"^V" ignore
        #"^M" ignore
        delete deslect
        delete-end deselect
    ]
]
do-text-key: funct [
    "Process text face keyboard events."
    face [object!]
    event [event!]
    key
] [
    text-key-map/face: face
    text-key-map/shift?: find event/flags 'shift
    if no-edit: get-facet face 'no-edit [
        key: any [select/skip text-key-map/no-edit key 2 key]
    ]
    either char? key [
        text-key-map/key: key
        switch/default key bind text-key-map/chars 'event [
            unless no-edit [
                insert-text-face face key
            ]
        ]
    ] [
        if find event/flags 'control [
            key: any [select text-key-map/control key key]
        ]
        text-key-map/key: key
        switch/default key text-key-map/words [return event]
    ]
    none
]
insert-text-face: funct [
    {Insert text into field or area at cursor/mark position.}
    face [object!]
    text
] [
    state: face/state
    if mhead: state/mark-head [
        t: head state/cursor
        state/cursor: mhead
        remove/part mhead state/mark-tail
        select-none state
        clear-text-caret face
    ]
    state/cursor: insert state/cursor text
    resize-text-face face
]
remove-text-face: funct [
    {Remove text from a field or area at cursor/mark position.}
    face [object!]
    len
    /clip
] [
    state: face/state
    either mhead: state/mark-head [
        mtail: state/mark-tail
        state/cursor: either positive? offset? mhead mtail [mhead] [mtail]
        select-none state
    ] [
        mhead: state/cursor
        mtail: len
        case [
            len = 'end-line [mtail: any [find mhead newline tail mhead]]
            negative? len [state/cursor: skip mhead len]
        ]
    ]
    text: take/part mhead mtail
    if clip [save-clip-text text]
    resize-text-face face
]
copy-text-face: funct [
    {Copy text from a field or area at cursor/mark position.}
    face
] [
    state: face/state
    either mhead: state/mark-head [
        save-clip-text copy/part mhead state/mark-tail
    ] [
        if get-facet face 'quick-copy [save-clip-text head face/cursor]
    ]
]
select-all: funct [
    "Select and mark all text in face"
    face
] [
    face/state/mark-head: head face/state/cursor
    face/state/cursor: face/state/mark-tail: tail face/state/cursor
    update-text-caret face
]
select-none: func [state] [
    state/mark-head: state/mark-tail: none
]
click-text-face: funct [
    "Make text face the focus and setup cursor."
    face
    cursor
    event
] [
    if block? cursor [cursor: first cursor]
    clear-text-caret face
    face/state/cursor: cursor
    face/state/xpos: none
    if event [
        case [
            find event/flags 'double [
                move-cursor face 'full-word 1 true
            ]
            all [
                find event/flags 'shift
                face/state/mark-head
            ] [
                face/state/mark-tail: cursor
            ]
            true [select-none face/state]
        ]
    ]
    focus face
]
save-clip-text: func [txt] [
    write clipboard:// to-binary enline txt
]
load-clip-text: does [
    to-string deline read clipboard://
]
make-text: funct [
    {Make a text draw command block, with all necessary attributes.}
    face
    body
] [
    remind-gui ["making text:" face/style]
    style: face-font? face
    out: make block! 6
    foreach field [font para anti-alias] [
        if style/:field [repend out [field style/:field]]
    ]
    if val: select face/state 'scroll [
        cs: negate max 0x0 face/facets/content-size
        repend out ['scroll as-pair val/x * cs/x val/y * cs/y]
    ]
    if val: select face/state 'caret [
        repend out ['caret val]
    ]
    append out body
]
make-text-gob: funct [face gsize text-data] [
    gob: make gob! [offset: 0x0 size: gsize data: face]
    fstyle: face-font? face
    gob/text: to-text append reduce [
        'font fstyle/font
        'para fstyle/para
        'anti-alias fstyle/anti-alias
        'scroll 0x0
        'caret select face/state 'caret
    ] text-data copy []
    gob
]
size-text-face: funct [
    face [object!]
    limit-size [pair!]
] [
    gob: make gob! [offset: 0x0 size: limit-size]
    fstyle: face-font? face
    gob/text: to-text reduce [
        'font fstyle/font
        'para fstyle/para
        'anti-alias fstyle/anti-alias
        any [
            select face/facets 'text-body
            select face/facets 'text-edit
        ]
    ] copy []
    fstyle/font/offset + fstyle/para/margin + fstyle/para/origin + size-text gob
]
font-char-size?: funct [fstyle] [
    gob: make gob! [offset: 0x0 size: 300x100]
    gob/text: to-text reduce [
        'font fstyle/font
        'para make fstyle/para [wrap?: off]
        'anti-alias fstyle/anti-alias
        "M"
    ] copy []
    size-text gob
]
resize-text-face: funct [
    face
] [
    face/state/xpos: none
    fstyle: face-font? face
    all [
        tgob: first face/gob
        size: size-text tgob
        tgob/size/y: -5 + second face/facets/viewport-box/bottom-right
        tgob/size/x: -5 + face/facets/gob-size/x - any [fstyle/para/margin/x 0]
    ]
]
init-text-caret: func [face] [
    face/state/caret: context [
        caret: copy ["" ""]
        highlight-start: copy ["" ""]
        highlight-end: copy ["" ""]
    ]
]
clear-text-caret: funct [face] [
    car: face/state/caret
    car/caret/1: car/highlight-start/1: car/highlight-end/1: copy ""
    car/caret/2: car/highlight-start/2: car/highlight-end/2: copy ""
]
update-text-caret: funct [face] [
    txt: face/gob/pane/1/text
    car: select txt 'caret
    txt: back tail txt
    car/caret/1: car/highlight-start/1: car/highlight-end/1: txt
    car/caret/2: face/state/cursor
    car/highlight-start/2: face/state/mark-head
    car/highlight-end/2: face/state/mark-tail
]
goto-caret: funct [
    "Set text caret to a specific position."
    face
    pos [string! integer! none!]
] [
    unless pos [exit]
    if string? pos [pos: index? pos]
    gob: first face/gob
    car: select gob/text 'caret
    txt: back tail gob/text
    car/caret/1: car/highlight-start/1: car/highlight-end/1: txt
    car/caret/2: face/state/cursor: at face/facets/text-edit pos
    car/highlight-start/2: none
    car/highlight-end/2: none
]
caret-xy?: funct [
    "Return cursor caret offset from text gob."
    gob
] [
    any [
        all [
            car: select gob/text 'caret
            car/caret/1
            car/caret/2
            caret-to-offset gob car/caret/1 car/caret/2
        ]
        0x0
    ]
]
see-caret: funct [
    "Force window to scroll for caret to be seen."
    face
] [
    tgob: first face/gob
    scro: select tgob/text 'scroll
    rowh: second face-char-size? face
    posy: rowh + second caret-xy? tgob
    tsiz: size-text-face face as-pair tgob/size/x 10000
    sizy: tgob/size/y
    case [
        posy < rowh [
            tgob/text/scroll/y: tgob/text/scroll/y - posy + rowh + 4
        ]
        posy > sizy [
            tgob/text/scroll/y: tgob/text/scroll/y - (posy - sizy)
        ]
    ]
]
move-caret: funct [
    "Move caret vertically. Return cursor string index."
    face
    action [word!]
] [
    tgob: sub-gob? face
    xy: caret-xy? tgob
    unless xy [return face/state/cursor]
    rowh: second face-char-size? face
    x: face/state/xpos: any [face/state/xpos xy/x]
    v: switch action [
        up [negate rowh]
        down [rowh]
        page-up [negate face/gob/size/y]
        right [face/gob/size/y]
    ]
    y: xy/y + (rowh / 2) + v
    caret: offset-to-caret tgob as-pair x y
    if empty? caret [
        caret: back tail caret
        caret/1: tail caret/1
    ]
    first caret
]
clear-all-carets: funct [
    "Clear all carets in a window/face"
    face
] [
    fields: tagged-faces face 'field
    foreach f fields [
        if in f/state 'caret [
            clear-text-caret f
        ]
    ]
]
guie/char-space: charset { ^-
^M/[](){}"}
guie/char-valid: complement guie/char-space
move-cursor: funct [
    {Move cursor up, down, left, right, home, end, or to a position.}
    face [object!]
    action [word!]
    count
    select? "Add to marked text (selection)"
] [
    state: face/state
    cursor: state/cursor
    sc: any [state/mark-head cursor]
    tc: none
    reset-x: true
    cursor: switch action [
        left [
            sc: any [state/mark-tail cursor]
            skip cursor negate count
        ]
        right [skip cursor count]
        down up
        page-down page-up [
            reset-x: false
            move-caret face action
        ]
        head [head cursor]
        tail [tail cursor]
        end [
            loop count [
                unless tc: find cursor newline [break]
                cursor: next tc
            ]
            any [tc tail cursor]
        ]
        home [
            loop count [
                unless tc: find/reverse/tail cursor newline [break]
                cursor: back tc
            ]
            any [tc head cursor]
        ]
        back-word [
            tc: cursor
            loop count [
                all [
                    tc
                    tc: find/reverse tc guie/char-valid
                    tc: find/reverse tc guie/char-space
                    tc: next tc
                ]
            ]
            any [tc head cursor]
        ]
        next-word [
            tc: next cursor
            loop count [
                all [
                    tc
                    tc: find tc guie/char-space
                    tc: find tc guie/char-valid
                ]
            ]
            any [tc tail cursor]
        ]
        back-para [
            tc: back cursor
            loop count [
                all [
                    tc
                    tc: find/reverse cursor newline
                    tc: find/reverse tc guie/char-space
                    tc: find/reverse/tail tc newline
                ]
            ]
            any [tc head cursor]
        ]
        next-para [
            tc: cursor
            loop count [
                all [
                    tc
                    tc: find cursor newline
                    tc: find tc guie/char-valid
                ]
            ]
            any [tc tail cursor]
        ]
        full-word [
            select?: true
            tc: cursor
            sc: any [
                find/reverse/tail tc guie/char-space
                head cursor
            ]
            cursor: any [
                find tc guie/char-space
                tail cursor
            ]
        ]
    ]
    if reset-x [state/xpos: none]
    either select? [
        set bind [mark-head mark-tail] state reduce either (index? sc) < index? cursor [[sc cursor]] [[cursor sc]]
    ] [
        clear-text-caret face
        select-none state
    ]
    state/cursor: cursor
]
base-handler: context [
    do-event: func [event] [
        print "(Missing event handler)"
        event
    ]
    win-gob: none
    status: 'made
    name: 'no-name
    priority: 0
    about: "Main template for VIEW event handlers."
]
handle-events: func [
    "Adds a handler to the view event system."
    handler [block!]
    /local sys-hand
] [
    handler: make base-handler handler
    sys-hand: system/view/event-port/locals/handlers
    unless foreach [here: hand] sys-hand [
        if handler/priority > hand/priority [
            insert here handler
            break/return true
        ]
    ] [
        append sys-hand handler
    ]
    handler/status: 'init
    debug-gui 'handler ["added for:" handler/name]
    handler
]
unhandle-events: func [
    "Removes a handler from the view event system."
    handler [object!]
] [
    remove find system/view/event-port/locals/handlers handler
    exit
]
handled-events?: func [
    {Returns event handler object matching a given name.}
    name
] [
    foreach hand system/view/event-port/locals/handlers [
        if hand/name = name [return hand]
    ]
    none
]
wake-events: funct [
    "Awake the prior DO-EVENTS WAIT call."
    handler
] [
    handler/status: 'wake
]
do-events: func [
    {Waits for window events. Returns when all windows are closed.}
] [
    debug-gui 'wait "entered"
    wait system/view/event-port
    debug-gui 'wait "exited"
]
init-view-system: func [
    "Initialize the View event subsystem."
    /local ep
] [
    init system/view/screen-gob: make gob! [text: "Top Gob"] system/view/metrics
    if system/view/event-port [exit]
    ep: open [scheme: 'event]
    system/view/event-port: ep
    ep/locals: context [handlers: copy []]
    ep/awake: funct [event] [
        either all [
            obj: event/window/data
            obj: select obj 'handler
        ] [
            event: obj/do-event event
        ] [
            print "A mystery GUI event?"
            halt
        ]
        if obj/status = 'wake [
            obj/status: 'awake
            unhandle-events obj
            debug-gui 'handler ["Awake from WAIT:" obj/name]
            return true
        ]
        tail? system/view/screen-gob
    ]
]
gui-events: context [
    handlers: none
    over-face:
    over-where:
    drag:
    none
    outside-event?: false
    handlers: context [
        down: up: context [
            down-face: none
            do-event: func [event] [
                down-face: handler/(event/type)/do-event event down-face
            ]
            handler: context [
                down:
                alt-down:
                aux-down: context [
                    do-event: func [event face /local where] [
                        where: event/offset
                        event: map-event event
                        face: any [all [outside-event? guie/popup-face] event/gob/data]
                        if face [
                            until [
                                event: do-style face 'on-click event
                                if any [
                                    none? event
                                    none? parent-face? face
                                ] [break]
                                face: parent-face? face
                                event
                            ]
                            if object? event [
                                drag: event
                                drag/start: where
                            ]
                        ]
                        face
                    ]
                ]
                up:
                alt-up:
                aux-up: context [
                    do-event: func [event down-face /local face] [
                        if all [drag drag/gob] [
                            show drag/gob
                            remove find/last event/window drag/gob
                            cursor system-cursors/arrow
                        ]
                        event: map-event event
                        face: any [all [outside-event? guie/popup-face] event/gob/data]
                        if face [event/offset: do-style face 'locate event]
                        case/all [
                            all [down-face not drag down-face = face] [do-style down-face 'on-click event]
                            all [drag drag/gob drag/gob/offset = drag/base-offset] [
                                do-style drag/face 'on-click event
                                drag: none
                            ]
                            all [drag drag/gob] [
                                f: face
                                drag/event: event
                                while [all [f not ret: do-style f 'on-drop drag]] [
                                    drag/event/offset: drag/event/offset + f/gob/offset
                                    f: parent-face? f
                                ]
                                unless ret [
                                    do-style drag/face 'on-over none
                                    base-pos: drag/base-offset + get-gob-offset drag/origin
                                    delta: base-pos - drag/gob/offset / 10
                                    loop 11 [
                                        drag/gob/offset: drag/gob/offset + delta
                                        show drag/gob
                                        wait 0.012500000000000001
                                    ]
                                    drag/gob/offset: drag/base-offset
                                    insert guie/drag/origin drag/gob
                                    win: window-face? drag/face
                                    show win/gob
                                ]
                                drag: none
                            ]
                            drag [drag: none]
                        ]
                        none
                    ]
                ]
            ]
        ]
        alt-down: alt-up: make down []
        aux-down: aux-up: make down []
        move: context [
            do-event: func [event /local face where window] [
                either drag [
                    either not drag/gob [
                        drag/delta: event/offset - drag/start
                        if any [drag/active not zero? drag/delta] [
                            drag/active: true
                            drag/event: map-event event
                            do-style drag/face 'on-drag drag
                        ]
                    ] [
                        if any [drag/active greater? sum-pair abs drag/start - event/offset 2] [
                            drag/active: true
                            extend drag 'offset event/offset
                            window: event/window
                            do-style drag/face 'on-drag drag
                            remove find/last event/window drag/gob
                            event: map-event event
                            face: event/gob/data
                            append window drag/gob
                            show-later either drag/show-parent? [drag/show-parent?: false drag/gob/parent] [drag/gob]
                            where: do-style face 'locate event
                            if all [
                                any [
                                    face <> over-face
                                    where <> over-where
                                ]
                                any [
                                    do-style/bubble face 'on-drag-over reduce [drag where yes] (
                                        cursor system-cursors/no
                                        false
                                    )
                                ]
                            ] [
                                cursor system-cursors/arrow
                                if over-face [
                                    do-style over-face 'on-drag-over reduce [drag over-where no]
                                ]
                                do-style face 'on-drag-over reduce [drag where yes]
                            ]
                            over-face: face
                            over-where: where
                        ]
                    ]
                ] [
                    event: map-event event
                    face: any [all [outside-event? guie/popup-face] event/gob/data]
                    if face [
                        do-style face 'on-move event
                        either over-face <> face [
                            if over-face [do-style over-face 'on-over none]
                            over-face: face
                            do-style face 'on-over event/offset
                        ] [
                            if get-facet face 'all-over [
                                do-style face 'on-over event/offset
                            ]
                        ]
                    ]
                ]
            ]
        ]
        resize: context [
            do-event: func [event] [
                do-style event/window/data 'on-resize event/offset
                clear guie/shows
                draw-face event/window/data
            ]
        ]
        key: key-up: context [
            do-event: func [event /local win face] [
                either face: guie/focal-face [
                    until [
                        if event/key = #"^-" [process-tab event face break]
                        event: do-style face 'on-key event
                        not all [face: parent-face? face event? event]
                    ]
                ] [
                    event: do-style event/window/data 'on-key event
                ]
            ]
        ]
        close: context [
            do-event: func [event] [
                do-style event/window/data 'on-close event
                unview/only event/window
            ]
        ]
        restore: offset: minimize: maximize: context [
            do-event: func [event] [
                do-style event/window/data 'on-window event
            ]
        ]
        scroll-line: scroll-page: context [
            do-event: func [event /local face] [
                if over-face [
                    face: over-face
                    until [
                        event: do-style face 'on-scroll-event event
                        not all [face: parent-face? face event? event]
                    ]
                ]
            ]
        ]
        drop-file: context [
            do-event: func [event /local gob ofs face where] [
                print "drop-file"
                event: map-event event
                face: event/gob/data
                event/offset: do-style face 'locate event
                do-style face 'on-drop event
            ]
        ]
    ]
    guie/handler: [
        name: 'gui
        priority: 0
        do-event: func [event] [
            debug-gui 'events [event/type event/offset]
            outside-event?: all [guie/popup-face event/gob/data <> guie/popup-face]
            handlers/(event/type)/do-event event
            show-now
            none
        ]
    ]
]
black: 0.0.0
coal: 64.64.64
gray: 128.128.128
pewter: 170.170.170
silver: 192.192.192
snow: 240.240.240
white: 255.255.255
blue: 0.0.255
green: 0.255.0
cyan: 0.255.255
red: 255.0.0
yellow: 255.255.0
magenta: 255.0.255
navy: 0.0.128
leaf: 0.128.0
teal: 0.128.128
maroon: 128.0.0
olive: 128.128.0
purple: 128.0.128
orange: 255.150.10
oldrab: 72.72.16
brown: 139.69.19
coffee: 76.26.0
sienna: 160.82.45
crimson: 220.20.60
violet: 72.0.90
brick: 178.34.34
pink: 255.164.200
gold: 255.205.40
tan: 222.184.135
beige: 255.228.196
ivory: 255.255.240
linen: 250.240.230
khaki: 179.179.126
rebolor: 142.128.110
wheat: 245.222.129
aqua: 40.100.130
forest: 0.48.0
water: 80.108.142
papaya: 255.80.37
sky: 164.200.255
mint: 100.136.116
lime: 40.200.40
reblue: 38.58.108
base-color: 200.200.200
yello: 255.240.120
request: funct [
    {Open a requestor modal dialog box. Returns result: true false none}
    title [string!]
    message [string!]
    /warn "Important message to user"
    /ask "Ask user a question (yes/no)"
    /cancel "Add a cancel button (returns as false)"
] [
    btns: make block! 4
    if ask [append btns [button "Yes" close true button "No" close false]]
    if any [warn not ask] [append btns [button "Ok" close true]]
    if cancel [append btns [button "Cancel" close false]]
    win-gob: view/modal/options compose/deep/only [
        panel 240.100.80 [title (title)]
        group [
            doc (message)
            scroller
        ] options [margin: 5x5]
        group (btns)
    ] [margin: 0x0 area-color: silver]
    get-face win-gob/data
]
alert: func [
    "Open an alert reqeustor."
    message [string! block!]
] [
    request/warn "Alert" reform message
]
locate-popup: funct [
    {Return the absolute coordinates for a popup below the given face.}
    face [object!]
] [
    set [gob: xy:] map-gob-offset/reverse face/gob 0x0
    face/gob/size * 0x1 + gob/offset + xy
]
if command? :show [show-native: :show]
show: funct [gob] [
    update-subgobs gob
    show-native gob
]
update-subgobs: funct [gob] [
    foreach g gob/pane [
        update-subgobs g
    ]
    all [
        gob/data
        in gob/data 'gob
        gob = gob/data/gob
        gd: gob/data/draw-result
        not any [gob/text gob/color gob/effect]
        to-draw gd gob/draw: any [all [gob/draw clear gob/draw] copy []]
    ]
]
show-later: funct [
    item [gob! object! block! none!]
] [
    if object? item [item: select item 'gob]
    if item [
        remind-gui/when ["dup-show:" mold item] find guie/shows item
        append guie/shows item
    ]
]
show-now: has [list out] [
    unless empty? list: guie/shows [
        remind-gui/when ["show queue length:" length? list] (length? list) > 2
        out: clear []
        foreach f list [
            unless find out f [append out f]
        ]
        foreach f out [show f]
        clear list
    ]
]
view: funct [
    {Displays a window view from a layout block, face (panel), or low level graphics object (gob).}
    spec [block! object! gob!] "Layout block, face object, or gob type"
    /options opts [block!] "Optional features, in name: value format"
    /modal "Display a modal window (pop-up)"
    /no-wait "Return immediately - do not wait"
    /across {Use horizontal layout for top panel (rather than vertical)}
    /as-is {Use GOB exactly as passed - do not add a parent gob}
] [
    unless screen: system/view/screen-gob [return none]
    opts: make map! reduce/no-set any [opts []]
    if modal [opts/modal: true]
    if no-wait [opts/no-wait: true]
    if across [opts/break-after: 0]
    if as-is [opts/as-is: true]
    case [
        block? spec [
            win-face: make-window-panel spec opts
            win-gob: win-face/gob
        ]
        object? spec [
            win-face: spec
            win-gob: win-face/gob
            opts/handler: guie/handler
            append win-face 'handler
            do-style win-face 'on-update none
            do-style win-face 'on-resize win-face/facets/init-size
            draw-face win-face
        ]
        gob? spec [
            either as-is [win-gob: spec] [
                win-gob: make-window-gob spec opts
            ]
        ]
    ]
    win-gob/text: any [opts/title win-gob/text "REBOL: untitled"]
    ds: screen/size - win-gob/size
    pos: any [
        opts/offset
        if last-win: last screen [
            max 0x0 last-win/size - win-gob/size / 2 + last-win/offset
        ]
        'center
    ]
    win-gob/offset: case [
        pair? pos [pos]
        word? pos [
            max 5x5 switch pos [
                top-left [0x0]
                top-right [ds * 1x0]
                bottom-left [ds * 0x1]
                bottom-right [ds]
                center [ds / 2]
            ]
        ]
        true [0x0]
    ]
    win-gob/offset/y: max win-gob/offset/y system/view/metrics/title-size/y + system/view/metrics/border-size/y
    opts/flags: any [opts/flags copy [resize]]
    if opts/no-resize [
        alter opts/flags 'resize
    ]
    if opts/modal [
        if last screen [
            win-gob/owner: last screen
            append opts/flags [modal popup on-top no-title]
        ]
        if win-face [win-face/state/value: none]
    ]
    if opts/owner [
        win-gob/owner: opts/owner
    ]
    if opts/handler [
        handler: handle-events opts/handler
        handler/win-gob: win-gob
        win-gob/data/handler: handler
    ]
    if opts/reactors [
        if win-face [extend win-face 'reactors opts/reactors]
    ]
    win-gob/flags: opts/flags
    unless win-gob = screen [append screen win-gob]
    show win-gob
    wait-now: all [
        any [modal 1 = length? screen]
        not opts/no-wait
    ]
    if win-face [do-triggers win-face 'enter]
    show-now
    if wait-now [
        if handler [handler/status: 'active]
        do-events
    ]
    win-gob
]
unview: funct [
    {Closes a window view. Wakes up a prior WAIT if necessary.}
    /all "Close all views."
    /only "Close a single view. Window face or GOB."
    window [object! gob!]
] [
    screen: system/view/screen-gob
    case [
        all [show clear screen exit]
        gob? window [win-gob: window]
        object? window [win-gob: window/gob]
        true [win-gob: last screen]
    ]
    remove find screen win-gob
    show win-gob
    if all [
        window: win-gob/data
        handler: select window 'handler
        handler/status = 'active
    ] [
        wake-events handler
    ]
    win-gob
]
make-window-panel: funct [
    content [block!]
    opts [map!]
] [
    win-face: make-face 'window append compose/deep [content: [backdrop [(content)]]] to-block opts
    win-face/gob/text: find-title-text win-face/gob/1/data
    append win-face 'handler
    do-style win-face 'on-update none
    do-style win-face 'on-resize win-face/facets/init-size
    draw-face/no-show win-face
    unless opts/handler [opts/handler: guie/handler]
    clear guie/shows
    win-face
]
make-window-gob: funct [
    spec [gob!]
    opts [map!]
] [
    either opts/as-is [
        window: spec
    ] [
        spec/offset: 0x0
        window: make gob! [size: spec/size text: "Window"]
        append window spec
    ]
    if any [
        opts/color
        opts/draw
    ] [
        spec: copy [
            size: window/size
            offset: 0x0
        ]
        if opts/color [append spec [color: opts/color]]
        if opts/draw [append spec [draw: to-draw opts/draw copy []]]
        insert window make gob! spec
    ]
    unless opts/handler [opts/handler: gob-handler]
    window/data: make object! [
        handler: none
        options: opts
    ]
    window
]
gob-handler: [
    name: 'gob
    about: "Low level handler for VIEW of simple GOBs."
    priority: 50
    do-event: func [event] [
        print ["view-event:" event/type event/offset]
        either switch event/type [
            close [true]
            key [event/key = escape]
        ] [
            unview/only event/window
        ] [
            show event/window
        ]
        none
    ]
]
issue-id: funct [
    "Issue unique id"
    pool [block! map!] "Where to look for issued ids"
] [
    id: make string! 8
    loop 8 [append id first random "abcdefghijklmnopqrstuvwxyz0123456789"]
    if map? pool [pool: words-of pool]
    either find pool id [issue-id pool] [id]
]
inside?: funct [
    "Check if pair is inside two pairs box"
    value [pair!]
    top-left-corner [pair!]
    bottom-right-corner [pair!]
] [
    not any [(t: value - top-left-corner) <> abs t (t: bottom-right-corner - value) <> abs t]
]
ifv: func [
    {If condition is true assign block's value to word otherwise keep curent value}
    :value
    condition
    then-block
] [
    either condition [set value do then-block] [get value]
]
if=: func [
    {If condition has value, return it, otherwise evaluate the block.}
    condition
    then-block
] [
    either condition [condition] then-block
]
ift: func [
    {If condition is TRUE, evaluates the block. Returns TRUE otherwise.}
    condition
    then-block
] [
    either condition then-block [true]
]
limit: func ["Limit number in between boundaries"
    number [number!] "Number to limit"
    min-value [number!] "Lower boundary"
    max-value [number!] "Highwe boundary"
] [
    min max-value max min-value number
]
limit?: func [{Return TRUE if number is in between boundaries, FALSE otherwise}
    number [number!] "Number to limit"
    min-value [number!] "Lower boundary"
    max-value [number!] "Highwe boundary"
] [
    all [number <= max-value number >= min-value]
]
auto-complete: func [{Return list of all itemps that begin with the string}
    list [block!] "List of available choices"
    string [char! string!] "String to search"
    /index "Return index of first match"
    /local len
] [
    local: copy []
    string: to string! string
    len: length? string
    forall list [
        all [
            equal? string copy/part to string! list/1 len
            append local list/1
            index
            return index? list
        ]
    ]
    either index [none] [local]
]
show-tooltip: funct [
    tooltip [object!]
    parent-face [object!]
] [
    win: window-face? parent-face
    tooltip/gob/offset: parent-face/gob/size * 0x1 + second map-gob-offset/reverse parent-face/gob 1x1
    tooltip/style: 'tooltip
    append win/gob tooltip/gob
    show tooltip/gob
]
hide-tooltip: funct [
    face [object!] "Face from window where to close tooltip"
] [
    win: window-face? face
    faces: faces? win
    until [
        either all [tt: first faces 'tooltip = tt/style] [
            tt: tt/gob
            tt/alpha: tt/color: tt/draw: tt/image: tt/text: tt/pane: none
            show-native tt
            remove at win/gob index? faces
        ] [
            faces: next faces
        ]
        tail? faces
    ]
]
show-popup: funct ["Displays a popup view"
    popup [gob! block! object!] "Popup gob, VID face, or VID layout block"
    parent-face [object!] "Parent face that opens popup"
    /offset offs
    /size siz
] [
    main-win: window-face? parent-face
    if not siz [
        siz: as-pair parent-face/gob/size/x 120
    ]
    off: main-win/gob/offset + (second map-gob-offset/reverse parent-face/gob 1x1) + (0x1 * parent-face/gob/size) - 0x2
    if offs [off: off + offs]
    popup: view/options popup [
        owner: main-win/gob
        flags: [popup on-top no-title]
        as-is: true
        offset: off
        init-size: siz - 2x0
        border-size: [-5x-5 -5x-5]
    ]
    guie/popup-face: popup/data
    guie/popup-parent: parent-face
    guie/popup-face
]
hide-popup: funct [
    "Close popup view"
] [
    if guie/popup-face [
        unview/only guie/popup-face
        unhandle-events guie/popup-face/handler
        guie/focal-face:
        guie/popup-face:
        guie/popup-parent: none
    ]
]
do-popup-parent: func [
    "Call a popup's parent style actor function."
    act [word!] "Actor identifier"
    data {Argument to the actor (use block for multiple args).}
] [
    do-style guie/popup-parent :act :data
    do-face guie/popup-parent
]
place-popup: funct [
    "Place popup where the popup's parent is."
] [
    main-win: window-face? guie/popup-parent
    guie/popup-face/gob/offset: main-win/gob/offset + (second map-gob-offset/reverse guie/popup-parent/gob 1x1) + (0x1 * guie/popup-parent/gob/size)
]
get-style-actors: funct [
    style-name [word!]
] [
    style: select guie/styles style-name
    words-of style/actors
]
specular-functions: reduce [
    'mul func [c v] [
        c * v
    ]
    'linear func [c v] [
        c * v
    ]
    'high func [c v] [
        c * v + min 255 to-integer max 0 800 * v - 545
    ]
    'avg func [c v] [
        to-tuple reduce [
            min 255 255 * v + c/1 * v / 2
            min 255 255 * v + c/2 * v / 2
            min 255 255 * v + c/3 * v / 2
        ]
    ]
]
set-opacity: func [
    "Sets opacity for a single color between 0 and 100%"
    color [tuple!]
    v [integer! decimal! percent!]
] [
    color/4: 1 - v * 255
    color
]
make-gradient: funct [
    {Build a gradient color span based on a material object.}
    color [tuple!]
    mat-obj [object!] "Material object"
] [
    fn: any [
        select specular-functions mat-obj/specular
        select specular-functions 'mul
    ]
    out: make block! length? mat-obj/diffusion
    foreach v mat-obj/diffusion [
        append out case [
            percent? :v [
                to-decimal v
            ]
            tuple? :v [
                v
            ]
            number? :v [
                set-opacity fn color v * mat-obj/intensity mat-obj/opacity
            ]
        ]
    ]
]
make-material: funct [
    {Adds a materials facet to face from material's name.}
    face [object!] "Face object"
    material [word! none!] "Material's name"
    /color clr [tuple!] "Optional color to use"
    /facet fct [word!] {Optional facet to use to get color (standard is 'area-color)}
] [
    unless material [exit]
    if not facet [fct: 'area-color]
    if not color [clr: get-facet face fct]
    mat-obj: make object! []
    mat: materials/:material
    foreach mode words-of mat [
        mm: mat/:mode
        repend mat-obj [
            mode
            either tuple? mm/diffusion [
                mm/diffusion
            ] [
                make-gradient clr mm
            ]
        ]
    ]
    set-facet face 'materials mat-obj
]
set-material: funct [
    {Chooses the gradient from a material object to use with a face mode}
    face [object!]
    mode [word! none!]
] [
    all [
        mat: get-facet face 'materials
        set-facet face 'area-fill any [
            all [mode select mat mode]
            select mat 'up
            select mat first words-of mat
        ]
    ]
]
use-material: func [
    "Gets a gradient or color directly from a material"
    color [tuple!]
    'material [word!]
] [
    set-material make-material color (material) none
]
make-color: funct [
    {Creates a material object from a material asset and an input color and intensity}
    color [tuple!]
    intensity [number!]
    'material [word!]
] [
    mat: materials/:material
    mat-obj: make object! []
    foreach mode words-of mat [
        repend mat-obj [
            mode
            do select specular-functions
            get in get in mat first words-of mat 'specular
            color
            intensity
        ]
    ]
    mat-obj
]
set-color: func [
    {Chooses the color from a material object to use with a face mode}
    mat [object!]
    mode [word! none!]
] [
    set-material mat mode
]
use-color: func [
    "Gets a color directly from a material"
    color [tuple!]
    intensity [number!]
    'material [word!]
] [
    set-color make-color color intensity (material) none
]
fontize [
    base: [
        para: [
            origin: 0x0
            margin: 0x0
        ]
        font: [
            color: black
            size: 12
            name: "Arial"
            offset: 0x0
        ]
        anti-alias: off
    ]
    bold: base [
        font: [
            style: 'bold
        ]
    ]
    field: base [
        para: [
            origin: 1x2
            margin: 0x0
            wrap?: false
            valign: 'top
        ]
    ]
    area: base [
        para: [
            origin: 4x4
            margin: 0x4
            wrap?: true
        ]
    ]
    info: field [
        para: [
            valign: 'top
        ]
        anti-alias: on
    ]
    info-area: info [
        para: [
            wrap?: true
        ]
    ]
    head-bar: [
        font: [
            color: black
            size: 12
            style: 'bold
            name: "Arial"
        ]
        para: [
            origin: 4x0
            valign: 'middle
        ]
        anti-alias: on
    ]
    centered: base [
        para: [
            margin: 0x0
            origin: 0x0
            align: 'center
            valign: 'middle
        ]
    ]
    button: centered [
        font: [
            color: snow
            style: 'bold
            size: 12
            shadow: [0x1 2]
        ]
        para: [
            origin: -5x-2
            wrap?: false
        ]
        anti-alias: on
    ]
    title: base [
        font: [
            size: 16
            style: 'bold
        ]
        para: [
            origin: 0x0
            wrap?: false
            align: 'left
            valign: 'top
        ]
        anti-alias: on
    ]
    label: base [
        font: [
            style: 'bold
            align: 'right
        ]
        para: [
            origin: 4x2
        ]
        anti-alias: on
    ]
    radio: base [
        para: [
            origin: 18x0
            valign: 'middle
        ]
    ]
    list-item: base [
        para: [
            wrap?: false
        ]
        anti-alias: off
    ]
    code: base [
        font: [
            name: "courier new"
        ]
        anti-alias: off
    ]
]
stylize [
    face: [
        about: "A special style used passing pre-built faces."
        options: [
            content: [object!]
            init-size: [pair!]
        ]
    ]
    backdrop: [
        facets: [
            init-size: 0x0
            bg-color: 200.200.200
            break-after: 1
            padding: [5x5 5x5]
            spacing: 5x5
        ]
        options: [
            content: [block!]
            init-size: [pair!]
            bg-color: [tuple!]
        ]
        actors: [
            on-make: [
                make-panel face 'panel
                face/gob/color: get-facet face 'bg-color
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                resize-panel face/gob
            ]
            on-update: [
                update-panel face/gob
            ]
            on-content: [
                do-style/style face 'on-content arg 'hpanel
            ]
        ]
    ]
    window: [
        about: "A special style used by system for window panels."
        tags: [form]
        facets: [
            tab-face: none
            init-size: 0x0
        ]
        actors: [
            on-make: [
                make-panel face 'panel
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                resize-panel face/gob
                do-style face 'on-popup none
            ]
            on-update: [
                update-panel face/gob
            ]
            on-content: [
                do-style/style face 'on-content arg 'hpanel
            ]
            on-window: [
                if all [arg/type = 'offset face <> guie/popup-face] [
                    do-face/only face 'moved
                    do-style face 'on-popup none
                ]
                none
            ]
            on-popup: [
                if guie/popup-face [
                    place-popup
                    show-later guie/popup-face/gob
                ]
            ]
            on-key: [
                if arg/type = 'key [
                    if arg/key = #"^-" [tab-face: process-tab arg face]
                    if any [
                        tag-face? tab-face 'state
                        tag-face? tab-face 'action
                    ] [
                        down-click: make event! [type: 'down]
                        up-click: make event! [type: 'up]
                        if arg/key = #" " [
                            do-style tab-face 'on-click down-click
                            do-style tab-face 'on-click up-click
                        ]
                        if arg/key = #"^M" [
                            do-style tab-face 'on-click down-click
                            do-style tab-face 'on-click up-click
                        ]
                    ]
                ]
            ]
            on-click: [
                hide-popup
                none
            ]
            on-set: [face/state/value: arg/2]
            on-get: [face/state/value]
        ]
    ]
    hgroup: [
        about: {For spaced groups. No background or borders. Default horizontal.}
        tags: [panel]
        facets: [
            init-size: 0x0
            layout-mode: 'horizontal
            padding: [3x3 3x3]
            spacing: 3x3
        ]
        options: [
            content: [block!]
            init-size: [pair!]
            bg-color: [tuple!]
        ]
        actors: [
            on-make: [
                make-panel face 'group
            ]
            on-attach: [
                extend-face face 'attached arg
                set-face arg face/state/value
            ]
            on-content: [
                switch arg/1 [
                    clear [
                        remove-from-group face/gob arg/3 arg/4
                        if trigger-faces: select face 'trigger-faces [clear trigger-faces]
                        bind-faces face
                        apply :update-face [face arg/2 true]
                        face
                    ]
                    insert [
                        content: arg/3
                        index: arg/4
                        trigs: insert-into-group face/gob index content
                        bind-faces face
                        do-style content 'on-init none
                        all [
                            trigs
                            extend-face face 'trigger-faces trigs
                            do-style trigs 'on-init none
                        ]
                        do-triggers/no-recursive face 'load
                        apply :update-face [face arg/2 true]
                        face
                    ]
                    remove [
                        index: arg/3
                        range: arg/4
                        apply :remove-from-group [face/gob index range]
                        bind-faces face
                        apply :update-face [face arg/2 true]
                        face
                    ]
                ]
            ]
            on-scroll: [
                gob: face/gob
                sgob: sub-gob? face
                bars: face/attached
                if all [bars sgob] [
                    axis: face-axis? arg
                    sgob/offset/:axis: negate (sgob/size/:axis + (2 * face/facets/spacing/:axis)) - gob/size/:axis * arg/state/value - face/facets/spacing/:axis
                    show sgob
                ]
            ]
            on-set: [
                if all [arg/1 = 'value block? arg/2] [set-panel face arg/2]
            ]
            on-get: [
                get-panel face
            ]
            on-clear: [
                clear-panel face
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                resize-group face/gob
            ]
            on-update: [
                update-group face/gob
            ]
        ]
    ]
    vgroup: hgroup [
        facets: [
            layout-mode: 'vertical
        ]
    ]
    hpanel: hgroup [
        about: "For grouping faces with a background and borders."
        tags: [panel]
        facets: [
            bg-color:
            area-color: silver
            border-color: coal
            init-size: 0x0
            break-after: 0
            draw-mode: 'plain
            layout-mode: 'horizontal
            area-fill: none
            border-size: [1x1 1x1]
            material: 'container-groove
        ]
        options: [
            content: [block! object!]
            init-size: [pair!]
            bg-color: [tuple!]
            break-after: [integer!]
        ]
        draw: [
            plain: []
            gradient: [
                clip margin-box/top-left margin-box/bottom-right
                pen none
                line-width 0
                grad-pen linear 1x1 0 gob-size/y 90 area-fill
                box (margin-box/top-left + 1) (margin-box/bottom-right - 1) 1
            ]
        ]
        actors: [
            on-make: [
                make-material face get-facet face 'material
                set-material face 'up
                all [
                    get-facet face 'area-fill
                    set-facet face 'draw-mode 'gradient
                ]
                make-panel face 'panel
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                resize-panel face/gob
            ]
            on-update: [
                update-panel face/gob
            ]
            on-content: [
                switch arg/1 [
                    clear [
                        clear at face/gob arg/3
                        if trigger-faces: select face 'trigger-faces [clear trigger-faces]
                        bind-faces face
                        apply :update-face [face arg/2 true]
                    ]
                    insert [
                        content: arg/3
                        index: arg/4
                        trigs: none
                        foreach f content [
                            if t: select f/facets 'triggers [
                                unless trigs [
                                    trigs: make block! 2
                                ]
                                append trigs f
                            ]
                            if any [none? t find t 'visible-trigger] [
                                insert at face/gob index f/gob
                                ++ index
                            ]
                        ]
                        bind-faces face
                        do-style content 'on-init none
                        all [
                            trigs
                            extend-face face 'trigger-faces trigs
                            do-style trigs 'on-init none
                        ]
                        do-triggers/no-recursive face 'load
                        apply :update-face [face arg/2 true]
                    ]
                    remove [
                        index: arg/3
                        range: arg/4
                        apply :remove [at face/gob index range range]
                        bind-faces face
                        apply :update-face [face arg/2 true]
                    ]
                ]
            ]
        ]
    ]
    vpanel: hpanel [
        facets: [
            layout-mode: 'vertical
        ]
    ]
    htight: hpanel [
        about: {Tightly spaced and packed group. No background or borders. Horizontal default.}
        tags: [panel]
        facets: [
            margin: [0x0 0x0]
            padding: [0x0 0x0]
            spacing: 0x0
            border-size: [0x0 0x0]
        ]
    ]
    vtight: htight [
        facets: [
            layout-mode: 'vertical
        ]
    ]
    tight: vtight []
    tooltip: [
        about: "Fake style."
        tags: [internal]
        facets: []
        actors: []
    ]
    pad: [
        about: "Padding for blank spaces."
        facets: [
            init-size: 10x10
            bg-color: none
        ]
        options: [
            init-size: [pair!]
        ]
    ]
    when: [
        about: "A special style for defining panel triggers."
        facets: [
            triggers: []
        ]
        options: [
            triggers: [block!] "Trigger words"
        ]
    ]
    data: when [
        about: "A special style for storing data."
        options: [
            block: [block!] "Block will REDUCE immediately"
        ]
        facets: [
            triggers: [load]
        ]
        actors: [
            on-init: [
                block: get-facet face 'block
                if none? block [block: copy []]
                face/state/value: reduce block
            ]
        ]
    ]
    embed: data [
        about: {A special style for including data values in SUBMIT.}
        tags: [field input]
    ]
    tags: when [
        about: {A special style that defines tags for the previously laid out face.}
        options: [
            block: [block!] "Block will REDUCE immediately"
        ]
        facets: [
            triggers: [load]
        ]
        actors: [
            on-init: [
                probe face/gob/parent
                probe get-facet face 'block
            ]
        ]
    ]
    plane: [
        about: {A lean sub-panel used as a scroll frame. No internal resizing.}
        tags: [internal]
        facets: [
            init-size: 400x200
            break-after: 1
        ]
        options: [
            panel-face: [object!]
        ]
        actors: [
            on-make: [
                make-panel face 'panel
                set-panel-content face get-facet face 'panel-face
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                resize-panel face/gob
            ]
            on-attach: [
                extend-face face 'attached arg
                set-face face face/state/value
            ]
            on-scroll: [
                pgob: face/gob
                unless gob: sub-gob? face [exit]
                size: negate max 0x0 gob/size - pgob/size
                offset: size * get-face arg
                axis: face-axis? arg
                xy: gob/offset
                xy/:axis: offset/:axis
                gob/offset: xy
                show-later face
                true
            ]
            on-scroll-event: [
                dy: none
                switch arg/type [
                    scroll-line [dy: arg/offset/y / -30]
                    scroll-page [dy: negate arg/offset/y]
                ]
                if all [dy bars: select face 'attached] [
                    do-style first bars 'on-bump-scroll dy
                ]
                none
            ]
            on-set: []
        ]
    ]
]
stylize [
    clicker: [
        about: {Single-action button without text. Basis of other styles.}
        tags: [internal]
        facets: [
            init-size: 28x28
            area-color: 80.100.120
            edge-color: 0.0.0.128
            pen-color:
            area-fill:
            material: 'chrome
            focus-color: red
            draw-mode: 'normal
            materials: none
        ]
        options: [
            init-size: [pair!]
            area-color: [tuple!]
        ]
        draw: [
            normal: [
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 (viewport-box/bottom-right/y) 90 area-fill
                box 1x1 (viewport-box/bottom-right - 2) 1
            ]
            focus: [
                fill-pen focus-color
                box -1x-1 viewport-box/bottom-right 5
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 (viewport-box/bottom-right/y) 90 area-fill
                box 1x1 (viewport-box/bottom-right - 2) 1
            ]
        ]
        actors: [
            on-init: [
                set-facet face 'materials make-material face get-facet face 'material
            ]
            on-draw: [
                set-material face face/state/mode
                color: get-facet face 'edge-color
                if face/state/mode = 'over [color: color / 2]
                face/facets/pen-color: color
                arg
            ]
            on-over: [
                face/state/mode: pick [over up] face/state/over: not not arg
                draw-face face
            ]
            on-click: [
                face/state/mode: arg/type
                if 'up = face/state/mode [face/state/mode: 'over]
                draw-face face
                if arg/type = 'up [focus face do-face face]
                none
            ]
            on-focus: [
                set-facet face 'draw-mode either arg ['focus] ['normal]
                set-facet face 'focus-color either arg [red] [255.255.255.255]
                draw-face face
            ]
            on-key: [
                if arg/type = 'key [
                    switch arg/key [
                        #" " [do-face face]
                    ]
                ]
            ]
        ]
    ]
    button: clicker [
        about: "Single action button with text."
        tags: [action tab]
        facets: [
            init-size: 130x24
            text-body: "Button"
            text-style: 'button
            max-size: 260x24
            min-size: 80x24
        ]
        options: [
            text-body: [string! block!]
            area-color: [tuple!]
            init-size: [pair!]
            wide: [percent!]
        ]
        actors: [
            on-set: [
                if arg/1 = 'value [
                    face/facets/text-body: form any [arg/2 ""]
                    show-later face
                ]
            ]
            on-get: [
                if arg = 'value [
                    face/facets/text-body
                ]
            ]
        ]
    ]
    toggle: button [
        about: "Dual action button with text and LED indicator."
        tags: [action tab]
        facets: [
            led-colors: reduce [green coal]
            text-body: "Toggle"
            led-color: none
            material: 'aluminum
        ]
        options: [
            text-body: [string! block!]
            area-color: [tuple!]
            orig-state: [logic!]
            init-size: [pair!]
            wide: [percent!]
        ]
        draw: [
            normal: [
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 (viewport-box/bottom-right/y) 90 area-fill
                box 1x1 (gob-size - 2) 1
                line-width 0.40000000000000002
                fill-pen led-color
                box 7x7 (gob-size - 7 * 0x1 + 12x0) 1
            ]
            focus: [
                fill-pen focus-color
                box -1x-1 viewport-box/bottom-right 5
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 (viewport-box/bottom-right/y) 90 area-fill
                box 1x1 (gob-size - 2) 1
                line-width 0.40000000000000002
                fill-pen led-color
                box 7x7 (gob-size - 7 * 0x1 + 12x0) 1
            ]
        ]
        actors: [
            on-init: [
                face/state/value: true? get-facet face 'orig-state
                make-material face get-facet face 'material
            ]
            on-set: [
                if arg/1 = 'value [face/state/value: true? arg/2]
            ]
            on-clear: [
                set-face face false
            ]
            on-draw: [
                set-material face face/state/mode
                color: get-facet face 'edge-color
                if face/state/mode = 'over [color: color / 2]
                face/facets/pen-color: color
                face/facets/led-color: pick get-facet face 'led-colors not not face/state/value
                arg
            ]
            on-click: [
                if arg/type = 'down [
                    focus face
                    set-face face not face/state/value
                    do-face face
                ]
                none
            ]
            on-key: [
                if arg/key = #" " [
                    set-face face not face/state/value
                    do-face face
                ]
            ]
        ]
    ]
    check: toggle [
        tags: [state tab]
        facets: [
            init-size: 300x10
            max-size: 2000x22
            led-colors: reduce [leaf 50.50.50.200]
            text-style: 'radio
            auto-wide: 20x4
            text-body: "Check"
            focus-color: 255.255.255.255
        ]
        draw: [
            line-width 0
            fill-pen focus-color
            translate (as-pair 3 gob-size/y - 13 / 2)
            box -2x-2 14x14 3
            pen pen-color
            line-width 1
            fill-pen snow
            box 0x0 11x11
            line-width 2
            pen led-color
            fill-pen led-color
            polygon 1x4 5x10 12x-1 5x6 1x3
            reset-matrix
        ]
        actors: [
            on-make: [
                if all [
                    s: get-facet face 'auto-wide
                    not select face/options 'init-size
                ] [
                    set-facet face 'init-size max face/facets/min-size min face/facets/max-size s + size-text-face face 2000x100
                ]
            ]
        ]
    ]
    radio: check [
        tags: [state tab]
        facets: [
            related: 'on-mutex
            text-body: "Radio"
        ]
        draw: [
            pen none
            line-width 0
            fill-pen focus-color
            translate (as-pair 3 gob-size/y - 12 / 2)
            circle 5.5x5.5 7.7999999999999998
            pen pen-color
            line-width 1.5
            fill-pen snow
            circle 5x5 5.5999999999999996
            line-width 0.10000000000000001
            fill-pen led-color
            circle 5x5 2.5
            reset-matrix
        ]
        actors: [
            on-click: [
                if arg/type = 'down [
                    focus face
                    set-face face true
                    do-face face
                ]
                none
            ]
            on-mutex: [
                if all [
                    face <> arg
                    face/state/value
                    all [
                        not find select face 'reactors 'of
                    ]
                ] [
                    set-face face false
                ]
            ]
        ]
    ]
    arrow-button: clicker [
        about: "Single action button with arrow (but no text)."
        facets: [
            init-size:
            min-size:
            max-size: 22x22
            arrow-color: snow
            angle: 0
            material: 'aluminum
            center-point: none
        ]
        options: [
            init-size: [pair!]
            area-color: [tuple!]
            angle: [integer!]
        ]
        draw: [
            pen pen-color
            line-width 1.5
            grad-pen cubic 1x1 0 40 area-fill
            box 1x1 (gob-size - 2) 3
            transform angle 0.69999999999999996 0.69999999999999996 0x0 center-point
            pen arrow-color
            line-width 2.7000000000000002
            line-cap rounded
            line -6x5 0x-5 6x5 0x-1 -6x5
        ]
        actors: [
            on-resize: [
                do-style/style face 'on-resize arg 'face
                face/facets/center-point: arg - 2 / 2
            ]
        ]
    ]
    drop-down: button [
        about: "Drop-down test."
        tags: [tab state]
        facets: [
            text-body: "Drop-down"
            text-style: 'button
            text?: true
            area-fill: none
            arrow-center: 0x0
            pen-color: none
        ]
        options: [
            list-data: [block!]
            value: [integer!]
        ]
        draw: [
            normal: [
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 40 90 area-fill
                box 1x1 (viewport-box/bottom-right - 2) 1
                transform 180 0.59999999999999998 0.59999999999999998 0x0 arrow-center
                pen edge-color
                line-width 1
                line-cap rounded
                polygon -12x10 0x-10 12x10
                line-width 1
                line 20x12 20x-12
                reset-matrix
                translate -20x0
            ]
            focus: [
                fill-pen focus-color
                box -1x-1 viewport-box/bottom-right 5
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 40 90 area-fill
                box 1x1 (viewport-box/bottom-right - 2) 1
                transform 180 0.59999999999999998 0.59999999999999998 0x0 arrow-center
                pen edge-color
                line-width 1
                line-cap rounded
                polygon -12x10 0x-10 12x10
                line-width 1
                line 20x12 20x-12
                reset-matrix
                translate -20x0
            ]
        ]
        actors: [
            on-make: [
                if none? get-facet face 'value [set-facet face 'value 1]
                if none? get-facet face 'list-data [set-facet face 'list-data ["No data set!"]]
            ]
            on-draw: [
                set-material face face/state/mode
                color: get-facet face 'edge-color
                if face/state/mode = 'over [color: color / 2]
                face/facets/pen-color: color
                set-facet face 'text-body pick get-facet face 'list-data get-facet face 'value
                arg
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                face/gob/size: arg
                face/facets/arrow-center: arg - as-pair 15 arg/y / 2
            ]
            on-set: [
                switch type?/word arg/2 [
                    block! [set-facet face 'list-data arg/2]
                    integer! [
                        set-facet face 'value arg/2
                        if get-facet face 'text? [set-facet face 'text-body pick get-facet face 'list-data arg/2]
                    ]
                ]
                draw-face face
            ]
            on-get: [
                pick get-facet face 'list-data get-facet face 'value
            ]
            on-clear: [
                set-face face 1
            ]
            on-key: [
                arg
            ]
            on-click: [
                ld: get-facet face 'list-data
                popup: show-popup [
                    text-list ld do [
                        do-popup-parent 'on-set reduce ['value value]
                        hide-popup
                    ]
                ] face
                none
            ]
        ]
    ]
    drop-arrow: drop-down [
        facets: [
            init-size: 24x24
            max-size: 24x24
            center-point: 12x12
            arrow-color: black
            text-body: none
            text?: no
        ]
        draw: [
            pen pen-color
            line-width 1.5
            grad-pen cubic 1x1 0 40 area-fill
            box 1x1 (gob-size - 2) 3
            transform 180 0.69999999999999996 0.69999999999999996 0x0 center-point
            pen arrow-color
            line-width 2.7000000000000002
            line-cap rounded
            line -6x5 0x-5 6x5 0x-1 -6x5
        ]
        actors: [
            on-draw: [
                set-material face face/state/mode
                color: get-facet face 'edge-color
                if face/state/mode = 'over [color: color / 2]
                face/facets/pen-color: color
                arg
            ]
            on-click: [
                ld: get-facet face 'list-data
                popup: show-popup/size/offset [
                    text-list ld do [
                        do-popup-parent 'on-set reduce ['value value]
                        hide-popup
                    ]
                ] face 144x120 -120x0
                none
            ]
        ]
    ]
    tab-button: clicker [
        about: "Tab button. For internal use."
        tags: [internal state]
        facets: [
            init-size: 100x28
            max-size: 120x28
            min-size: 80x28
            text-body: "Button"
            text-style: 'button
            related: 'on-mutex
            led-colors: reduce [green coal red]
            draw-mode: 'bottom
            led-color: none
        ]
        options: [
            text-body: [string! block!]
            id: [tag!]
            layout: [issue!]
            active: [logic!]
        ]
        draw: [
            top: [
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 28 90 area-fill
                shape [
                    move (as-pair 1 gob-size/y)
                    line 1x5
                    line 5x1
                    line (as-pair gob-size/x - 7 1)
                    line (as-pair gob-size/x - 2 5)
                    line (gob-size + -2x0)
                ]
                line-width 0.40000000000000002
                fill-pen led-color
                box 5x5 13x13 1
                translate 0x10
            ]
            bottom: [
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 28 90 area-fill
                shape [
                    move 1x-1
                    line (as-pair 1 gob-size/y - 7)
                    line (as-pair 5 gob-size/y - 3)
                    line (as-pair gob-size/x - 7 gob-size/y - 3)
                    line (as-pair gob-size/x gob-size/y - 7)
                    line (as-pair gob-size/x - 2 -1)
                ]
                line-width 0.40000000000000002
                fill-pen led-color
                box 5x5 13x13 1
                translate 0x10
            ]
            left: [
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 28 90 area-fill
                shape [
                    move (as-pair 1 gob-size/y)
                    line 1x5
                    line 5x1
                    line (as-pair gob-size/x - 7 1)
                    line (as-pair gob-size/x - 2 5)
                    line (gob-size + -2x0)
                ]
                line-width 0.40000000000000002
                fill-pen led-color
                box 5x5 13x13 1
                translate 0x10
            ]
            right: [
                pen pen-color
                line-width 1
                grad-pen linear 1x1 0 28 90 area-fill
                shape [
                    move (as-pair 1 gob-size/y)
                    line 1x5
                    line 5x1
                    line (as-pair gob-size/x - 7 1)
                    line (as-pair gob-size/x - 2 5)
                    line (gob-size + -2x0)
                ]
                line-width 0.40000000000000002
                fill-pen led-color
                box 5x5 13x13 1
                translate 0x10
            ]
        ]
        actors: [
            on-make: [
                face/state/value: get in face/options 'active
                face/state/mode: none
                mode: get-facet face 'layout
                if none? mode [mode: 'top]
                set-facet face 'draw-mode to word! mode
            ]
            on-draw: [
                set-material face face/state/mode
                color: get-facet face 'edge-color
                face/facets/led-color: pick get-facet face 'led-colors not not face/state/value
                if face/state/mode = 'over [
                    face/facets/led-color: pick get-facet face 'led-colors 3
                    color: color / 2
                ]
                face/facets/pen-color: color
                arg
            ]
            on-click: [
                if arg/type = 'down [
                    hide-tooltip face
                    return init-drag face arg/offset
                ]
                if arg/type = 'up [
                    tab-box: compound-face? compound-face? face
                    focus tab-box
                    face/state/value: true
                    id: face/name
                    tab: either close?: inside? arg/offset 5x5 13x13 [
                        tabs: words-of get-facet tab-box 'tabs
                        tabs: remove find tabs id
                        do-style tab-box 'on-remove-tab id
                        first either empty? tabs [back tabs] [tabs]
                    ] [
                        id
                    ]
                    if any [
                        all [not close? id <> tab-box/state/active]
                        all [close? id = tab-box/state/active]
                    ] [
                        set-face tab-box tab
                    ]
                    do-related face 'on-mutex
                    set-face face tab
                ]
                none
            ]
            on-set: [
                if 'value = arg/1 [face/state/value: arg/2]
                show-later face
            ]
            on-mutex: [
                tab-bar: compound-face? face
                set-face face tab-bar/state/active = get-facet face 'id
            ]
            on-over: [
                face/state/mode: either arg ['over] [none]
                draw-face face
                if face/gob/parent [
                    parent: face/gob/parent/data
                    either arg [
                        buttons: compound-face? face
                        tab-box: compound-face? buttons
                        do-style tab-box 'on-render-tab id: get-facet face 'id
                        preview.img: pick get-facet tab-box 'previews id
                        t: make-face 'hpanel [content: [image preview.img 188x104]]
                        do-style t 'on-resize 200x115
                    ] []
                ]
            ]
            on-drag: [
                face/gob/offset: arg/offset - arg/base
                show face/gob
            ]
            on-drag-over: [
                bar: parent-face? face
                do-style bar 'on-drag-over reduce [arg/1 face/gob/offset + arg/2 arg/3]
                true
            ]
            on-key: [
                print "onkey button"
                if arg/type = 'key [
                    switch arg/key [
                        left [print "left"]
                        right [print "right"]
                    ]
                ]
            ]
        ]
    ]
]
stylize [
    box: [
        about: "Simple rectangular box."
        facets: [
            init-size: 100x100
            bg-color: black
        ]
        options: [
            init-size: [pair!]
            bg-color: [tuple!]
        ]
        actors: [
            on-draw: [
                all [
                    face/facets/bg-color
                    face/facets/bg-color/4: either face/state/mode = 'over [
                        127
                    ] [
                        0
                    ]
                ]
                arg
            ]
            on-over: [
                face/state/mode: pick [over up] face/state/over: not not arg
                draw-face face
            ]
        ]
    ]
    bar: box [
        about: "Simple horizontal divider bar."
        facets: [
            init-size: 200x1
            min-size: 20x1
            max-size: 1000x5
            area-color: 0.0.0.100
        ]
    ]
    div: bar [
        about: "Simple vertical divider bar."
        facets: [
            init-size: 1x200
            min-size: 1x20
            max-size: 5x1000
        ]
    ]
    progress: [
        about: "Progress bar."
        tags: [indicator]
        facets: [
            init-size: 200x22
            max-size: 1000x22
            edge-color: 96.96.96
            area-color: 80.80.80.128
            material: 'radial-aluminum
            bar-size: 1x1
        ]
        options: [
            bar-color: [tuple!]
            init-size: [pair!]
            value: [percent!]
        ]
        draw: [
            pen edge-color
            line-width 1.5
            grad-pen 1x1 0 viewport-box/bottom-right/y 90 materials/down
            box 1x1 (viewport-box/bottom-right - 2) 3
            grad-pen linear 1x1 0 viewport-box/bottom-right/y 90 area-fill
            box 1x1 bar-size 3
        ]
        actors: [
            on-make: [
                make-material face get-facet face 'material
                set-material face 'up
                if value: get-facet face 'value [set-face face value]
            ]
            on-set: [
                if number? arg/2 [
                    face/state/value: v: limit to percent! arg/2 0% 100%
                    face/facets/bar-size: as-pair v * face/gob/size/x face/gob/size/y - 2
                ]
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                set-face face face/state/value
            ]
        ]
    ]
    slider: [
        about: "Slide-bar for numeric input (0% - 100%)"
        tags: [state action input tab]
        facets: [
            init-size: 200x22
            min-size: 200x22
            max-size: 1000x22
            edge-color: 96.96.96
            area-color: 80.80.80
            relay: true
            focus-color: gray
            axis: none
            knob-xy:
            bias-xy: 6x0
            slider-size: 0x0
            material: 'radial-aluminum
        ]
        options: [
            init-size: [pair!]
            knob-color: [tuple!]
            value: [percent!]
        ]
        state: [
            value: [percent!]
        ]
        draw: [
            pen edge-color
            line-width 0.40000000000000002
            grad-pen 1x1 0 10 90 area-fill
            box 1x1 slider-size 3
            line-width 1.5
            fill-pen focus-color
            translate knob-xy
            triangle -6x16 0x2 6x16
        ]
        actors: [
            on-init: [
                make-material face get-facet face 'material
                set-material face 'up
                face/state/value: either in face/options 'value [max 0% min 100% face/options/value] [0%]
                face/facets/axis: face-axis? face
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                face/facets/slider-size: arg - 2 * 1x0 + 0x6
                face/facets/axis: face-axis? face
                do-style face 'on-update none
            ]
            on-update: [
                if face/facets/viewport-box/bottom-right [
                    bias: face/facets/bias-xy
                    size: face/facets/viewport-box/bottom-right - bias - bias
                    val: face/state/value
                    face/facets/knob-xy: val * size * 1x0 + bias
                ]
            ]
            on-offset: [
                bias: face/facets/bias-xy
                arg: max 0x0 arg - bias
                size: face/facets/viewport-box/bottom-right - bias - bias
                axis: pick [x y] 'y = get-facet face 'axis
                face/state/value: val: min 100% max 0% to-percent arg/:axis / size/:axis
                face/facets/knob-xy: val * size * 1x0 + bias
            ]
            on-click: [
                focus face
                if arg/type = 'down [drag: init-drag/only face arg/offset]
                do-style face 'on-offset arg/offset
                if arg/type = 'down [
                    draw-face face
                    return drag
                ]
                do-face face
                none
            ]
            on-drag: [
                do-style face 'on-offset arg/delta + arg/base
                draw-face face
                do-face face
            ]
            on-get: [
                if arg = 'value [face/state/value]
            ]
            on-set: [
                if all [
                    'value = first arg
                    number? second arg
                ] [
                    face/state/value: limit second arg 0% 100%
                ]
                do-style face 'on-update none
            ]
            on-clear: [
                set-face face 0
            ]
            on-focus: [
                set-facet face 'focus-color either arg [red] [gray]
                draw-face face
            ]
            on-key: [
                if arg/type = 'key [
                    switch/default arg/key [
                        left [set-face face -1% + get-face face]
                        right [set-face face 1% + get-face face]
                    ] [
                        unless e: error? try [
                            n: -1 + to integer! to string! arg/key
                        ] [
                            if -1 = n [n: 9]
                            set-face face to percent! n / 9
                        ]
                    ]
                ]
            ]
        ]
    ]
    scroller: [
        about: "Scroll bar with end arrows."
        tags: [action part]
        facets: [
            init-size: 16x16
            min-size: 16x16
            btn-size: 16x16
            max-size: 16x16
            all-over: true
            relay: true
            material: 'scroller
            area-color: 200.233.245
            edge-color: 0.0.0.128
            arrow-color: black
            area-fill:
            over-fill: sky
            down-fill: coal
            btn-fill: reduce [area-fill area-fill area-fill]
            knob-xy:
            knob-size:
            knob-base:
            btn-xy: 0x0
            angles: [0 180]
            axis:
            none
        ]
        options: [
            init-size: [pair!]
        ]
        state: [
            value: 0%
            delta: 10.000000000000001%
            knob-size: 100%
        ]
        draw: [
            pen edge-color
            line-width 1
            grad-pen linear 1x1 0 16 (use 'a [a: angles/1 if a = 270 [a: 90] a]) materials/down
            box 1x1 (viewport-box/bottom-right - 1) 6
            grad-pen linear 1x1 0 16 (use 'a [a: angles/1 if a = 270 [a: 90] a]) materials/up
            box knob-xy (knob-xy + knob-size) 6
            pen false
            transform angles/1 0x0 0.59999999999999998 0.59999999999999998 (btn-size / 2)
            pen arrow-color
            line-cap rounded
            fill-pen arrow-color
            polygon -6x5 0x-5 6x5
            reset-matrix
            transform angles/2 0.59999999999999998 0.59999999999999998 0x0 (btn-xy - 1 + (btn-size / 2))
            polygon -6x5 0x-5 6x5
        ]
        actors: [
            on-init: [
                if target: find-face-actor/reverse face 'on-scroll [
                    append-face-act face reduce ['scroll target]
                    do-style target 'on-attach face
                ]
            ]
            on-make: [
                make-material face get-facet face 'material
                set-material face 'up
            ]
            on-resize: [
                size: arg
                a: pick [x y] size/y < size/x
                z: pick [x y] a = 'y
                unless face/facets/axis [
                    set-facet face 'axis a
                    face/facets/max-size/:a: 2147483647
                ]
                do-style/style face 'on-resize size 'face
                size: face/facets/gob-size
                btn-size: get-facet face 'btn-size
                all [
                    act: find-face-actor/reverse face 'on-scroll
                    target: sub-gob? act
                    inner-size: min size - btn-size target/size
                    not zero? target/size/:a
                    face/state/delta: to percent! inner-size/:a / target/size/:a
                ]
                face/facets/angles: pick [[0 180] [270 90]] size/y > size/x
                face/facets/gob-size: size
                bxy: size - btn-size
                bxy/:z: 1
                face/facets/btn-xy: bxy
                set-face face face/state/value
            ]
            on-set: [
                foreach [word val] arg [
                    switch word [
                        value [
                            switch type?/word val [
                                percent! [
                                    face/state/value: val
                                ]
                                block! [
                                    face/state/value: val/1
                                    face/state/knob-size: val/2
                                ]
                            ]
                        ]
                        delta [face/state/delta: val]
                    ]
                ]
                get-facet face [axis: gob-size: btn-size:]
                if none? value [value: 0%]
                if none? knob-size [knob-size: 100%]
                value: max 0% min 100% face/state/value
                knob-size: max 0% min 100% face/state/knob-size
                face/state/value: value
                face/state/delta: face/state/knob-size: knob-size
                value: value * (100% - knob-size)
                axim: either 'x = axis [1x0] [0x1]
                if not none? gob-size [
                    area: gob-size - (2 * btn-size)
                    knob-size: knob-size * area * axim + (reverse axim * 12)
                    knob-xy: area * value + btn-size * axim + (reverse axim * 2)
                    set-facet face 'knob-xy knob-xy
                    set-facet face 'knob-size knob-size
                    draw-face face
                ]
            ]
            on-reset: [
                face/state/value: 0%
                face/state/delta: 10.000000000000001%
            ]
            on-sense-scroll: [
                get-facet face [gob-size: btn-size: knob-size: knob-xy:]
                axis: face-axis? face
                n: arg/:axis
                k: knob-xy/:axis
                case [
                    n < btn-size/:axis [2]
                    n > (gob-size/:axis - btn-size/:axis) [3]
                    n < k [4]
                    n > (k + knob-size/:axis) [5]
                    true [1]
                ]
            ]
            on-bump-scroll: [
                d: to percent! face/state/delta * arg
                set-face face max 0% min 100% face/state/value + d
            ]
            on-click: [
                if arg/type = 'down [
                    switch do-style face 'on-sense-scroll arg/offset [
                        1 [return init-drag/only face face/state/value]
                        2 4 [do-style face 'on-bump-scroll -1]
                        3 5 [do-style face 'on-bump-scroll 1]
                    ]
                ]
                none
            ]
            on-drag: [
                axis: get-facet face 'axis
                size: face/facets/gob-size - (2 * face/facets/btn-size) - face/facets/knob-size + 1x1
                scroll-pos: size/:axis * arg/base + arg/delta/:axis
                face/state/value: val: max 0% min 100% to percent! scroll-pos / size/:axis
                set-face face face/state/value
                draw-face face
                do-face face
            ]
            on-delta: [
                face/state/delta: pick arg 'x = get-facet face 'axis
                if get-facet face 'gob-size [
                    set-face face face/state/value
                    draw-face face
                ]
            ]
            on-scroll-event: [
                dy: none
                switch arg/type [
                    scroll-line [dy: arg/offset/y / -30]
                    scroll-page [dy: negate arg/offset/y]
                ]
                if dy [do-style face 'on-bump-scroll dy]
                none
            ]
        ]
    ]
]
stylize [
    text: [
        about: "Simple text without background."
        facets: [
            init-size: 0x0
            text-body: ""
            text-style: 'base
        ]
        options: [
            init-size: [pair!]
            text-body: [string! block!]
            text-color: [tuple!]
        ]
        actors: [
            on-make: [
                face/facets/init-size: face/facets/min-size: face/facets/max-size: size-text-face face 800x600
            ]
            on-init: [
                if in face/options 'text-color [
                    style: face-font? face
                    style/font/color: face/options/text-color
                ]
            ]
        ]
    ]
    title: text [
        about: "Title text style without background."
        facets: [
            text-style: 'title
        ]
    ]
    head-bar: text [
        about: "Boxed text bar for headings."
        facets: [
            init-size: 200x20
            max-size: 2000x20
            area-color: 255.255.255.100
            edge-color: 80.80.80.100
            text-style: 'head-bar
        ]
        options: [
            text-body: [string! block!]
            area-color: [tuple!]
            init-size: [pair!]
        ]
        draw: [
            pen edge-color
            line-width 1.6000000000000001
            fill-pen area-color
            box 1x1 (gob-size - 3) 2
        ]
        actors: [
            on-set: [
                face/facets/text-body: form any [arg/2 ""]
                show-later face
            ]
        ]
    ]
    label: text [
        about: "Label text without background."
        facets: [
            init-size: 100x20
            max-size: 200x20
            text-style: 'label
        ]
    ]
    text-item: text [
        tags: [state tab internal]
        facets: [
            init-size: 100x18
            max-size: 2000x18
            min-size: 40x18
            area-color: 255.255.255.100
            edge-color: black
            edge-width: 0.10000000000000001
            text-style: 'list-item
            related: 'on-mutex
            margin: [2x0 2x0]
            material: 'piano
        ]
        options: [
            text-body: [string! block!]
            area-color: [tuple!]
        ]
        draw: [
            pen black
            line-width edge-width
            grad-pen linear 1x1 0 viewport-box/bottom-right/y 90 area-fill
            box 1x1 (viewport-box/bottom-right - 1)
        ]
        actors: [
            on-init: [
                make-material face get-facet face 'material
            ]
            on-set: [
                all [
                    arg/1 = 'value
                    face/state/value: true? arg/2
                    set-facet face 'edge-width 2
                    parent-face: face/gob/parent/data
                    parent-face/state/value: index? find faces? parent-face face
                ]
                show-later face
            ]
            on-click: [
                focus face/gob/parent/data
                if arg/type = 'up [
                    set-face face true
                    do-face face
                ]
            ]
            on-draw: [
                set-material face face/state/mode
                arg
            ]
            on-mutex: [
                if all [
                    face <> arg
                    face/state/value
                    all [
                        not find select face 'reactors 'of
                    ]
                ] [
                    set-facet face 'edge-width 0.10000000000000001
                    set-face face false
                ]
            ]
        ]
    ]
    text-area: [
        about: {General text input area, editable, scrollable, without background.}
        tags: [internal field]
        facets: [
            init-size: 300x163
            max-size: 2000x2000
            min-size: 100x22
            text-edit: ""
            lines: true
            text-style: 'area
            padding: [1x1 1x1]
        ]
        options: [
            init-size: [pair!]
            text-edit: [string! block!]
        ]
        state: [
            cursor:
            mark-head:
            mark-tail:
            caret: none
            xpos: none
        ]
        actors: [
            on-make: [
                face/state/value: face/facets/text-edit: copy face/facets/text-edit
                init-text-caret face
                append face/gob gob: make-text-gob face face/gob/size "empty"
                gob/offset: (first get-facet face 'margin) + (first get-facet face 'border-size) + (first get-facet face 'padding) + 2
                do-style face 'on-update none
            ]
            on-attach: [
                extend-face face 'attached arg
                gob: sub-gob? face
                face/facets/gob-size: face/facets/init-size
                set-face face/attached/1 face-text-size face
            ]
            on-update: [
                gob: sub-gob? face
                either block? face/facets/text-edit [
                    change back back tail gob/text to-text face/facets/text-edit copy []
                ] [
                    change back tail gob/text face/facets/text-edit
                ]
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                face/gob/1/size: face/facets/viewport-box/bottom-right
                if in face 'attached [
                    set-face face/attached/1 face-text-size face
                ]
            ]
            on-set: [
                switch arg/1 [
                    value [
                        face/facets/text-edit: reform any [face/state/value: arg/2 ""]
                        clear-text-caret face
                        do-style face 'on-update none
                        do-style face 'on-resize face/gob/size
                    ]
                    locate [
                        goto-caret face arg/2
                        see-caret face
                        show-later face
                    ]
                ]
                if in face 'attached [
                    set-face face/attached/1 face-text-size face
                ]
            ]
            on-get: [
                if arg = 'value [
                    face/facets/text-edit
                ]
            ]
            on-clear: [
                clear face/facets/text-edit
                show-later face
            ]
            on-scroll: [
                gob: sub-gob? face
                size: gob/size - gob/text/scroll
                tsize: size-text gob
                gob/text/scroll/y: min 0 arg/state/value * negate tsize/y - gob/size/y + 5
                show-later face
            ]
            on-key: [
                if arg/type = 'key [
                    gob: sub-gob? face
                    do-text-key face arg arg/key
                    update-text-caret face
                    see-caret face
                    t: face-text-size face
                    if in face 'attached [
                        set-face face/attached/1 face-text-size face
                    ]
                    show-later face
                ]
            ]
            on-scroll-event: [
                dy: none
                switch arg/type [
                    scroll-line [dy: arg/offset/y / -30]
                    scroll-page [dy: negate arg/offset/y]
                ]
                if all [dy bars: select face 'attached] [
                    do-style first bars 'on-bump-scroll dy
                ]
                none
            ]
            on-click: [
                clear-all-carets window-face? face
                either arg/type = 'down [
                    if cur: offset-to-caret sub-gob? face arg/offset [
                        click-text-face face cur arg
                        return init-drag/only face arg/offset
                    ]
                    none
                ] [arg]
            ]
            on-drag: [
                if all [
                    arg/event/gob = sub-gob? face
                    cur: offset-to-caret sub-gob? face arg/event/offset
                ] [
                    state: face/state
                    unless state/mark-head [state/mark-head: state/cursor]
                    state/mark-tail: state/cursor: first cur
                    update-text-caret face
                    see-caret face
                    if in face 'attached [
                        bar: face/attached/1
                        set-face bar bar/state/value
                    ]
                    show-later face
                ]
            ]
            on-focus: [
                either arg [
                    unless face/state/cursor [face/state/cursor: face/facets/text-edit]
                    update-text-caret face
                ] [
                    face/state/cursor: none
                    clear-text-caret face
                ]
                show-later face
                none
            ]
            on-reset: [
                txt: face/gob/pane/1/text
                clear last txt
                show-later face
                none
            ]
        ]
    ]
    text-box: text-area [
        about: "Text area with background box."
        tags: [field]
        facets: [
            bg-color: snow
            init-size: 320x240
            padding: [0x0 0x0]
            border-color: black
            border-size: [1x1 1x1]
            area-fill:
            material: 'field-groove
        ]
        options: [
            init-size: [pair!]
            text-edit: [string! block!]
            bg-color: [tuple!]
            debug: [logic!]
        ]
        draw: [
            pen none
            grad-pen linear 1x1 -2 10 90 area-fill
            box 0x0 (as-pair viewport-box/bottom-right/x 12)
        ]
        actors: [
            on-init: [
                make-material/facet face get-facet face 'material 'bg-color
                set-material face 'up
            ]
            on-draw: [
                if in face/options 'debug [
                    append arg [
                        pen border-color
                        line-width none
                        fill-pen 255.0.0.128
                        box 0x0 (viewport-box/bottom-right - 1)
                    ]
                ]
                arg
            ]
        ]
    ]
    field: text-box [
        about: {Single line text input, editable, with background box.}
        tags: [field tab input]
        facets: [
            init-size: 130x22
            max-size: 2000x22
            min-size: 20x22
            lines: false
            text-style: 'field
        ]
        actors: [
            on-validate: [
                set-facet face 'border-color
                switch arg/2 [
                    skipped [snow]
                    required [white]
                    not-required [snow]
                    invalid [red]
                    valid [green]
                ]
                draw-face face
            ]
        ]
    ]
    area: hpanel [
        about: {Multi-line text input, editable, scrollable, with background and scrollbars.}
        tags: [field input]
        facets: [
            init-size: 300x161
            min-size: 50x50
            spacing: 0x0
            input: true
            break-after: 2
            area-color: snow
        ]
        options: [
            text-edit: [string! block!]
            area-color: [tuple!]
            init-size: [pair!]
            debug: [logic!]
        ]
        content: [
            text-box :text-edit :debug :area-color
            scroller
        ]
        actors: [
            on-set: [
                do-style first f: faces? face 'on-set arg
                if arg/1 = 'value [
                    set-face f/2 0%
                ]
            ]
            on-get: [
                get-face first faces? face
            ]
        ]
    ]
    code-area: area [
        about: {Multi-line code input, editable, scrollable, with background and scrollbars.}
        tags: [field keep]
        content: [
            text-box :text-edit :area-color options [text-style: 'code]
            scroller
        ]
    ]
    info: text-area [
        about: "Text information fields, non-editable."
        tags: [tab select]
        facets: [
            init-size: 100x22
            max-size: 2000x22
            min-size: 20x22
            lines: false
            no-edit: true
            text-style: 'info
            edge-color: 100.100.100.200
            area-color: 240.240.240.150
        ]
        options: [
            init-size: [pair!]
            text-edit: [string! block!]
        ]
        draw: [
            pen edge-color
            line-width 1.5
            fill-pen area-color
            box 1x1 (viewport-box/bottom-right - 1) 1
        ]
    ]
    info-area: hpanel [
        about: {Multi-line text info, non-editable, scrollable, scrollbars.}
        tags: [tab select]
        facets: [
            init-size: 300x100
            text-style: 'info-area
            break-after: 2
        ]
        options: [
            text-edit: [string! block!]
            area-color: [tuple!]
            init-size: [pair!]
        ]
        content: [
            info :text-edit options [
                init-size: 300x100
                max-size: 2000x2000
            ]
            scroller
        ]
        actors: [
            on-set: [
                do-style first f: faces? face 'on-set arg
                if arg/1 = 'value [
                    set-face f/2 0%
                ]
            ]
            on-get: [
                get-face first faces? face
            ]
        ]
    ]
]
temp-ctx-doc: context [
    space: charset " ^-"
    nochar: charset " ^-^/"
    para-start: charset [#"!" - #"~"]
    emit-para: funct [
        "Emit a paragraph with minor markup."
        out [block!] "A richtext block"
        para "marked-up string"
    ] [
        while [all [para not tail? para]] [
            either spot: find para #"<" [
                append out copy/part para spot
                para: either end: find/tail spot #">" [
                    switch copy/part spot end [
                        "<b>" [append out 'bold]
                        "</b>" [append out [bold off]]
                        "<i>" [append out 'italic]
                        "</i>" [append out [italic off]]
                        "<em>" [append out [bold italic]]
                        "</em>" [append out [bold off italic off]]
                    ]
                    end
                ] [
                    next spot
                ]
            ] [
                append out copy/part para tail para
                para: none
            ]
        ]
        append out [newline newline]
    ]
    set 'parse-doc funct [
        {Parse the doc string input. Return rich-text output.}
        text [string!]
    ] [
        text: trim/auto detab text
        if newline <> last text [append text newline]
        out: make block! (length? text) / 20 + 1
        emit: func [data] [repend out data]
        s: none
        para: make string! 20
        ft: what-font? 'title
        fb: what-font? 'base
        fc: what-font? 'code
        emit [
            'font fb/font
            'para fb/para
            'anti-alias ft/anti-alias
        ]
        parse/all text [
            some [
                "###" break
                |
                "===" copy s to newline skip (
                    emit [
                        'font ft/font
                        s
                        'drop
                        'font fb/font
                        'newline 'newline
                    ]
                )
                |
                some [copy s [para-start to newline] (repend para [s " "]) skip] (emit-para out para clear para)
                |
                some [copy s [space thru newline] (append para s)] (
                    emit [
                        'font fc/font
                        copy para
                        'drop 1
                        'font fb/font
                        'newline 'newline
                    ]
                    clear para
                )
                |
                newline
                opt [newline (emit 'newline)]
            ]
        ]
        out
    ]
]
stylize [
    doc: text-area [
        about: {A tiny document markup method for embedded docs, notes, messages.}
        tags: [tab select]
        facets: [
            no-edit: true
        ]
        options: [
            text-edit: [string! block!]
        ]
        actors: [
            on-make: [
                face/state/value: face/facets/text-edit: parse-doc face/facets/text-edit
                init-text-caret face
                set-facet face 'gob-size get-facet face 'init-size
                append face/gob gob: make-text-gob face face/facets/gob-size - 2 "empty"
                face/gob/size: gob/size
                do-style face 'on-update none
            ]
        ]
    ]
]
stylize [
    sensor: [
        about: "Has no graphics, but can be clicked."
        tags: [internal]
        facets: [
            init-size: 100x100
        ]
        options: [
            init-size: [pair!]
        ]
        actors: [
            on-click: [
                if arg/type = 'up [do-face face 'hit]
                none
            ]
        ]
    ]
    drawing: sensor [
        about: "Simple scalar vector draw block. Can be clicked."
        tags: [input tab]
        facets: [
            init-size: 100x100
        ]
        options: [
            drawing: [block!]
            init-size: [pair!]
        ]
        actors: [
            on-make: [
                if block? drw: face/facets/drawing [
                    bind face/gob/draw: copy drw face/facets
                ]
            ]
        ]
    ]
    image: sensor [
        about: "Simple image with optional border. Can be clicked."
        tags: [input tab]
        facets: [
            init-size: 200x100
            img: make image! 50x50
        ]
        options: [
            src: [image! file! url!]
            init-size: [pair!]
        ]
        draw: [
            image-filter bilinear resample 0.5
            image img 0x0 viewport-box/bottom-right
        ]
        actors: [
            on-make: [
                if in face/options 'src [
                    set-face face face/options/src
                ]
            ]
            on-set: [
                if arg/1 = 'value [
                    unless image? img: arg/2 [img: load img]
                    if image? img [
                        face/facets/init-size: face/facets/min-size: face/facets/max-size: any [all [in face/options 'init-size face/options/init-size] img/size]
                        set-facet face 'img img
                    ]
                ]
            ]
        ]
    ]
    icon: image [
        about: "Icon image with optional text below."
        tags: [input tab]
    ]
]
stylize [
    text-list-box: box [
        about: "List of selectable text lines (no scrollbar)."
        tags: [input part internal]
        facets: [
            init-size: 100x100
            min-size: 64x64
            bg-color:
            area-color: snow
            over-color: snow - 32
            mark-color: sky
            text-style: 'list-item
            all-over: true
            contents: []
            row-size: 0x0
            skip-len: 0
        ]
        options: [
            contents: [block!]
            area-color: [tuple!]
        ]
        state: [
            value: none
            list: none
            selected: copy []
            timer: none
            query: none
            update?: true
        ]
        actors: [
            on-make: [
                append face/gob gob: make gob! [
                    size: face/facets/init-size
                    data: face
                ]
                gob/draw: out: make block! 10 * length? face/facets/contents
                face/facets/row-size: 3 + face-char-size? face
                face/facets/skip-len: 4 + length? do-style face 'on-draw-cell reduce [0x0 10x10 0.0.0 face-font? face ""]
                do-style face 'on-update none
            ]
            on-attach: [
                extend-face face 'attached arg
            ]
            on-update: [
                gob: sub-gob? face
                clear draw-buf: gob/draw
                out: make block! 200
                do-style face 'on-draw-list face/facets/contents
                delect/all dialect-draw compose draw-buf out
                gob/draw: to-draw out copy []
                foreach n face/state/selected [
                    do-style face 'on-color-cell reduce [n off]
                ]
                show-later face
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'face
                face/facets/row-size/x: arg/x - 2
                face/gob/size: arg
                do-style face 'on-update none
                if in face 'attached [
                    set-face face/attached/1 reduce [0% to percent! face/gob/size/y / max face/gob/size/y face/gob/1/size/y]
                ]
            ]
            on-over-action: [
                n: if arg [do-style face 'on-find-cell arg/y]
                prior: face/state/over
                if prior <> n [
                    if face/state/over: n [
                        do-style face 'on-color-cell reduce [n on]
                    ]
                    if prior [
                        do-style face 'on-color-cell reduce [prior off]
                    ]
                    show-later face
                ]
            ]
            on-over: [
                either select parent: parent-face? face 'lists [
                    do-style parent 'on-over arg
                ] [
                    do-style face 'on-over-action arg
                ]
            ]
            on-click: [
                parent: compound-face? face
                switch arg/type [
                    down [
                        focus parent
                        none
                    ]
                    up [
                        set-face parent do-style face 'on-find-cell arg/offset/y
                        do-face face
                    ]
                ]
            ]
            on-scroll: [
                gob: sub-gob? face
                items: length? face/facets/contents
                visible: to integer! face/gob/size/y / face/facets/row-size/y
                first-item: max 0 to integer! round items - visible * arg/state/value
                gob/offset/y: negate first-item * face/facets/row-size/y
                show-later face
            ]
            on-scroll-list: [
                over: face/state/over
                if over [do-style face 'on-color-cell reduce [over off]]
                over: limit arg + any [
                    over
                    face/state/value
                    either positive? arg [0] [1 + length? face/facets/contents]
                ] 1 length? face/facets/contents
                do-style face 'on-color-cell reduce [over on]
                face/state/over: over
                gob: sub-gob? face
                visible: to integer! face/gob/size/y / face/facets/row-size/y
                first-item: to integer! negate gob/offset/y / face/facets/row-size/y
                bars: select face 'attached
                if bars [
                    bar: first bars
                    step: to percent! face/facets/row-size/y / (gob/size/y - face/gob/size/y)
                    case [
                        over > (visible + first-item) [
                            set-face first bars bar/state/value + step
                        ]
                        over <= first-item [
                            set-face first bars bar/state/value - step
                        ]
                    ]
                ]
                show-later face
            ]
            on-scroll-event: [
                gob: sub-gob? face
                visible: to integer! face/gob/size/y / face/facets/row-size/y
                first-item: to integer! negate gob/offset/y / face/facets/row-size/y
                value: switch arg/type [
                    scroll-line [either positive? arg/offset/y [-1] [1]]
                    scroll-page [visible]
                ]
                lists: select compound-face? face 'lists
                either lists [
                    foreach list lists [do-style list 'on-scroll-list value]
                ] [
                    do-style face 'on-scroll-list value
                ]
            ]
            on-key: [
                switch/default arg/key [
                    up [
                        if arg/type = 'key [
                            do-style face 'on-scroll-event make event! [type: 'scroll-line offset: 0x3]
                        ]
                    ]
                    down [
                        if arg/type = 'key [
                            do-style face 'on-scroll-event make event! [type: 'scroll-line offset: 0x-3]
                        ]
                    ]
                    #"^M" [set-face face face/state/over]
                    #" " [set-face face face/state/over]
                    #"^[" [
                        hide-popup
                        none
                    ]
                ] [
                    timer: face/state/timer
                    either any [
                        none? timer
                        all [time? timer (now/time/precise - timer) > 0:00:01]
                    ] [
                        face/state/query: join copy "" arg/key
                    ] [
                        append face/state/query arg/key
                    ]
                    face/state/timer: now/time/precise
                    if integer? face/state/over [
                        do-style face 'on-color-cell reduce [face/state/over off]
                    ]
                    t: auto-complete/index face/facets/contents face/state/query
                    unless any [none? t equal? t face/state/over] [
                        do-style face 'on-color-cell reduce [face/state/over: t on]
                        draw-face face
                    ]
                ]
            ]
            on-get: [
                switch arg [
                    value [face/state/over]
                    data [get-facet face 'contents]
                ]
            ]
            on-set: [
                selected: unique append face/state/selected face/state/over
                clear face/state/selected
                foreach line selected [do-style face 'on-color-cell reduce [line off]]
                face/state/value: none
                foreach [word val] arg [
                    switch word [
                        value [
                            if integer? val [
                                append face/state/selected face/state/value: val
                            ]
                            if block? val [face/facets/contents: copy val]
                        ]
                        list [
                            face/facets/contents: either block? val [val] [form val]
                        ]
                    ]
                ]
                do-style face 'on-color-cell reduce [face/state/value on]
                do-style face 'on-update none
            ]
            on-color-cell: [
                unless any [not arg/1 zero? arg/1] [
                    color: case [
                        find face/state/selected arg/1 'mark-color
                        arg/2 'over-color
                        true 'area-color
                    ]
                    gob: sub-gob? face
                    out: find gob/draw 'translate
                    out: skip out arg/1 - 1 * face/facets/skip-len + 3
                    unless empty? out [
                        change out get-facet face color
                    ]
                    if arg/2 [face/state/over: arg/1]
                ]
            ]
            on-find-cell: [
                num: 0
                dy: face/facets/row-size/y
                gob: sub-gob? face
                out: find gob/draw 'translate
                forskip out face/facets/skip-len [
                    ++ num
                    if all [
                        pos: second out
                        pos/y <= arg (pos/y + dy) > arg
                    ] [return num]
                ]
                return none
            ]
            on-draw-list: [
                xy: 0x0
                gob: sub-gob? face
                out: gob/draw
                color: get-facet face 'area-color
                fstyle: face-font? face
                size: face/facets/row-size
                foreach item arg [
                    if none? item [item: ""]
                    append out do-style face 'on-draw-cell reduce [xy size color fstyle form item]
                    xy: size * 0x1 + xy
                ]
                gob/size: as-pair size/x xy/y
            ]
            on-draw-cell: [
                fstyle: arg/4
                reduce [
                    'translate arg/1
                    'fill-pen arg/3
                    'box 0x0 arg/2
                    'text
                    reduce [
                        'font fstyle/font
                        'para fstyle/para
                        'anti-alias fstyle/anti-alias
                        arg/5
                    ]
                    'reset-matrix
                ]
            ]
        ]
    ]
    text-list: hpanel [
        about: "List of selectable text lines with scrollbar."
        tags: [compound tab state]
        facets: [
            max-size: 200x3000
            break-after: 2
            spacing: 0x0
            border-size: [0x0 0x0]
            border-color: none
            margin: [0x0 0x0]
            focus-color: none
            names: true
            filter: [true]
            label?: false
        ]
        options: [
            list-label: [string!]
            list-data: [block!]
        ]
        content: [
            sort-button: button "Sort" do [
                list: compound-face? face
                m: select [orig up down] get-facet face 'sort-method
                if none? m [m: 'orig]
                set-facet face 'sort-method m
                do-style list 'on-update none
            ] options [
                init-size: 120x22
                max-size: 300x22
            ]
            sort-pad: pad options [
                init-size: 18x22
                max-size: 18x22
            ]
            list: text-list-box :list-data
            scroller
        ]
        draw: [
            clip -2x-2 (viewport-box/bottom-right + 2)
            line-width 0
            fill-pen focus-color
            box -2x-2 (viewport-box/bottom-right + 2) 2
        ]
        actors: [
            on-init: [
                if select face 'reactors [
                    extend face/names/list 'reactors face/reactors
                ]
                set-face face/names/sort-button get-facet face 'list-label
                do-style/style face 'on-init arg 'hpanel
            ]
            on-set: [
                switch arg/1 [
                    value [
                        set-face face/names/list arg/2
                    ]
                    data [
                        set-facet face 'list-data arg/2
                        set-face/list face/names/list face arg
                    ]
                ]
            ]
            on-get: [
                v: switch arg [
                    value [get-face face/names/list]
                    data [get-facet face 'list-data]
                    text [pick get-facet face 'list-data get-face face/names/list face]
                ]
                v
            ]
            on-focus: [
                set-facet face 'focus-color either arg [red] [255.255.255.255]
                draw-face face
            ]
            on-key: [
                do-style face/names/list 'on-key arg
            ]
            on-update: [
                unless get-facet face 'label? [
                    show-face face/names/sort-button 'ignore
                    show-face face/names/sort-pad 'ignore
                ]
                do-style/style face 'on-update arg 'hpanel
                list: face/names/list
                data: copy get-facet face 'list-data
                filter: get-facet face 'filter
                if not error? try [row: data/1 do bind filter 'row] [
                    remove-each row data [not do bind filter 'row]
                ]
                data: switch/default get-facet face/names/sort-button 'sort-method [
                    up [sort data]
                    down [sort/reverse data]
                ] [data]
                set-face list data
            ]
        ]
    ]
    text-table: hpanel [
        about: "List of selectable text lines with scrollbar."
        tags: [compound tab state]
        facets: [
            max-size: 2000x3000
            spacing: 0x0
            border-size: [2x2 2x2]
            border-color: none
            margin: [2x2 2x2]
            focus-color: none
            names: true
            sort-method: [1 orig]
            labels: []
            filter: [true]
            columns-order: []
        ]
        state: [
            timer: none
            query: none
        ]
        options: [
            list-labels: [block!]
            list-data: [block!]
        ]
        draw: [
            clip -2x-2 (viewport-box/bottom-right + 2)
            line-width 0
            fill-pen focus-color
            box -2x-2 (viewport-box/bottom-right + 2) 2
        ]
        actors: [
            on-init: [
                do-style/style face 'on-init arg 'hpanel
                do-style face 'on-set reduce ['data get-facet face 'list-labels get-facet face 'list-data]
            ]
            on-attach: [
                lists: copy []
                foreach face faces? face [
                    if equal? 'text-list-box face/style [append lists face]
                ]
                extend-face face 'attached arg
                extend face 'lists lists
            ]
            on-update: [
                do-style/style face 'on-update arg 'hpanel
                get-facet face [list-data: sort-method: filter:]
                data: copy list-data
                filters: extract-columns data
                forall filters [
                    filters/1: unique filters/1
                    insert head filters/1 [<All> <empty> <not empty>]
                ]
                if not error? try [row: data/1 do bind filter 'row] [
                    remove-each row data [not do bind filter 'row]
                ]
                comparator: func [a b] switch sort-method/2 [
                    orig [[]]
                    up [[a/(sort-method/1) < b/(sort-method/1)]]
                    down [[a/(sort-method/1) > b/(sort-method/1)]]
                ]
                data: either empty? data [
                    array/initial length? face/facets/labels []
                ] [
                    extract-columns sort/compare data :comparator
                ]
                cols: get-facet face 'columns-order
                faces: faces? face
                repeat fac length? faces [
                    column: data/(cols/1)
                    name: select face/names to word! join 'filter- fac
                    if name [set-face name filters/:fac]
                    if 'text-list-box = faces/:fac/style [
                        set-face faces/:fac column
                        cols: next cols
                        if empty? cols [break]
                    ]
                ]
            ]
            on-set: [
                switch arg/1 [
                    value [
                        foreach list face/lists [do-style list 'on-set reduce ['value arg/2]]
                        do-face face
                    ]
                    data [
                        labels: copy arg/2
                        either integer? labels/2 [
                            cols: copy []
                            parse labels [
                                some [
                                    string!
                                    | p: set i integer! (append cols i remove p)
                                ]
                            ]
                        ] [
                            cols: copy []
                            repeat i length? labels [append cols i]
                        ]
                        set-facet face 'columns-order cols
                        set-facet face 'labels arg/2
                        set-facet face 'list-data arg/3
                        set-facet face 'break-after 1 + length? labels
                        panel-layout: copy [
                            #labels
                            pad options [max-size: 16x16]
                            #columns
                            scr: scroller
                        ]
                        but-act: [
                            list: compound-face? face
                            m: select [orig up down] get-facet face 'sort-method
                            if none? m [m: 'orig]
                            set-facet face 'sort-method m
                            c: index? find get-facet list 'list-labels get-facet face 'text-body
                            set-facet list 'sort-method reduce [c m]
                            do-style list 'on-update none
                        ]
                        flt-act: [
                            parent: compound-face? compound-face? face
                            index: second parse to string! face/name "-"
                            set-facet parent 'filter switch/default value [
                                <All> [[true]]
                                <empty> [compose [empty? (to path! reduce ['row to integer! index])]]
                                <not empty> [compose [not empty? (to path! reduce ['row to integer! index])]]
                            ] [
                                compose [(to path! reduce ['row to integer! index]) = (value)]
                            ]
                            set-facet face 'arrow-color either <All> = value [black] [red]
                            update-face parent
                        ]
                        replace panel-layout #labels collect [
                            words: copy []
                            repeat label length? labels [
                                repend words [word: to set-word! join 'filter- label none]
                                keep reduce [
                                    'htight compose [
                                        button (labels/:label) do but-act (word) drop-arrow [] do flt-act
                                    ]
                                ]
                            ]
                        ]
                        replace panel-layout #columns collect [
                            repeat col length? labels [
                                word: to set-word! join 'list- col
                                keep compose [(word) text-list-box []]
                            ]
                        ]
                        set 'pan panel-layout
                        set-panel-content face bind panel-layout context words
                        scr: face/names/scr
                        append-face-act scr reduce ['scroll face]
                        do-style face 'on-attach scr
                    ]
                ]
                show-later face
            ]
            on-get: [
                switch arg [
                    value [get-face face/lists/1]
                    data [get-facet face 'list-data]
                    text [pick get-facet face 'list-data get-face face/faces/1]
                ]
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'hpanel
                id: -1 + length? faces? face
                unless -1 = id [
                    set-face scr reduce [0% to percent! face/gob/:id/size/y / max face/gob/:id/size/y face/gob/:id/1/size/y]
                ]
            ]
            on-focus: [
                set-facet face 'focus-color either arg [red] [255.255.255.255]
                draw-face face
            ]
            on-scroll: [
                do-style face/lists 'on-scroll arg
            ]
            on-over: [
                do-style face/lists 'on-over-action arg
            ]
            on-focus: [
                set-facet face 'focus-color either arg [red] [255.255.255.255]
                draw-face face
            ]
            on-key: [
                shift?: find arg/flags 'shift
                lists: face/lists
                switch/default arg/key [
                    #"^M" [
                        set-face face face/lists/1/state/over
                    ]
                    #" " [
                        set-face face face/lists/1/state/over
                    ]
                    #"^[" [
                        hide-popup
                        none
                    ]
                    #"+" [
                        foreach list lists [insert at list/facets/contents over: list/state/over copy ""]
                        do-style lists 'on-update none
                        do-style lists 'on-color-cell reduce [over on]
                    ]
                    #"-" [
                        foreach list lists [remove at list/facets/contents over: list/state/over]
                        do-style lists 'on-update none
                        do-style lists 'on-color-cell reduce [over on]
                    ]
                ] [
                    if all [
                        arrow: find [up down] arg/key
                        arg/type = 'key
                    ] [
                        either shift? [
                            if over: face/lists/1/state/value [
                                move at face/facets/list-data over step: either 'up = arg/key [-1] [1]
                                do-style face 'on-update none
                                set-face face limit over + step 1 length? face/facets/list-data
                            ]
                        ] [
                            do-style lists 'on-scroll-list either 'up = arg/key [-1] [1]
                        ]
                    ]
                    if not arrow [do-style face 'on-auto-complete arg/key]
                ]
            ]
            on-auto-complete: [
                timer: face/state/timer
                lists: face/lists
                either any [
                    none? timer
                    all [time? timer (now/time/precise - timer) > 0:00:01]
                ] [
                    face/state/query: join copy "" arg
                ] [
                    append face/state/query arg
                ]
                face/state/timer: now/time/precise
                over: lists/1/state/over
                if integer? over [do-style lists 'on-color-cell reduce [over off]]
                words: copy []
                foreach list lists [append words auto-complete/index list/facets/contents face/state/query]
                remove-each word words [none? get word]
                t: last words
                unless any [none? t equal? t over] [
                    do-style lists 'on-color-cell reduce [t on]
                    draw-face face
                ]
            ]
        ]
    ]
]
extract-columns: funct [
    "Rearange 2D block from rows to columns"
    block
] [
    columns: 0
    foreach l block [if columns < length? l [columns: length? l]]
    out: make block! columns
    loop columns [append/only out make block! length? block]
    foreach row block [
        out: head out
        column: make block! columns
        if columns > length? row [
            append row: copy row array/initial columns - length? row none
        ]
        foreach col row [
            append out/1 col
            out: next out
        ]
    ]
    head out
]
stylize [
    table-cell: tight [
        tags: [internal]
        facets: [
            size: 100x20
            max-size: 10000x10000
            min-size: 1x1
            area-color: off
            border-color: off
        ]
        options: [
            size: [pair!]
            content: [block!]
            area-color: [tuple!]
            border-color: [tuple!]
        ]
        actors: [
            on-make: [
                make-panel2 face
                size: get-facet face 'size
                resize-panel face size
            ]
            on-init: []
            on-resize: []
        ]
        draw: [
            line-width 1
            pen 96.96.96
            fill-pen 206.211.220
            box 0x0 (size - 1)
        ]
    ]
    table-row: tight [
        tags: [internal]
        facets: [
            size: 400x20
            max-size: 10000x10000
            min-size: 1x1
            area-color: off
            border-color: off
        ]
        options: [
            size: [pair!]
            content: [block!]
            area-color: [tuple!]
            border-color: [tuple!]
        ]
        actors: [
            on-make: [
                make-panel2 face
            ]
            on-resize: [
                resize-panel face arg
            ]
        ]
        draw: []
    ]
    table-header: tight [
        tags: [internal]
        facets: [
            size: 10x10
            max-size: 1x1
            min-size: 1x1
            margin: 2x1
            trim-size: false
            area-color: off
            border-color: off
        ]
        options: [
            size: [pair!]
            content: [block!]
            area-color: [tuple!]
            border-color: [tuple!]
        ]
        actors: [
            on-make: [
                make-panel2 face
            ]
            on-resize: []
        ]
        draw: [
            line-width 1
            pen border-color
            fill-pen area-color
            box 0x0 (size - 1)
        ]
    ]
    table-panel: hpanel [
        tags: [internal]
        facets: [
            size: 100x100
            max-size: 10000x10000
            min-size: 1x1
            margin: 1x1
            spacer: 0x0
            break-after: 1
            area-color: off
            border-color: black
            pfacets: none
        ]
        options: [
            size: [pair!]
            border-color: [tuple!]
            area-color: [tuple!]
            content: [block! object!]
        ]
        actors: [
            on-make: [
                set-facet face 'break-after 1
                make-panel2 face
            ]
            on-init: [
                margin: 2 * get-facet face 'margin
                f: first faces? face
                resize-panel face size: f/facets/size + margin
                set-facet face 'min-size size
            ]
            on-resize: []
        ]
        draw: [
            line-width 1
            pen border-color
            fill-pen area-color
            box 0x0 (size - 1)
        ]
    ]
    table-viewport: hpanel [
        tags: [internal]
        facets: [
            size: 100x100
            min-size: 1x1
            max-size: 10000x10000
            margin: 1x1
            spacer: 0x0
            trim-size: false
            area-color: off
            border-color: white
        ]
        options: [
            size: [pair!]
            border-color: [tuple!]
            area-color: [tuple!]
            content: [block!]
        ]
        actors: [
            on-make: [
                set-facet face 'break-after 1
                make-panel2 face
            ]
            on-resize: [
                resize-panel face arg
                set-face face face/state/value
            ]
            on-attach: [
                extend-face face 'attached arg
                set-face face face/state/value
            ]
            on-scroll: [
                pf: parent-face? face
                face: first faces? face
                gob: face/gob
                pgob: face/gob/parent
                size: negate max 0x0 gob/size - pgob/size + 2
                offset: min 0x1 (size * get-face arg) + 1
                axis: face-axis? arg
                xy: gob/offset
                xy/:axis: offset/:axis
                gob/offset: xy
                show-later face
                if hf: pf/names/th [
                    hf/gob/offset/x: xy/x
                    show-later hf
                ]
                true
            ]
        ]
        draw: [
            pen border-color
            fill-pen area-color
            box 0x0 (size - 1)
        ]
    ]
    table: tight [
        tags: [compound]
        facets: [
            size: 100x100
            min-size: 1x1
            max-size: 10000x10000
            margin: 1x1
            border-color: black
            area-color: gray
            names: true
        ]
        options: [
            row-layout: [block!]
            data: [block!]
            border-color: [tuple!]
            area-color: [tuple!]
            size: [pair!]
        ]
        actors: [
            on-make: [
                init-size: get-facet face 'size
                set-facet face 'break-after 2
                f: face/facets
                lay: copy/deep [
                    tp: table-panel []
                ]
                row-face: none
                foreach row f/data [
                    append last lay copy/deep [
                        table-row orange []
                    ]
                    idx: 0
                    foreach col-data row [
                        col-spec: pick f/row-layout idx: idx + 2
                        if opts: find col-spec 'options [
                            col-spec: copy/part col-spec opts
                        ]
                        if word? col-data [col-data: get col-data]
                        append last last lay compose/deep [
                            table-cell sky blue [(col-spec) (col-data) (any [all [opts copy/part opts 2] []])]
                        ]
                    ]
                    unless row-face [
                        row-face: make-panel 'table-row last last lay none
                    ]
                ]
                p: row-face/gob/pane
                header: copy []
                idx: 1
                foreach g p [
                    append header compose/deep [
                        table-cell [
                            button (as-pair g/size/x 25) (pick f/row-layout idx)
                        ]
                    ]
                    idx: idx + 2
                ]
                extend face/options 'content compose/deep [
                    th: table-header [(header)]
                    pad options [min-size: 0x0 size: 0x0 max-size: 0x0]
                    tv: table-viewport [(lay)]
                    scroller
                    scroller
                ]
                make-panel2 face
                resize-panel face init-size
            ]
            on-init: []
            on-resize: [
                if in face 'names [
                    max-size: get-facet face/names/tp 'size
                    hsize: as-pair max-size/x 25
                    set-facet face/names/th 'max-size hsize
                    resize-panel face/names/th hsize
                    set-facet face 'max-size max-size + 24
                ]
                resize-panel face arg
            ]
        ]
        draw: [
            pen border-color
            fill-pen area-color
            box 0x0 (size - 1)
        ]
    ]
]
log-t: now/time/precise
log: func [data /local t] [
    data: rejoin append copy [] data
    log-t: t
]
stylize [
    button-bar: [
        about: "Simple button bar."
        facets: [
            init-size: 400x28
            min-size: 200x28
            max-size: 2000x28
            spacing: 5x0
            buttons: make map! 10
            button-style: 'tab-button
            names: context []
        ]
        tags: [compound internal]
        options: [
            init-size: [pair!]
            layout: [issue!]
            data-block: [block!]
        ]
        state: [
            items: copy []
            active: #[none]
        ]
        debug-draw: [
            pen red
            line-width 2
            box 1x1 viewport-box/bottom-right
        ]
        actors: [
            on-init: [
                make-panel face 'panel
                face/facets/names: context copy []
            ]
            on-set: [
                log ["BARon-set" arg]
                switch type?/word arg/2 [
                    word! [
                        face/state/active: arg/2
                        button: get bind arg/2 face/names
                        do-related button 'on-mutex
                        set-face button arg/2
                    ]
                    map! [
                        face/state/items: to block! arg/2
                        d: do-style face 'on-parse-data face/state/items
                        set-panel-content/no-show face d
                    ]
                    block! []
                ]
                log "===end of on-set"
            ]
            on-resize: [
                do-style/style face 'on-resize arg 'hpanel
            ]
            on-update: [
                do-style/style face 'on-update arg 'hpanel
            ]
            on-content: [
                do-style/style face 'on-content arg 'hpanel
            ]
            DISABLED-on-drag-over: [
                drag: arg/1
                drag-offset: drag/gob/offset - get-gob-offset face/gob
                all [
                    not empty? face/gob/pane
                    pos: drag-offset/x / button-width: (face/gob/pane/1/size/x + face/facets/spacing/x)
                    button-id: to integer! round pos
                    gob: face/gob/pane/:button-id
                    left-boundary: button-id - 1 * button-width
                    gob/offset/x: max left-boundary button-id * button-width - drag-offset/x * 2 + left-boundary
                    show gob/parent
                ]
                true
            ]
            DISABLED-on-drop: [
                drag: arg/face
                items: to block! face/state/items
                id: get-facet drag 'id
                pos: (to integer! arg/event/offset/x / arg/gob/size/x) * 2 + 1
                pos-id: items/:pos
                either all [drag: find items id drop: find items pos-id] [
                    swap next drag next drop
                    swap drag drop
                    set-face face to map! items
                    show-later window-face? face
                    true
                ] [false]
            ]
            on-visible-count: [
                but: make-face get-facet face 'button-style []
                cur-size: max 0 face/facets/viewport-box/bottom-right/x - 45
                to integer! cur-size / (face/facets/spacing/x + but/facets/min-size/x)
            ]
            on-show-button: [
                count: do-style face 'on-visible-count none
                pos: either pos: find arg face/state/active [(1 + index? pos) / 2] [0]
                if pos > count [arg: skip arg pos - count * 2]
                arg
            ]
            on-make-button: [
                either none? arg/1 [[]] [
                    compose/deep [(to set-word! arg/1) (get-facet face 'button-style) (arg/2) (arg/3) (get-facet face 'layout)]
                ]
            ]
            on-parse-data: [
                log "BARon-parse-data"
                out: copy []
                parse arg [
                    some [(t: none)
                        opt set t word!
                        set s string! (
                            unless none? t [
                                append out do-style face 'on-make-button reduce [:t s equal? :t face/state/active]
                                append face/facets/names :t
                            ]
                        )
                    ]
                ]
                if find [#left #right] get-facet face 'layout [
                    set-facet face 'layout-mode 'horizontal
                ]
                face/state/items: arg
                log "===end of parse-data"
                out
            ]
            on-arrow: [
                face/state/items: skip face/state/items arg * 2
                d: do-style face 'on-parse-data face/state/items
                unless none? d [set-panel-content face d]
            ]
            on-fix-positions: [
                print "on-fix-positions"
            ]
        ]
    ]
    tab-box: hpanel [
        about: "Multi sub-panel."
        tags: [panel tab compound]
        facets: [
            init-size: 600x360
            max-size: 4000x3000
            min-size: 400x200
            border-size: [0x0 0x0]
            border-color: 200.200.200
            bg-color: none
            spacing: 0x0
            margin: [0x0 0x0]
            layout-mode: 'horizontal
            names: true
            pen-color: 0.0.0
            tabs: make map! []
            panels: make map! []
            previews: make map! []
            placement: #top
            break-after: 1
        ]
        options: [
            init-size: [pair!]
            data: [block!]
            placement: [issue!]
        ]
        state: [
            active: #[none]
            tab-offset: 0
            shown-tabs: 0
        ]
        actors: [
            on-make: [
                make-panel face 'panel
            ]
            on-init: [
                set-facet face 'tabs make map! []
                set-facet face 'panels make map! []
                do-style face 'on-layout-face get-facet face 'placement
            ]
            on-layout-face: [
                set-facet face 'placement either none? arg [#top] [arg]
                layout: switch face/facets/placement [
                    #top [
                        set-facet face 'break-after 1 [
                            tab-bar: button-bar [""] #top do [do-style compound-face? face 'on-show-tab get-facet face 'id]
                            tab-box: vtight []
                        ]
                    ]
                    #bottom [
                        set-facet face 'break-after 1 [
                            tab-box: vtight []
                            tab-bar: button-bar [""] #bottom do [do-style compound-face? face 'on-show-tab get-facet face 'id]
                        ]
                    ]
                    #left [
                        set-facet face 'break-after 2 [
                            tab-bar: button-bar [""] #left do [do-style compound-face? face 'on-show-tab get-facet face 'id]
                            tab-box: vtight []
                        ]
                    ]
                    #right [
                        set-facet face 'break-after 2 [
                            tab-box: vtight []
                            tab-bar: button-bar [""] #right do [do-style compound-face? face 'on-show-tab get-facet face 'id]
                        ]
                    ]
                ]
                set-panel-content/no-show face layout
                do-style face 'on-parse-data get-facet face 'data
                tab-box: face/names/tab-box
                repeat i length? tab-box/gob [
                    show-face/no-show tab-box/gob/:i/data 'ignore
                ]
                do-style face 'on-show-tab first words-of face/facets/tabs
            ]
            on-parse-data: [
                tabs: get-facet face 'tabs
                parse arg [
                    some [(id: nm: pn: none)
                        opt set id word! set nm string! set pn block! (
                            if none? id [id: to word! join "tab-" issue-id tabs]
                            do-style face 'on-add-tab reduce [id nm pn]
                        )
                    ]
                ]
            ]
            on-add-tab: [
                get-facet face [previews: tabs: panels:]
                unless word? arg/1 [insert head arg to word! join "tab-" issue-id words-of tabs]
                tabs/(arg/1): arg/2
                panels/(arg/1): arg/3
                set-face tab-bar tabs
            ]
            on-remove-tab: [
                do-style face 'on-add-tab reduce [arg none none]
            ]
            on-show-tab: [
                get-facet face [panels: tabs:]
                if act: face/state/active [
                    show-face/no-show tab-box/names/:act 'ignore
                ]
                panel: panels/:arg
                if block? panel [
                    panel: make-face 'hpanel [content: panel init-size: 1x1 break-after: 1 name: to word! arg]
                    extend panel 'name to word! arg
                    append-panel-content tab-box panel
                    update-subgobs panel/gob
                    panels/:arg: panel
                ]
                face/state/active: arg
                focus face
                show-face tab-box/names/(to word! arg) 'visible
                set-face tab-bar arg
            ]
            on-set: [
                log ["BOXon-set" arg]
                value: arg/2
                tabs: get-facet face 'tabs
                switch type?/word value [
                    integer! [
                        tab: pick words-of tabs value
                        do-style face 'on-show-tab tab
                    ]
                    word! [
                        do-style face 'on-show-tab value
                    ]
                    block! [
                        either parse value [some tag!] [
                            out: copy []
                            forall value [repend out [value/1 tabs/(value/1)]]
                            set-face tab-bar out
                        ] []
                    ]
                ]
                log "---on-set"
            ]
            on-get: [
                {Return block of two map!s - [tab-names panel-faces]}
                get-facet face [tabs: panels:]
                reduce [tabs panels]
            ]
            on-focus: [
                set-facet face 'bg-color either arg [red] [255.255.255.255]
                draw-face face
            ]
            on-key: [
                tabs: find words-of face/facets/tabs face/state/active
                if 'key-up = arg/type [
                    switch/default arg/key [
                        left [set-face face first back tabs]
                        right [if 1 <= length? next tabs [set-face face first next tabs]]
                    ] [print "other key"]
                ]
            ]
        ]
    ]
]
system/view/event-port: none
init-view-system